/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;

import javax.swing.table.AbstractTableModel;
import java.util.Vector;

/**
 * Gestisce la finestra di dialogo contenente le informazioni relative alle varie connessioni attive
 */
class ActiveConnectionUploadDownloadInfoDialog extends JDialog {
    BorderLayout layoutActiveConUpDownInfo = new BorderLayout();
    TitledBorder titledBorderInfo;
    JPanel panelInfo = new JPanel();
    BorderLayout layoutPanelInfo = new BorderLayout();
    JScrollPane scrollPaneInfo = new JScrollPane();
	InfoTableModel tableModelInfo=null;
    JTable tableInfo =null;
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JPanel panelButtonBar = new JPanel();
    JLabel empty2 = new JLabel();
    JLabel empty1 = new JLabel();
    GridLayout layoutButtonBarContainer = new GridLayout();
    JButton buttonOK = new JButton();
    JPanel panelButtonBarContainer = new JPanel();
    BorderLayout layoutButtonBar = new BorderLayout();
    JLabel empty3 = new JLabel();

    public ActiveConnectionUploadDownloadInfoDialog(PolitellaFrame parentFrame, String title,Vector info) {
        super(parentFrame, title);
        try {
			if(title.compareTo("Active Connections")==0)    {
				//visualizzo informazioni relative alle connessioni attive
				String[] columnNames={"Peer","Shared Projects"};
				tableModelInfo=new InfoTableModel(columnNames);
			}
			else    {
				// visualizzo informazioni relative a upload o download in corso
				String[] columnNames={"Peer","Resource"};
				tableModelInfo=new InfoTableModel(columnNames);
			}

			this.tableInfo = new JTable(tableModelInfo);
		    this.tableModelInfo.setRowsValue(info);

            jbInit();
            pack();

	        //Center the window
		    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	        Dimension frameSize = this.getSize();
            if (frameSize.height > screenSize.height) {
                frameSize.height = screenSize.height;
	        }
			if (frameSize.width > screenSize.width) {
                frameSize.width = screenSize.width;
            }
            this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
            this.setVisible(true);
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {
        panelButtonBarContainer.setLayout(layoutButtonBarContainer);
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonOK_actionPerformed(e);
            }
        });
        buttonOK.setText("OK");
        layoutButtonBarContainer.setColumns(3);
        titledBorderInfo = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Info");
        this.setResizable(false);
        this.setModal(true);
        layoutActiveConUpDownInfo.setHgap(10);
        layoutActiveConUpDownInfo.setVgap(10);
        this.getContentPane().setLayout(layoutActiveConUpDownInfo);
        panelInfo.setBorder(titledBorderInfo);
        panelInfo.setPreferredSize(new Dimension(466, 200));
        panelInfo.setLayout(layoutPanelInfo);
        layoutPanelInfo.setHgap(10);
        layoutPanelInfo.setVgap(10);
        scrollPaneInfo.setAutoscrolls(true);
        scrollPaneInfo.setBorder(BorderFactory.createLoweredBevelBorder());
        scrollPaneInfo.setDoubleBuffered(true);
        scrollPaneInfo.setPreferredSize(new Dimension(454, 200));
        tableInfo.setAutoResizeMode(JTable.AUTO_RESIZE_NEXT_COLUMN);
        tableInfo.setRowSelectionAllowed(false);
        panelButtonBar.setLayout(layoutButtonBar);
        layoutButtonBar.setHgap(10);
        layoutButtonBar.setVgap(10);
        this.getContentPane().add(panelInfo, BorderLayout.CENTER);
        panelInfo.add(scrollPaneInfo, BorderLayout.CENTER);
        this.getContentPane().add(jLabel1, BorderLayout.WEST);
        this.getContentPane().add(jLabel2, BorderLayout.EAST);
        this.getContentPane().add(panelButtonBar, BorderLayout.SOUTH);
        panelButtonBar.add(panelButtonBarContainer, BorderLayout.CENTER);
        panelButtonBarContainer.add(empty1, null);
        panelButtonBarContainer.add(buttonOK, null);
        panelButtonBarContainer.add(empty2, null);
        panelButtonBar.add(empty3, BorderLayout.SOUTH);
        scrollPaneInfo.getViewport().add(tableInfo, null);
    }

	private class InfoTableModel extends AbstractTableModel  {
		private Vector rowsData= new Vector();
		private String[] columnNames;

		public InfoTableModel(String[] columnNames) {
			this.columnNames=columnNames;
		}
		public int getRowCount()    {
			return this.rowsData.size();
		}
		public int getColumnCount() {
			return this.columnNames.length;
		}
        public String getColumnName(int col) {
            return columnNames[col];
        }
		public Object getValueAt(int row, int column)   {
			return ((Vector)this.rowsData.elementAt(row)).elementAt(column);
		}
		protected void setRowsValue(Vector rowsData)  {
		    this.rowsData.removeAllElements();
			this.rowsData=rowsData;
			this.fireTableDataChanged();
		}
	}

    void buttonOK_actionPerformed(ActionEvent e) {
		this.setVisible(false);
		this.dispose();
    }
}