/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import Utility.ProjectType;
import Utility.BusinessModelComponent;

import java.io.File;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 * Gestisce la finestra di dialogo per l'editing dei componenti del business model con relative risorse
 */
class AddEditBusinessModelComponentDialog extends JDialog {
    JPanel panelAddEditBusModCompButtonBar = new JPanel();
    BorderLayout layoutAddEditBusModCompRoot = new BorderLayout();
    JLabel empty5 = new JLabel();
    JLabel empty4 = new JLabel();
    BorderLayout layoutAddEditBusModCompButtonBar = new BorderLayout();
    JPanel panelAddEditBusModCompButtonBarContainer = new JPanel();
    JButton buttonAdd_Update = new JButton();
    JButton buttonRemove = new JButton();
    JButton buttonCancel = new JButton();
    GridLayout layoutAddEditBusModCompButtonBarContainer = new GridLayout();
    JLabel empty6 = new JLabel();
    JPanel panelAddEditBusModCompDescriptionContainer = new JPanel();
    JPanel panelAddEditBusModCompResources = new JPanel();
    JLabel labelDescription = new JLabel();
    BorderLayout layoutAddEditBusModCompDescription = new BorderLayout();
    JLabel empty7 = new JLabel();
    JPanel panelAddEditBusModCompDescription = new JPanel();
    JTabbedPane tabbedPaneResLocations = new JTabbedPane();
    BorderLayout layoutEditBusModCompDescriptionContainer = new BorderLayout();
    JScrollPane scrollPaneDescription = new JScrollPane();
    BorderLayout layoutAddEditBusModCompResources = new BorderLayout();
    JTextPane textPaneDescription = new JTextPane();
    JLabel empty8 = new JLabel();
    JLabel empty3 = new JLabel();
    JPanel panelDocBinSourceLocationContainer = new JPanel();
    JButton buttonAddDocLocation = new JButton();
    JPanel panelDocLocationContainer = new JPanel();
    GridLayout layoutDocLocationContainer = new GridLayout();
    BorderLayout layoutDocLocation = new BorderLayout();
    JPanel panelDocLocation = new JPanel();
    JLabel labelDocLocation = new JLabel();
    GridLayout layoutDocBinSourceLocationContainer = new GridLayout();
    JButton buttonAddBinaryLocation = new JButton();
    JPanel panelBinaryLocationContainer = new JPanel();
    GridLayout layoutBinaryLocationContainer = new GridLayout();
    BorderLayout layoutBinaryLocation = new BorderLayout();
    JPanel panelBinaryLocation = new JPanel();
    JLabel labelBinaryLocation = new JLabel();
    JButton buttonAddSourceLocation = new JButton();
    JPanel panelSourceLocationContainer = new JPanel();
    GridLayout layoutSourceLocationContainer = new GridLayout();
    BorderLayout layoutSourceLocation = new BorderLayout();
    JPanel panelSourceLocation = new JPanel();
    JLabel labelSourceLocation = new JLabel();
    JButton buttonRemoveDocLocation = new JButton();
    JButton buttonRemoveBinaryLocation = new JButton();
    JButton buttonRemoveSourceLocation = new JButton();
    JComboBox comboBoxSourceLocation = new JComboBox();
    JComboBox comboBoxBinaryLocation = new JComboBox();
    JComboBox comboBoxDocLocation = new JComboBox();

    public AddEditBusinessModelComponentDialog(PolitellaFrame pFrame, boolean isAdding) {
        super(pFrame);

        try {
            jbInit();
			pack();
			this.comboBoxSourceLocation.setRenderer(new MyCellRenderer());
			this.comboBoxBinaryLocation.setRenderer(new MyCellRenderer());
			this.comboBoxDocLocation.setRenderer(new MyCellRenderer());
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }

		// carico nel JDialog le info, eventualmente gi disponibili, sul componente da editare

		BusinessModelComponent curr = pFrame.currentPrjViewing.busModCompManaging;

		String textInfo=curr.GetBusModCompDescription();
		if(textInfo!=null)
		    this.textPaneDescription.setText(textInfo);

		String[] arrayOfTextInfo = null;

		if(curr.IsBusinessRole())   {
			if((arrayOfTextInfo=curr.GetBusModCompSourceLoc())!=null)   {
				for(int i=0;i<arrayOfTextInfo.length;i++)
					this.comboBoxSourceLocation.addItem(arrayOfTextInfo[i]);
				this.comboBoxSourceLocation.setEnabled(true);
			}
//			if(textInfo!=null)
//				this.textFieldSourceLocation.setText(textInfo);
//			this.textFieldSourceLocation.setCaretPosition(0);
		}
		else    {
//			this.textFieldSourceLocation.setEnabled(false);
			this.buttonAddSourceLocation.setEnabled(false);
		}

		if(curr.IsBusinessRole())   {
			if((arrayOfTextInfo=curr.GetBusModCompBinaryLoc())!=null)    {
				for(int i=0;i<arrayOfTextInfo.length;i++)
					this.comboBoxBinaryLocation.addItem(arrayOfTextInfo[i]);
				this.comboBoxBinaryLocation.setEnabled(true);
			}
//			if(textInfo!=null)
//				this.textFieldBinaryLocation.setText(textInfo);
//			this.textFieldBinaryLocation.setCaretPosition(0);
		}
		else    {
//			this.textFieldBinaryLocation.setEnabled(false);
			this.buttonAddBinaryLocation.setEnabled(false);
		}

		if((arrayOfTextInfo=curr.GetBusModCompDocLoc())!=null)   {
			for(int i=0;i<arrayOfTextInfo.length;i++)
				this.comboBoxDocLocation.addItem(arrayOfTextInfo[i]);
			this.comboBoxDocLocation.setEnabled(true);
		}
//		if(textInfo!=null)
//			this.textFieldDocLocation.setText(textInfo);
//		this.textFieldDocLocation.setCaretPosition(0);

		if(!curr.IsBusinessRole())   {
			// una bus rela, non ha altre risorse proprie associate
			this.panelAddEditBusModCompResources.remove(this.tabbedPaneResLocations);
		}
		else    {
			// un bus mod, ha delle proprie risorse associate
			short[] busModCompIDLinks=curr.GetBusModCompIDLinks();
			for(int i=0;i<busModCompIDLinks.length;i++) {
				this.tabbedPaneResLocations.add(new AddEditBusinessModelComponentResourcesPanel(curr,busModCompIDLinks[i]));
				//il +2 serve perch nell'elenco delle descrizioni dei bus comp prima delle bus rela ci sono 2 campi Any...
				this.tabbedPaneResLocations.setTitleAt(this.tabbedPaneResLocations.getTabCount()-1,ProjectType.prjTypeDescription[2][busModCompIDLinks[i]+2]);
				this.tabbedPaneResLocations.setToolTipTextAt(this.tabbedPaneResLocations.getTabCount()-1,"Business Relationship " + ProjectType.prjTypeDescription[2][busModCompIDLinks[i]+2]);
			}
		}

		String compName = null;
		if(curr.GetBusModCompID()<ProjectType.numBusinessRole)
			compName = ProjectType.prjTypeDescription[2][curr.GetBusModCompID()+1];
		else
			compName = ProjectType.prjTypeDescription[2][curr.GetBusModCompID()+2];

		if(isAdding)    {
			this.setTitle("Add Component: " + compName);
			this.buttonAdd_Update.setText("Add");
		}
		else    {
			this.setTitle("Edit Component: " + compName);
			this.buttonAdd_Update.setText("Update");
			this.buttonRemove.setEnabled(true);
		}


		this.pack();

        //Center the window
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
           if (frameSize.height > screenSize.height) {
               frameSize.height = screenSize.height;
        }
		if (frameSize.width > screenSize.width) {
               frameSize.width = screenSize.width;
           }
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        this.setVisible(true);
    }

    void jbInit() throws Exception {
        this.setDefaultCloseOperation(0);
        this.setResizable(false);
        this.setModal(true);
        this.setTitle("");
        this.getContentPane().setLayout(layoutAddEditBusModCompRoot);
        panelAddEditBusModCompButtonBar.setLayout(layoutAddEditBusModCompButtonBar);
        layoutAddEditBusModCompRoot.setHgap(10);
        layoutAddEditBusModCompRoot.setVgap(10);
        panelAddEditBusModCompButtonBar.setPreferredSize(new Dimension(450, 37));
        buttonAdd_Update.setToolTipText("");
        buttonAdd_Update.setText("Add or Update");
        buttonAdd_Update.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAdd_Update_actionPerformed(e);
            }
        });
        buttonRemove.setEnabled(false);
        buttonRemove.setToolTipText("");
        buttonRemove.setText("Remove");
        buttonRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemove_actionPerformed(e);
            }
        });
        buttonCancel.setToolTipText("");
        buttonCancel.setText("Cancel");
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonCancel_actionPerformed(e);
            }
        });
        panelAddEditBusModCompButtonBarContainer.setLayout(layoutAddEditBusModCompButtonBarContainer);
        layoutAddEditBusModCompButtonBarContainer.setColumns(3);
        layoutAddEditBusModCompButtonBarContainer.setHgap(10);
        layoutAddEditBusModCompButtonBar.setHgap(10);
        layoutAddEditBusModCompButtonBar.setVgap(10);
        panelAddEditBusModCompDescriptionContainer.setLayout(layoutEditBusModCompDescriptionContainer);
        panelAddEditBusModCompResources.setLayout(layoutAddEditBusModCompResources);
        labelDescription.setAlignmentX((float) 0.5);
        labelDescription.setText("Description");
        layoutAddEditBusModCompDescription.setHgap(10);
        layoutAddEditBusModCompDescription.setVgap(10);
        panelAddEditBusModCompDescription.setLayout(layoutAddEditBusModCompDescription);
        panelAddEditBusModCompDescription.setPreferredSize(new Dimension(450, 60));
        layoutEditBusModCompDescriptionContainer.setHgap(20);
        scrollPaneDescription.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        scrollPaneDescription.setBorder(BorderFactory.createLoweredBevelBorder());
        textPaneDescription.setSelectionColor(new Color(10, 36, 106));
        layoutAddEditBusModCompResources.setHgap(10);
        layoutAddEditBusModCompResources.setVgap(10);
        buttonAddDocLocation.setIcon(new ImageIcon("Interfaccia/Icons/OpenSmall.gif"));
        buttonAddDocLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonAddDocLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAddDocLocation_actionPerformed(e);
            }
        });
        buttonAddDocLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonAddDocLocation.setNextFocusableComponent(buttonAdd_Update);
        buttonAddDocLocation.setPreferredSize(new Dimension(22, 20));
        buttonAddDocLocation.setFocusPainted(false);
        panelDocLocationContainer.setLayout(layoutDocLocationContainer);
        panelDocLocationContainer.setMinimumSize(new Dimension(161, 23));
        panelDocLocationContainer.setPreferredSize(new Dimension(161, 23));
        panelDocLocation.setLayout(layoutDocLocation);
        panelDocLocation.setMinimumSize(new Dimension(26, 22));
        panelDocLocation.setPreferredSize(new Dimension(26, 22));
        labelDocLocation.setText("Doc. Files Location          ");
        panelDocBinSourceLocationContainer.setLayout(layoutDocBinSourceLocationContainer);
        layoutDocBinSourceLocationContainer.setRows(3);
        layoutDocBinSourceLocationContainer.setColumns(1);
        layoutDocBinSourceLocationContainer.setHgap(10);
        layoutDocBinSourceLocationContainer.setVgap(10);
        buttonAddBinaryLocation.setFocusPainted(false);
        buttonAddBinaryLocation.setPreferredSize(new Dimension(22, 20));
        buttonAddBinaryLocation.setNextFocusableComponent(buttonAdd_Update);
        buttonAddBinaryLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonAddBinaryLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAddBinaryLocation_actionPerformed(e);
            }
        });
        buttonAddBinaryLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonAddBinaryLocation.setIcon(new ImageIcon("Interfaccia/Icons/OpenSmall.gif"));
        panelBinaryLocationContainer.setPreferredSize(new Dimension(161, 23));
        panelBinaryLocationContainer.setMinimumSize(new Dimension(161, 23));
        panelBinaryLocationContainer.setLayout(layoutBinaryLocationContainer);
        panelBinaryLocation.setLayout(layoutBinaryLocation);
        panelBinaryLocation.setMinimumSize(new Dimension(26, 22));
        panelBinaryLocation.setPreferredSize(new Dimension(26, 22));
        labelBinaryLocation.setText("Binary Files Location          ");
        buttonAddSourceLocation.setFocusPainted(false);
        buttonAddSourceLocation.setPreferredSize(new Dimension(22, 20));
        buttonAddSourceLocation.setNextFocusableComponent(buttonAdd_Update);
        buttonAddSourceLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonAddSourceLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAddSourceLocation_actionPerformed(e);
            }
        });
        buttonAddSourceLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonAddSourceLocation.setIcon(new ImageIcon("Interfaccia/Icons/OpenSmall.gif"));
        panelSourceLocationContainer.setPreferredSize(new Dimension(161, 23));
        panelSourceLocationContainer.setMinimumSize(new Dimension(161, 23));
        panelSourceLocationContainer.setLayout(layoutSourceLocationContainer);
        panelSourceLocation.setLayout(layoutSourceLocation);
        panelSourceLocation.setMinimumSize(new Dimension(26, 22));
        panelSourceLocation.setPreferredSize(new Dimension(26, 22));
        labelSourceLocation.setText("Source Files Location          ");
        buttonRemoveDocLocation.setEnabled(false);
        buttonRemoveDocLocation.setPreferredSize(new Dimension(22, 20));
        buttonRemoveDocLocation.setToolTipText("Click it to remove selected file");
        buttonRemoveDocLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonRemoveDocLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonRemoveDocLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemoveDocLocation_actionPerformed(e);
            }
        });
        buttonRemoveDocLocation.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        buttonRemoveBinaryLocation.setEnabled(false);
        buttonRemoveBinaryLocation.setPreferredSize(new Dimension(22, 20));
        buttonRemoveBinaryLocation.setToolTipText("Click it to remove selected file");
        buttonRemoveBinaryLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonRemoveBinaryLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonRemoveBinaryLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemoveBinaryLocation_actionPerformed(e);
            }
        });
        buttonRemoveBinaryLocation.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        buttonRemoveSourceLocation.setEnabled(false);
        buttonRemoveSourceLocation.setPreferredSize(new Dimension(22, 20));
        buttonRemoveSourceLocation.setToolTipText("Click it to remove selected file");
        buttonRemoveSourceLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonRemoveSourceLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonRemoveSourceLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemoveSourceLocation_actionPerformed(e);
            }
        });
        buttonRemoveSourceLocation.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        comboBoxSourceLocation.setEnabled(false);
        comboBoxSourceLocation.setNextFocusableComponent(buttonAddSourceLocation);
        comboBoxSourceLocation.setMaximumRowCount(5);
        comboBoxSourceLocation.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                comboBoxSourceLocation_itemStateChanged(e);
            }
        });
        comboBoxBinaryLocation.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                comboBoxBinaryLocation_itemStateChanged(e);
            }
        });
        comboBoxBinaryLocation.setMaximumRowCount(5);
        comboBoxBinaryLocation.setNextFocusableComponent(buttonAddSourceLocation);
        comboBoxBinaryLocation.setEnabled(false);
        comboBoxDocLocation.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                comboBoxDocLocation_itemStateChanged(e);
            }
        });
        comboBoxDocLocation.setMaximumRowCount(5);
        comboBoxDocLocation.setNextFocusableComponent(buttonAddSourceLocation);
        comboBoxDocLocation.setEnabled(false);
        this.getContentPane().add(panelAddEditBusModCompButtonBar, BorderLayout.SOUTH);
        panelAddEditBusModCompButtonBar.add(empty4, BorderLayout.WEST);
        panelAddEditBusModCompButtonBar.add(empty5, BorderLayout.EAST);
        panelAddEditBusModCompButtonBar.add(panelAddEditBusModCompButtonBarContainer, BorderLayout.CENTER);
        panelAddEditBusModCompButtonBarContainer.add(buttonAdd_Update, null);
        panelAddEditBusModCompButtonBarContainer.add(buttonRemove, null);
        panelAddEditBusModCompButtonBarContainer.add(buttonCancel, null);
        panelAddEditBusModCompButtonBar.add(empty6, BorderLayout.SOUTH);
        this.getContentPane().add(panelAddEditBusModCompResources, BorderLayout.CENTER);
        panelAddEditBusModCompResources.add(panelAddEditBusModCompDescription, BorderLayout.NORTH);
        panelAddEditBusModCompDescription.add(panelAddEditBusModCompDescriptionContainer, BorderLayout.CENTER);
        panelAddEditBusModCompDescriptionContainer.add(labelDescription, BorderLayout.WEST);
        panelAddEditBusModCompDescriptionContainer.add(scrollPaneDescription, BorderLayout.CENTER);
        panelAddEditBusModCompDescription.add(empty7, BorderLayout.NORTH);
        panelAddEditBusModCompResources.add(tabbedPaneResLocations, BorderLayout.SOUTH);
        panelAddEditBusModCompResources.add(panelDocBinSourceLocationContainer, BorderLayout.CENTER);
        panelDocBinSourceLocationContainer.add(panelSourceLocationContainer, null);
        panelSourceLocationContainer.add(labelSourceLocation, null);
        panelSourceLocationContainer.add(panelSourceLocation, null);
        panelSourceLocation.add(buttonAddSourceLocation, BorderLayout.EAST);
        panelSourceLocation.add(buttonRemoveSourceLocation, BorderLayout.WEST);
        panelSourceLocation.add(comboBoxSourceLocation, BorderLayout.CENTER);
        panelDocBinSourceLocationContainer.add(panelBinaryLocationContainer, null);
        panelBinaryLocationContainer.add(labelBinaryLocation, null);
        panelBinaryLocationContainer.add(panelBinaryLocation, null);
        panelBinaryLocation.add(buttonAddBinaryLocation, BorderLayout.EAST);
        panelBinaryLocation.add(buttonRemoveBinaryLocation, BorderLayout.WEST);
        panelBinaryLocation.add(comboBoxBinaryLocation, BorderLayout.CENTER);
        panelDocBinSourceLocationContainer.add(panelDocLocationContainer, null);
        panelDocLocationContainer.add(labelDocLocation, null);
        panelDocLocationContainer.add(panelDocLocation, null);
        panelDocLocation.add(buttonAddDocLocation, BorderLayout.EAST);
        panelDocLocation.add(buttonRemoveDocLocation, BorderLayout.WEST);
        panelDocLocation.add(comboBoxDocLocation, BorderLayout.CENTER);
        this.getContentPane().add(empty8, BorderLayout.WEST);
        this.getContentPane().add(empty3, BorderLayout.EAST);
        scrollPaneDescription.getViewport().add(textPaneDescription, null);
    }

    void buttonCancel_actionPerformed(ActionEvent e) {
		//ho terminato l'editing del componente annullando tutto ci che ho fatto
		//ripristino le condizioni iniziali dell'identificatore del componente editato
		((PolitellaFrame)this.getParent()).currentPrjViewing.busModCompManaging=null;
		this.dispose();
    }

    void buttonAdd_Update_actionPerformed(ActionEvent e) {
		//ripristino le condizioni iniziali dell'identificatore del componente editato
		PolitellaFrame pFrame = (PolitellaFrame)this.getParent();

		String textInfo = null;

		textInfo=this.textPaneDescription.getText().replace('\n',' ').replace('\r',' ').trim();
		if(textInfo.compareTo("")==0)
			textInfo=null;
	    pFrame.currentPrjViewing.busModCompManaging.SetBusModCompDecription(textInfo);

/*		textInfo=this.textFieldSourceLocation.getText();
		if(textInfo.compareTo("")!=0)   {
			if(!(new File(textInfo)).exists())  {
			//il file non esiste, deve specifcarne un altro
				JOptionPane.showMessageDialog(this,"The source file you have specified doesn't exist.\nCheck it","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
				this.textFieldSourceLocation.setText(null);
				return;
			}
		}
		else
			textInfo=null;*/

		pFrame.currentPrjViewing.busModCompManaging.SetBusModCompSourceLoc(this.GetComboBoxItems(this.comboBoxSourceLocation));
//		pFrame.currentPrjViewing.busModCompManaging.SetBusModCompSourceLoc(textInfo);

/*		textInfo=this.textFieldBinaryLocation.getText();
		if(textInfo.compareTo("")!=0)   {
			if(!(new File(textInfo)).exists())  {
			//il file non esiste, deve specifcarne un altro
				JOptionPane.showMessageDialog(this,"The binary file you have specified doesn't exist.\nCheck it","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
				this.textFieldBinaryLocation.setText(null);
				return;
			}
		}
		else
			textInfo=null;*/
		pFrame.currentPrjViewing.busModCompManaging.SetBusModCompBinaryLoc(this.GetComboBoxItems(this.comboBoxBinaryLocation));
//		pFrame.currentPrjViewing.busModCompManaging.SetBusModCompBinaryLoc(textInfo);

/*		textInfo=this.textFieldDocLocation.getText();
		if(textInfo.compareTo("")!=0)   {
			if(!(new File(textInfo)).exists())  {
			//il file non esiste, deve specifcarne un altro
				JOptionPane.showMessageDialog(this,"The documentation file you have specified doesn't exist.\nCheck it","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
				this.textFieldDocLocation.setText(null);
				return;
			}
		}
		else
			textInfo=null;*/
		pFrame.currentPrjViewing.busModCompManaging.SetBusModCompDocLoc(this.GetComboBoxItems(this.comboBoxDocLocation));
//		pFrame.currentPrjViewing.busModCompManaging.SetBusModCompDocLoc(textInfo);

		for(int i=this.tabbedPaneResLocations.getTabCount();i>0;i--)    {
		    if(!((AddEditBusinessModelComponentResourcesPanel)this.tabbedPaneResLocations.getComponentAt(i-1)).AddUpdateThisResources())    {
			//c' stato qualche problema, andiamo a vedere
				this.tabbedPaneResLocations.setSelectedIndex(i-1);
				return;
		    }
		}

		pFrame.currentPrjViewing.busModCompManaging.SetIsActive(true);

		pFrame.currentPrjViewing.busModCompManaging=null;

		pFrame.currentPrjViewing.repaint();

		this.dispose();
    }

    void buttonRemove_actionPerformed(ActionEvent e) {
		//ripristino le condizioni iniziali dell'identificatore del componente editato
		PolitellaFrame pFrame = (PolitellaFrame)this.getParent();

		if(pFrame.currentPrjViewing.busModCompManaging.IsSelected())
			pFrame.currentPrjViewing.ReLoadInfoTree(null);

		pFrame.currentPrjViewing.busModCompManaging.ResetAll();

		pFrame.currentPrjViewing.busModCompManaging=null;

		pFrame.currentPrjViewing.repaint();

		this.dispose();
    }

	/**
	 * Gestisce la scelta di 1 risorsa e ctrl che tale risorsa esista realmente
	 */
	private String SelectFile(String selectFileYet) {
		String selectPath=null;
//		if(selectFileYet.compareTo("")==0)
		if(selectFileYet==null)
			selectPath=System.getProperty("user.dir");
		else
			selectPath=selectFileYet;
		JFileChooser chooser = new JFileChooser(selectPath);
		if(selectFileYet!=null)
			chooser.setSelectedFile(new java.io.File(selectFileYet));
		chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		chooser.setMultiSelectionEnabled(false);
		chooser.setDialogTitle("Select File");

		while(true) {
			int retValue =chooser.showDialog(this,"Add");

			if(retValue==JFileChooser.APPROVE_OPTION)   {
				//ho scelto un file
				if(chooser.getSelectedFile().exists())  {
					String fileForComparing;
					if(selectFileYet==null)
						fileForComparing="";
					else
						fileForComparing=selectFileYet;
					if(chooser.getSelectedFile().getAbsolutePath().compareTo(fileForComparing)==0)
						//ho riselezionato lo stesso oppure non ho fatto nulla
						return null;
					else
						return chooser.getSelectedFile().getAbsolutePath();
				}
			}
			else
			//ho cliccato su annulla
//				return selectFileYet;
				return null;
		}
	}

    void buttonAddDocLocation_actionPerformed(ActionEvent e) {
		this.AddToComboBox(this.comboBoxDocLocation);
//		this.textFieldDocLocation.setText(this.SelectFile(this.textFieldDocLocation.getText()));
//		this.textFieldDocLocation.setCaretPosition(0);
    }

    void buttonAddBinaryLocation_actionPerformed(ActionEvent e) {
		this.AddToComboBox(this.comboBoxBinaryLocation);
//		this.textFieldBinaryLocation.setText(this.SelectFile(this.textFieldBinaryLocation.getText()));
//		this.textFieldBinaryLocation.setCaretPosition(0);
    }
    void buttonAddSourceLocation_actionPerformed(ActionEvent e) {
		this.AddToComboBox(this.comboBoxSourceLocation);
//		this.textFieldSourceLocation.setText(this.SelectFile(this.textFieldSourceLocation.getText()));
//		this.textFieldSourceLocation.setCaretPosition(0);
    }

    void comboBoxBinaryLocation_itemStateChanged(ItemEvent e) {
		this.ComboBox_itemStateChanged(e,this.buttonRemoveBinaryLocation);
    }
    void comboBoxDocLocation_itemStateChanged(ItemEvent e) {
		this.ComboBox_itemStateChanged(e,this.buttonRemoveDocLocation);
    }
    void buttonRemoveBinaryLocation_actionPerformed(ActionEvent e) {
		this.RemoveFromComboBox(this.comboBoxBinaryLocation);
    }
    void buttonRemoveDocLocation_actionPerformed(ActionEvent e) {
		this.RemoveFromComboBox(this.comboBoxDocLocation);
    }

    void buttonRemoveSourceLocation_actionPerformed(ActionEvent e) {
		this.RemoveFromComboBox(this.comboBoxSourceLocation);
    }

    void comboBoxSourceLocation_itemStateChanged(ItemEvent e) {
		this.ComboBox_itemStateChanged(e,this.buttonRemoveSourceLocation);
    }

	private String[] GetComboBoxItems(JComboBox combo) {
		String[] items=null;

		int numItems = combo.getItemCount();
		if(numItems!=0) {
			items = new String[numItems];
			for(int i=0; i<numItems;i++)
			    items[i]=(String)combo.getItemAt(i);
		}
		return items;
	}

	private void AddToComboBox(JComboBox combo)  {
		String newItem=this.SelectFile((String)combo.getSelectedItem());
		if(newItem!=null)   {
			combo.setEnabled(true);
			int i;
			for(i=0;i<combo.getItemCount();i++) {
				if(newItem.compareTo(combo.getItemAt(i))==0)
				//ho gi inserito quel file
					break;
			}
			if(i==combo.getItemCount())
				//non ho inserito ancora quel file
			    combo.addItem(newItem);
		}
	}

	private void RemoveFromComboBox(JComboBox combo)    {
		combo.removeItemAt(combo.getSelectedIndex());
		combo.setSelectedIndex(-1);
		if(combo.getItemCount()==0)
			combo.setEnabled(false);
	}

	private void ComboBox_itemStateChanged(ItemEvent e,JButton button) {
		switch(e.getStateChange())  {
			case ItemEvent.DESELECTED:  {
				button.setEnabled(false);
				break;
			}
			case ItemEvent.SELECTED:    {
				button.setEnabled(true);
				break;
			}
		}
	}

 class MyCellRenderer extends JLabel implements ListCellRenderer    {

	 public MyCellRenderer() {
         setOpaque(true);
     }

     public Component getListCellRendererComponent(
         JList list,
         Object value,
         int index,
         boolean isSelected,
         boolean cellHasFocus)
     {
		if (isSelected) {
            setBackground(list.getSelectionBackground());
            setForeground(list.getSelectionForeground());
        } else {
            setBackground(list.getBackground());
            setForeground(list.getForeground());
        }

		this.setText(value.toString());

		if(list.getSelectedIndex()!=-1)
		//ho selezionato qualcosa
			list.setToolTipText(list.getSelectedValue().toString());
		else
			list.setToolTipText(null);

		return this;
     }
 }
}