/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import Utility.BusinessModelComponent;
import Utility.ProjectType;

import java.io.File;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * Permette di editare i vari gruppi di risorse associate ad ogni bus role per ogni
 * bus relationship ad esso associata
 */
public class AddEditBusinessModelComponentResourcesPanel extends JPanel {
    BorderLayout layoutRoot = new BorderLayout();
    JButton buttonAddSourceLocation = new JButton();
    JPanel panelDocLocation = new JPanel();
    JButton buttonAddBinaryLocation = new JButton();
    BorderLayout layoutSourceLocation = new BorderLayout();
    JLabel labelDocLocation = new JLabel();
    BorderLayout layoutBinaryLocation = new BorderLayout();
    JPanel panelAddEditBusModCompLocations = new JPanel();
    JLabel labelSourceLocation = new JLabel();
    JPanel panelSourceLocation = new JPanel();
    JLabel labelBinaryLocation = new JLabel();
    GridLayout layoutAddEditBusModCompLocation = new GridLayout();
    BorderLayout layoutDocLocation = new BorderLayout();
    JButton buttonAddDocLocation = new JButton();
    JPanel panelBinaryLocation = new JPanel();
    JLabel empty1 = new JLabel();
    JLabel empty2 = new JLabel();
    JLabel empty3 = new JLabel();
    JLabel empty7 = new JLabel();
    BorderLayout layoutEditBusModCompDescriptionContainer = new BorderLayout();
    JTextPane textPaneDescription = new JTextPane();
    JPanel panelAddEditBusModCompDescriptionContainer = new JPanel();
    JLabel empty4 = new JLabel();
    JLabel labelDescription = new JLabel();
    JLabel empty5 = new JLabel();
    JScrollPane scrollPaneDescription = new JScrollPane();
    JPanel panelAddEditBusModCompDescription = new JPanel();
    BorderLayout layoutAddEditBusModCompDescription = new BorderLayout();
    JComboBox comboBoxSourceLocation = new JComboBox();
    JButton buttonRemoveSourceLocation = new JButton();
    JComboBox comboBoxBinaryLocation = new JComboBox();
    JComboBox comboBoxDocLocation = new JComboBox();
    JButton buttonRemoveBinaryLocation = new JButton();
    JButton buttonRemoveDocLocation = new JButton();

    /**
	 * Identifica il bus comp a cui si riferiscono le risorse gestite in questo panel
	 */
	private BusinessModelComponent curr = null;
	/**
	 * Identifica il gruppo specifico di risorse a cui si fa riferimento
	 */
	private short busModCompIDLink =-1;

	public AddEditBusinessModelComponentResourcesPanel(BusinessModelComponent curr,short busModCompIDLink) {

		this.curr=curr;
		this.busModCompIDLink=busModCompIDLink;

		try {
            jbInit();

			this.comboBoxSourceLocation.setRenderer(new MyCellRenderer());
			this.comboBoxBinaryLocation.setRenderer(new MyCellRenderer());
			this.comboBoxDocLocation.setRenderer(new MyCellRenderer());
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }

		// carico nel JDialog le info, eventualmente gi disponibili, sul componente da editare

		String textInfo=curr.GetBusModComp_1_ResDescription(busModCompIDLink);
		if(textInfo!=null)
		    this.textPaneDescription.setText(textInfo);

		String[] arrayOfTextInfo = null;

		if((arrayOfTextInfo=curr.GetBusModComp_1_ResSourceLoc(busModCompIDLink))!=null) {
			for(int i=0;i<arrayOfTextInfo.length;i++)
				this.comboBoxSourceLocation.addItem(arrayOfTextInfo[i]);
			this.comboBoxSourceLocation.setEnabled(true);
		}
//		if(textInfo!=null)
//			this.textFieldSourceLocation.setText(textInfo);

		if((arrayOfTextInfo=curr.GetBusModComp_1_ResBinaryLoc(busModCompIDLink))!=null) {
			for(int i=0;i<arrayOfTextInfo.length;i++)
				this.comboBoxBinaryLocation.addItem(arrayOfTextInfo[i]);
			this.comboBoxBinaryLocation.setEnabled(true);
		}
//		if(textInfo!=null)
//			this.textFieldBinaryLocation.setText(textInfo);

		if((arrayOfTextInfo=curr.GetBusModComp_1_ResDocLoc(busModCompIDLink))!=null)    {
			for(int i=0;i<arrayOfTextInfo.length;i++)
				this.comboBoxDocLocation.addItem(arrayOfTextInfo[i]);
			this.comboBoxDocLocation.setEnabled(true);
		}
//		if(textInfo!=null)
//			this.textFieldDocLocation.setText(textInfo);

//	   	this.textFieldSourceLocation.setCaretPosition(0);
//		this.textFieldBinaryLocation.setCaretPosition(0);
//		this.textFieldDocLocation.setCaretPosition(0);
    }

    void jbInit() throws Exception {
        panelDocLocation.setLayout(layoutDocLocation);
        buttonAddSourceLocation.setIcon(new ImageIcon("Interfaccia/Icons/OpenSmall.gif"));
        buttonAddSourceLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAddSourceLocation_actionPerformed(e);
            }
        });
        buttonAddSourceLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonAddSourceLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonAddSourceLocation.setNextFocusableComponent(buttonRemoveBinaryLocation);
        buttonAddSourceLocation.setPreferredSize(new Dimension(22, 20));
        buttonAddSourceLocation.setToolTipText("Click it to add a file");
        layoutRoot.setHgap(10);
        layoutRoot.setVgap(10);
        this.setLayout(layoutRoot);
        buttonAddBinaryLocation.setIcon(new ImageIcon("Interfaccia/Icons/OpenSmall.gif"));
        buttonAddBinaryLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonAddBinaryLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAddBinaryLocation_actionPerformed(e);
            }
        });
        buttonAddBinaryLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonAddBinaryLocation.setNextFocusableComponent(buttonRemoveDocLocation);
        buttonAddBinaryLocation.setPreferredSize(new Dimension(22, 20));
        buttonAddBinaryLocation.setToolTipText("Click it to add a file");
        labelDocLocation.setText("Doc. Files Location");
        panelAddEditBusModCompLocations.setLayout(layoutAddEditBusModCompLocation);
        panelAddEditBusModCompLocations.setPreferredSize(new Dimension(450, 90));
        labelSourceLocation.setAlignmentX((float) 0.5);
        labelSourceLocation.setText("Source Files Location");
        panelSourceLocation.setLayout(layoutSourceLocation);
        labelBinaryLocation.setText("Binary Files Location");
        layoutAddEditBusModCompLocation.setRows(3);
        layoutAddEditBusModCompLocation.setColumns(2);
        layoutAddEditBusModCompLocation.setVgap(10);
        buttonAddDocLocation.setIcon(new ImageIcon("Interfaccia/Icons/OpenSmall.gif"));
        buttonAddDocLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonAddDocLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonAddDocLocation_actionPerformed(e);
            }
        });
        buttonAddDocLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonAddDocLocation.setNextFocusableComponent(this);
        buttonAddDocLocation.setPreferredSize(new Dimension(22, 20));
        buttonAddDocLocation.setToolTipText("Click it to add a file");
        buttonAddDocLocation.setFocusPainted(false);
        panelBinaryLocation.setLayout(layoutBinaryLocation);
        layoutEditBusModCompDescriptionContainer.setHgap(20);
        textPaneDescription.setSelectionColor(new Color(10, 36, 106));
        panelAddEditBusModCompDescriptionContainer.setLayout(layoutEditBusModCompDescriptionContainer);
        labelDescription.setAlignmentX((float) 0.5);
        labelDescription.setText("Description");
        scrollPaneDescription.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        scrollPaneDescription.setBorder(BorderFactory.createLoweredBevelBorder());
        panelAddEditBusModCompDescription.setLayout(layoutAddEditBusModCompDescription);
        panelAddEditBusModCompDescription.setPreferredSize(new Dimension(450, 60));
        layoutAddEditBusModCompDescription.setHgap(10);
        layoutAddEditBusModCompDescription.setVgap(10);
        this.setMaximumSize(new Dimension(470, 170));
        this.setMinimumSize(new Dimension(470, 170));
        comboBoxSourceLocation.setEnabled(false);
        comboBoxSourceLocation.setNextFocusableComponent(buttonAddSourceLocation);
        comboBoxSourceLocation.setMaximumRowCount(5);
        comboBoxSourceLocation.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                comboBoxSourceLocation_itemStateChanged(e);
            }
        });
        buttonRemoveSourceLocation.setEnabled(false);
        buttonRemoveSourceLocation.setNextFocusableComponent(comboBoxSourceLocation);
        buttonRemoveSourceLocation.setPreferredSize(new Dimension(22, 20));
        buttonRemoveSourceLocation.setToolTipText("Click it to remove selected file");
        buttonRemoveSourceLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonRemoveSourceLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonRemoveSourceLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemoveSourceLocation_actionPerformed(e);
            }
        });
        buttonRemoveSourceLocation.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        comboBoxBinaryLocation.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                comboBoxBinaryLocation_itemStateChanged(e);
            }
        });
        comboBoxBinaryLocation.setMaximumRowCount(5);
        comboBoxBinaryLocation.setNextFocusableComponent(buttonAddSourceLocation);
        comboBoxBinaryLocation.setEnabled(false);
        comboBoxDocLocation.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                comboBoxDocLocation_itemStateChanged(e);
            }
        });
        comboBoxDocLocation.setMaximumRowCount(5);
        comboBoxDocLocation.setNextFocusableComponent(buttonAddSourceLocation);
        comboBoxDocLocation.setEnabled(false);
        buttonRemoveBinaryLocation.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        buttonRemoveBinaryLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemoveBinaryLocation_actionPerformed(e);
            }
        });
        buttonRemoveBinaryLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonRemoveBinaryLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonRemoveBinaryLocation.setPreferredSize(new Dimension(22, 20));
        buttonRemoveBinaryLocation.setToolTipText("Click it to remove selected file");
        buttonRemoveBinaryLocation.setNextFocusableComponent(comboBoxBinaryLocation);
        buttonRemoveBinaryLocation.setEnabled(false);
        buttonRemoveDocLocation.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        buttonRemoveDocLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonRemoveDocLocation_actionPerformed(e);
            }
        });
        buttonRemoveDocLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonRemoveDocLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonRemoveDocLocation.setPreferredSize(new Dimension(22, 20));
        buttonRemoveDocLocation.setToolTipText("Click it to remove selected file");
        buttonRemoveDocLocation.setNextFocusableComponent(comboBoxDocLocation);
        buttonRemoveDocLocation.setEnabled(false);
        this.add(panelAddEditBusModCompLocations, BorderLayout.CENTER);
        panelAddEditBusModCompLocations.add(labelSourceLocation, null);
        panelAddEditBusModCompLocations.add(panelSourceLocation, null);
        panelSourceLocation.add(buttonAddSourceLocation, BorderLayout.EAST);
        panelSourceLocation.add(comboBoxSourceLocation, BorderLayout.CENTER);
        panelSourceLocation.add(buttonRemoveSourceLocation, BorderLayout.WEST);
        panelAddEditBusModCompLocations.add(labelBinaryLocation, null);
        panelAddEditBusModCompLocations.add(panelBinaryLocation, null);
        panelBinaryLocation.add(buttonAddBinaryLocation, BorderLayout.EAST);
        panelBinaryLocation.add(comboBoxBinaryLocation, BorderLayout.CENTER);
        panelBinaryLocation.add(buttonRemoveBinaryLocation, BorderLayout.WEST);
        panelAddEditBusModCompLocations.add(labelDocLocation, null);
        panelAddEditBusModCompLocations.add(panelDocLocation, null);
        panelDocLocation.add(buttonAddDocLocation, BorderLayout.EAST);
        panelDocLocation.add(comboBoxDocLocation, BorderLayout.CENTER);
        panelDocLocation.add(buttonRemoveDocLocation, BorderLayout.WEST);
        this.add(empty1, BorderLayout.SOUTH);
        this.add(empty2, BorderLayout.WEST);
        this.add(empty3, BorderLayout.EAST);
        this.add(panelAddEditBusModCompDescription, BorderLayout.NORTH);
        panelAddEditBusModCompDescription.add(empty5, BorderLayout.WEST);
        panelAddEditBusModCompDescription.add(empty4, BorderLayout.EAST);
        panelAddEditBusModCompDescription.add(panelAddEditBusModCompDescriptionContainer, BorderLayout.CENTER);
        panelAddEditBusModCompDescriptionContainer.add(labelDescription, BorderLayout.WEST);
        panelAddEditBusModCompDescriptionContainer.add(scrollPaneDescription, BorderLayout.CENTER);
        panelAddEditBusModCompDescription.add(empty7, BorderLayout.NORTH);
        scrollPaneDescription.getViewport().add(textPaneDescription, null);
    }

    void buttonAddSourceLocation_actionPerformed(ActionEvent e) {
		this.AddToComboBox(this.comboBoxSourceLocation);
//		this.textFieldSourceLocation.setText(this.SelectFile(this.textFieldSourceLocation.getText()));
//		this.textFieldSourceLocation.setCaretPosition(0);
    }

    void buttonAddBinaryLocation_actionPerformed(ActionEvent e) {
		this.AddToComboBox(this.comboBoxBinaryLocation);
//		this.textFieldBinaryLocation.setText(this.SelectFile(this.textFieldBinaryLocation.getText()));
//		this.textFieldBinaryLocation.setCaretPosition(0);
    }

    void buttonAddDocLocation_actionPerformed(ActionEvent e) {
		this.AddToComboBox(this.comboBoxDocLocation);
//		this.textFieldDocLocation.setText(this.SelectFile(this.textFieldDocLocation.getText()));
//		this.textFieldDocLocation.setCaretPosition(0);
    }

	/**
	 * Gestisce la scelta di 1 risorsa e ctrl che tale risorsa esista realmente
	 */
	private String SelectFile(String selectFileYet) {
		String selectPath=null;
//		if(selectFileYet.compareTo("")==0)
		if(selectFileYet==null)
			selectPath=System.getProperty("user.dir");
		else
			selectPath=selectFileYet;
		JFileChooser chooser = new JFileChooser(selectPath);
		if(selectFileYet!=null)
			chooser.setSelectedFile(new java.io.File(selectFileYet));
		chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		chooser.setMultiSelectionEnabled(false);
		chooser.setDialogTitle("Select File");

		while(true) {
			int retValue =chooser.showDialog(this,"Add");

			if(retValue==JFileChooser.APPROVE_OPTION)   {
				//ho scelto un file
				if(chooser.getSelectedFile().exists())  {
					String fileForComparing;
					if(selectFileYet==null)
						fileForComparing="";
					else
						fileForComparing=selectFileYet;
					if(chooser.getSelectedFile().getAbsolutePath().compareTo(fileForComparing)==0)
						//ho riselezionato lo stesso oppure non ho fatto nulla
						return null;
					else
						return chooser.getSelectedFile().getAbsolutePath();
				}
			}
			else
			//ho cliccato su annulla
//				return selectFileYet;
				return null;
		}
	}

	/**
	 * Associa o aggiorna i file specificati alle opportune risorse di un bus role
	 */
	boolean AddUpdateThisResources()  {

		String textInfo = null;

		textInfo=this.textPaneDescription.getText().replace('\n',' ').replace('\r',' ').trim();
		if(textInfo.compareTo("")==0)
			textInfo=null;
	    curr.SetBusModComp_1_ResDecription(textInfo,busModCompIDLink);

/*		textInfo=this.textFieldSourceLocation.getText();
		if(textInfo.compareTo("")!=0)   {
			if(!(new File(textInfo)).exists())  {
			//il file non esiste, deve specificarne un altro
				JOptionPane.showMessageDialog(this,"The source file you have specified for the\nBus. Relationship " + ProjectType.prjTypeDescription[2][busModCompIDLink+2] +"\ndoesn't exist.\nCheck it","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
				this.textFieldSourceLocation.setText(null);
				return false;
			}
		}
		else
			textInfo=null;*/

		this.curr.SetBusModComp_1_ResSourceLoc(this.GetComboBoxItems(this.comboBoxSourceLocation),busModCompIDLink);
//		this.curr.SetBusModComp_1_ResSourceLoc(textInfo,busModCompIDLink);

/*		textInfo=this.textFieldBinaryLocation.getText();
		if(textInfo.compareTo("")!=0)   {
			if(!(new File(textInfo)).exists())  {
			//il file non esiste, deve specifcarne un altro
				JOptionPane.showMessageDialog(this,"The binary file you have specified for the\nBus. Relationship " + ProjectType.prjTypeDescription[2][busModCompIDLink+2] +"\ndoesn't exist.\nCheck it","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
				this.textFieldBinaryLocation.setText(null);
				return false;
			}
		}
		else
			textInfo=null;*/

		this.curr.SetBusModComp_1_ResBinaryLoc(this.GetComboBoxItems(this.comboBoxBinaryLocation),busModCompIDLink);
//		this.curr.SetBusModComp_1_ResBinaryLoc(textInfo,busModCompIDLink);

/*		textInfo=this.textFieldDocLocation.getText();
		if(textInfo.compareTo("")!=0)   {
			if(!(new File(textInfo)).exists())  {
			//il file non esiste, deve specifcarne un altro
				JOptionPane.showMessageDialog(this,"The documentation file you have specified for the\nBus. Relationship " + ProjectType.prjTypeDescription[2][busModCompIDLink+2] +"\ndoesn't exist.\nCheck it","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
				this.textFieldDocLocation.setText(null);
				return false;
			}
		}
		else
			textInfo=null;*/

		this.curr.SetBusModComp_1_ResDocLoc(this.GetComboBoxItems(this.comboBoxDocLocation),busModCompIDLink);
//		this.curr.SetBusModComp_1_ResDocLoc(textInfo,busModCompIDLink);

		//tutto a posto
		return true;
	}

    void comboBoxBinaryLocation_itemStateChanged(ItemEvent e) {
		this.ComboBox_itemStateChanged(e,this.buttonRemoveBinaryLocation);
    }
    void comboBoxDocLocation_itemStateChanged(ItemEvent e) {
		this.ComboBox_itemStateChanged(e,this.buttonRemoveDocLocation);
    }
    void buttonRemoveBinaryLocation_actionPerformed(ActionEvent e) {
		this.RemoveFromComboBox(this.comboBoxBinaryLocation);
    }
    void buttonRemoveDocLocation_actionPerformed(ActionEvent e) {
		this.RemoveFromComboBox(this.comboBoxDocLocation);
    }

    void buttonRemoveSourceLocation_actionPerformed(ActionEvent e) {
		this.RemoveFromComboBox(this.comboBoxSourceLocation);
    }

    void comboBoxSourceLocation_itemStateChanged(ItemEvent e) {
		this.ComboBox_itemStateChanged(e,this.buttonRemoveSourceLocation);
    }

	private String[] GetComboBoxItems(JComboBox combo) {
		String[] items=null;

		int numItems = combo.getItemCount();
		if(numItems!=0) {
			items = new String[numItems];
			for(int i=0; i<numItems;i++)
			    items[i]=(String)combo.getItemAt(i);
		}
		return items;
	}

	private void AddToComboBox(JComboBox combo)  {
		String newItem=this.SelectFile((String)combo.getSelectedItem());
		if(newItem!=null)   {
			combo.setEnabled(true);
			int i;
			for(i=0;i<combo.getItemCount();i++) {
				if(newItem.compareTo(combo.getItemAt(i))==0)
				//ho gi inserito quel file
					break;
			}
			if(i==combo.getItemCount())
				//non ho inserito ancora quel file
			    combo.addItem(newItem);
		}
	}

	private void RemoveFromComboBox(JComboBox combo)    {
		combo.removeItemAt(combo.getSelectedIndex());
		combo.setSelectedIndex(-1);
		if(combo.getItemCount()==0)
			combo.setEnabled(false);
	}

	private void ComboBox_itemStateChanged(ItemEvent e,JButton button) {
		switch(e.getStateChange())  {
			case ItemEvent.DESELECTED:  {
				button.setEnabled(false);
				break;
			}
			case ItemEvent.SELECTED:    {
				button.setEnabled(true);
				break;
			}
		}
	}


 class MyCellRenderer extends JLabel implements ListCellRenderer    {

	 public MyCellRenderer() {
         setOpaque(true);
     }

     public Component getListCellRendererComponent(
         JList list,
         Object value,
         int index,
         boolean isSelected,
         boolean cellHasFocus)
     {
		if (isSelected) {
            setBackground(list.getSelectionBackground());
            setForeground(list.getSelectionForeground());
        } else {
            setBackground(list.getBackground());
            setForeground(list.getForeground());
        }

		this.setText(value.toString());

		if(list.getSelectedIndex()!=-1)
		//ho selezionato qualcosa
			list.setToolTipText(list.getSelectedValue().toString());
		else
			list.setToolTipText(null);

		return this;
     }
 }

}