/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import Utility.ProjectType;

import java.util.Vector;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

/**
 * Gestisce la selezione delle risorse associate ad un bus comp da scaricare
 */
class ChoiceBusModCompResourcesToDownloadPanel extends JPanel {
    BorderLayout layoutRoot = new BorderLayout();
    JLabel empty1 = new JLabel();
    JLabel empty2 = new JLabel();
    JLabel empty3 = new JLabel();
    JLabel empty4 = new JLabel();
    JPanel panelAllResources = new JPanel();
    GridLayout layoutAllResources = new GridLayout();
    JScrollPane scrollPaneSourceResources = new JScrollPane();
    JScrollPane scrollPaneDocResources = new JScrollPane();
    JScrollPane scrollPaneBinaryResources = new JScrollPane();

	/**
	 * Specifica a quale bus comp le risorse si riferiscono
	 */
	private short busModCompID = -1;
	/**
	 * Specifica a quale gruppo di risorse appartengono quelle qui specificate
	 */
	private short busModCompIDLink =-1;
    JList listSourceResources = new JList();
    JList listBinaryResources = new JList();
    JList listDocResources = new JList();

	public ChoiceBusModCompResourcesToDownloadPanel(short busModCompID, short busModCompIDLink,Vector resources) {

		this.busModCompID=busModCompID;
		this.busModCompIDLink=busModCompIDLink;

		// carico nel panel le info disponibili sul componente i cui elementi si vogliono scaricare
		String[] data = (String[])resources.get(0);
		if(data!=null)
			this.listSourceResources.setListData(data);

		data =(String[])resources.get(1);
		if(data!=null)
			this.listBinaryResources.setListData(data);

		data =(String[])resources.get(2);
		if(data!=null)
			this.listDocResources.setListData(data);

		try {
            jbInit();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }

    }

    void jbInit() throws Exception {
        layoutRoot.setHgap(10);
        layoutRoot.setVgap(10);
        this.setLayout(layoutRoot);
        panelAllResources.setLayout(layoutAllResources);
        layoutAllResources.setColumns(3);
        layoutAllResources.setHgap(10);
        layoutAllResources.setVgap(10);
        scrollPaneSourceResources.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Source Files"));
        scrollPaneSourceResources.setPreferredSize(new Dimension(100, 140));
        scrollPaneDocResources.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Doc. Files"));
        scrollPaneDocResources.setPreferredSize(new Dimension(100, 140));
        scrollPaneBinaryResources.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Binary Files"));
        scrollPaneBinaryResources.setPreferredSize(new Dimension(100, 140));
        listSourceResources.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(178, 178, 178),new Color(124, 124, 124)));
        listSourceResources.setVisibleRowCount(5);
        listBinaryResources.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(178, 178, 178),new Color(124, 124, 124)));
        listBinaryResources.setVisibleRowCount(5);
        listDocResources.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(178, 178, 178),new Color(124, 124, 124)));
        listDocResources.setVisibleRowCount(5);
        this.add(empty1, BorderLayout.NORTH);
        this.add(empty2, BorderLayout.SOUTH);
        this.add(empty3, BorderLayout.WEST);
        this.add(empty4, BorderLayout.EAST);
        this.add(panelAllResources, BorderLayout.CENTER);
        panelAllResources.add(scrollPaneSourceResources, null);
        scrollPaneSourceResources.getViewport().add(listSourceResources, null);
        panelAllResources.add(scrollPaneBinaryResources, null);
        scrollPaneBinaryResources.getViewport().add(listBinaryResources, null);
        panelAllResources.add(scrollPaneDocResources, null);
        scrollPaneDocResources.getViewport().add(listDocResources, null);
    }

	/**
	 * Inizia il down dei componenti selezionati
	 */
	void StartDownloads(PolitellaFrame pFrame)   {
		Vector busModCompInfos=new Vector();

	    int[] arrayOfSelectIndex = null;
		Object[] arrayOfSelectRes=null;
	    String[] list = null;
		Vector vectorOfInfos=null;

		 // nel vector metto nell'ordine:
		 // - Short busModCompID
		 // - Vector vectorOfInfos // (i campi sono tanti quanti gli elementi della lista a cui appartiene,
									//tutti null tranne quello in cui nella lista si trova il file che
									//voglio scaricare, in quel campo riporto il nome)
		 // - String RESOURCES
		 // - SHort busModCompIDLInk
		 // - String busCompElementType

		 short busModCompIDResOwner;
		 short busModCompIDLinkResOwner;

		 if(this.busModCompID < ProjectType.numBusinessRole)    {
			//sto visualizzando le risorse associate ad un bus. role
			busModCompIDResOwner = this.busModCompID;
			busModCompIDLinkResOwner = this.busModCompIDLink;
		 }
		 else   {
			//sto visualizzando le risorse associate ad una bus. relationship
			busModCompIDResOwner = this.busModCompIDLink;
			busModCompIDLinkResOwner = this.busModCompID;
		 }
		 //questa distinzione serve per evitare che scaricando delle risorse visualizzando una bus. rela
		 //queste non vadano salvate nella dir propria del bus role che ha implementato quella particolare
		 //bus rela.
		 //Se invece visualizzo un bus. role non ci sono problemi


		if(this.listSourceResources.getSelectedIndex()!=-1)    {
		    arrayOfSelectIndex = this.listSourceResources.getSelectedIndices();
			arrayOfSelectRes=this.listSourceResources.getSelectedValues();
		    list = new String[arrayOfSelectRes.length];
			for(int i=0;i<arrayOfSelectRes.length;i++)    {
				list[i]=(String)arrayOfSelectRes[i];
			}

			for(int i=0;i<list.length;i++)  {
				if(list[i].lastIndexOf('@')!=-1)    {
					//il file in questione non  ancora stato scaricato
					busModCompInfos.add(new Short(busModCompIDResOwner));

					vectorOfInfos = new Vector(this.listSourceResources.getModel().getSize());
					for(int y=0;y<vectorOfInfos.capacity();y++)
						vectorOfInfos.add(null);
					vectorOfInfos.remove(arrayOfSelectIndex[i]);
					vectorOfInfos.add(arrayOfSelectIndex[i],arrayOfSelectRes[i]);
   		    		busModCompInfos.add(vectorOfInfos);

		    		busModCompInfos.add("RESOURCES");
//	    	    	busModCompInfos.add(new Short(this.busModCompIDLink));
					busModCompInfos.add(new Short(busModCompIDLinkResOwner));
					busModCompInfos.add(new String("SOURCE"));

//					System.out.println(busModCompInfos);

					pFrame.userInterface.NewDownloadComponentElement(pFrame.currentPrjViewing.GetPrjID().longValue(),busModCompInfos);
					busModCompInfos.clear();
				}
			}
		}
		if(this.listBinaryResources.getSelectedIndex()!=-1)    {
		    arrayOfSelectIndex = this.listBinaryResources.getSelectedIndices();
			arrayOfSelectRes=this.listBinaryResources.getSelectedValues();
		    list = new String[arrayOfSelectRes.length];
			for(int i=0;i<arrayOfSelectRes.length;i++)    {
				list[i]=(String)arrayOfSelectRes[i];
			}

			for(int i=0;i<list.length;i++)  {
				if(list[i].lastIndexOf('@')!=-1)    {
					//il file in questione non  ancora stato scaricato
//			        busModCompInfos.add(new Short(this.busModCompID));
					busModCompInfos.add(new Short(busModCompIDResOwner));

					vectorOfInfos = new Vector(this.listBinaryResources.getModel().getSize());
					for(int y=0;y<vectorOfInfos.capacity();y++)
						vectorOfInfos.add(null);
					vectorOfInfos.remove(arrayOfSelectIndex[i]);
					vectorOfInfos.add(arrayOfSelectIndex[i],arrayOfSelectRes[i]);
   		    		busModCompInfos.add(vectorOfInfos);

					busModCompInfos.add("RESOURCES");
//  	    		busModCompInfos.add(new Short(this.busModCompIDLink));
					busModCompInfos.add(new Short(busModCompIDLinkResOwner));
					busModCompInfos.add(new String("BINARY"));
					pFrame.userInterface.NewDownloadComponentElement(pFrame.currentPrjViewing.GetPrjID().longValue(),busModCompInfos);
					busModCompInfos.clear();
				}
			}
		}
		if(this.listDocResources.getSelectedIndex()!=-1)   {
		    arrayOfSelectIndex = this.listDocResources.getSelectedIndices();
			arrayOfSelectRes=this.listDocResources.getSelectedValues();
		    list = new String[arrayOfSelectRes.length];
			for(int i=0;i<arrayOfSelectRes.length;i++)    {
				list[i]=(String)arrayOfSelectRes[i];
			}

			for(int i=0;i<list.length;i++)  {
				if(list[i].lastIndexOf('@')!=-1)    {
					//il file in questione non  ancora stato scaricato
//			        busModCompInfos.add(new Short(this.busModCompID));
					busModCompInfos.add(new Short(busModCompIDResOwner));

					vectorOfInfos = new Vector(this.listDocResources.getModel().getSize());
					for(int y=0;y<vectorOfInfos.capacity();y++)
						vectorOfInfos.add(null);
					vectorOfInfos.remove(arrayOfSelectIndex[i]);
					vectorOfInfos.add(arrayOfSelectIndex[i],arrayOfSelectRes[i]);
   		    		busModCompInfos.add(vectorOfInfos);

					busModCompInfos.add("RESOURCES");
//  	    		busModCompInfos.add(new Short(this.busModCompIDLink));
					busModCompInfos.add(new Short(busModCompIDLinkResOwner));
					busModCompInfos.add(new String("DOCUMENTATION"));
					pFrame.userInterface.NewDownloadComponentElement(pFrame.currentPrjViewing.GetPrjID().longValue(),busModCompInfos);
					busModCompInfos.clear();
				}
			}
		}
	}
}