/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionEvent;

/**
 * Gestisce un indicatore di progresso attivo per tutto il tempo in cui ci sono dei download in corso
 */
class ConnectionDownloadsInProgressDialog extends JDialog implements Runnable{
    BorderLayout layoutDownloadsProgress = new BorderLayout();
    JProgressBar progressBaConnectionDownloadsProgress = new JProgressBar();
    JLabel empty1 = new JLabel();
    JLabel empty2 = new JLabel();
    JLabel empty3 = new JLabel();
    JLabel empty14 = new JLabel();

	private Timer timer=null;

	private Thread thread =null;
	/**
	 * Valore dell'indicatore di progresso
	 */
	private int value=0;
	/**
	 * Indicatore del numero di download in corso
	 */
	private boolean connectionDownloadsInProgress=false;

    public ConnectionDownloadsInProgressDialog(PolitellaFrame pFrame) {
		super(pFrame);
        try {
			jbInit();

			this.setSize(200,70);
        }
        catch(Exception e) {
//            e.printStackTrace();
        }

        //Center the window
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
        if (frameSize.height > screenSize.height)
			frameSize.height = screenSize.height;
		if (frameSize.width > screenSize.width)
			frameSize.width = screenSize.width;
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

		timer= new Timer(500,null);
		timer.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				timer_actionPerformed(e);
	        }
        });
    }

    private void jbInit() throws Exception {
        this.getContentPane().setLayout(layoutDownloadsProgress);
        layoutDownloadsProgress.setHgap(10);
        layoutDownloadsProgress.setVgap(10);
        progressBaConnectionDownloadsProgress.setBorder(BorderFactory.createLoweredBevelBorder());
        progressBaConnectionDownloadsProgress.setDoubleBuffered(true);
        progressBaConnectionDownloadsProgress.setMaximum(20);
        progressBaConnectionDownloadsProgress.setString("");
        progressBaConnectionDownloadsProgress.setStringPainted(true);
        this.setDefaultCloseOperation(0);
        this.setResizable(false);
        this.setModal(true);
        this.setTitle("Connection or Downloads in progress...");
        this.getContentPane().add(progressBaConnectionDownloadsProgress, BorderLayout.CENTER);
        this.getContentPane().add(empty1, BorderLayout.SOUTH);
        this.getContentPane().add(empty2, BorderLayout.WEST);
        this.getContentPane().add(empty3, BorderLayout.EAST);
        this.getContentPane().add(empty14, BorderLayout.NORTH);
    }

	private void timer_actionPerformed(ActionEvent e)   {
		if(this.value==this.progressBaConnectionDownloadsProgress.getMaximum())
			value=-value;
		value++;
		this.progressBaConnectionDownloadsProgress.setValue(Math.abs(value));
	}

	public void setVisible(boolean newState) {
		if(newState) {
			//ho avviato un nuovo download
			if(!this.connectionDownloadsInProgress) {
				// il primo download che avvio
				this.connectionDownloadsInProgress=true;
				this.thread = new Thread(this);
				this.thread.start();
			}
		}
		else    {
			//ho terminato tutti i download
			this.connectionDownloadsInProgress=false;
			this.timer.stop();
			try {
				this.thread.interrupt();
			}catch(java.lang.NullPointerException e)    {}
			super.setVisible(false);
			this.value=0;
			this.progressBaConnectionDownloadsProgress.setValue(this.value);
		}
	}

	public void run()   {
		this.timer.start();
		super.setVisible(true);
	}
}