/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import java.util.Enumeration;

import Utility.BusinessModelComponent;
import Utility.ProjectType;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * Gestisce la finestra di dialogo per il download delle risorse di pi bus comp selezionati
 */
class MultiComponentsDownloadDialog extends JDialog {
    BorderLayout layoutRoot = new BorderLayout();
    JLabel empty5 = new JLabel();
    JPanel panelButtonBarContainer = new JPanel();
    JLabel empty4 = new JLabel();
    JLabel empty6 = new JLabel();
    JButton buttonOk = new JButton();
    GridLayout layoutButtonBarContainer = new GridLayout();
    JPanel panelButtonBar = new JPanel();
    BorderLayout layoutButtonBar = new BorderLayout();
    JButton buttonCancel = new JButton();
    JTabbedPane tabbedPaneBusComponents = new JTabbedPane();

    public MultiComponentsDownloadDialog(PolitellaFrame pFrame) {
        super(pFrame);

		Enumeration list = pFrame.currentPrjViewing.busModCompMultiSelection.elements();
		String title =null;
		String toolTip = null;
		while(list.hasMoreElements())   {
			BusinessModelComponent curr = (BusinessModelComponent) list.nextElement();
			this.tabbedPaneBusComponents.add(new SingleBusModCompDownloadResourcesPanel(curr));

			if(curr.GetBusModCompID()<ProjectType.numBusinessRole)
			//il +1 serve perch nell'array c' un solo campo Any...
				title = ProjectType.prjTypeDescription[2][curr.GetBusModCompID()+1];
			else
			//il +2 serve perch nell'array ci sono due campi Any...
				title = ProjectType.prjTypeDescription[2][curr.GetBusModCompID()+2];
			this.tabbedPaneBusComponents.setTitleAt(this.tabbedPaneBusComponents.getTabCount()-1,title);

			if(curr.GetBusModCompID()<ProjectType.numBusinessRole)
				toolTip = "Business Role " + title;
			else
				toolTip = "Business Relationship " + title;

			this.tabbedPaneBusComponents.setToolTipTextAt(this.tabbedPaneBusComponents.getTabCount()-1,toolTip);
		}

        try {
            jbInit();
            pack();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }

        //Center the window
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
           if (frameSize.height > screenSize.height) {
               frameSize.height = screenSize.height;
        }
		if (frameSize.width > screenSize.width) {
               frameSize.width = screenSize.width;
           }
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        this.setVisible(true);
    }

    void jbInit() throws Exception {
        this.getContentPane().setLayout(layoutRoot);
        layoutRoot.setHgap(10);
        layoutRoot.setVgap(10);
        panelButtonBarContainer.setLayout(layoutButtonBarContainer);
        buttonOk.setText("OK");
        buttonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonOk_actionPerformed(e);
            }
        });
        layoutButtonBarContainer.setColumns(4);
        layoutButtonBarContainer.setHgap(100);
        panelButtonBar.setLayout(layoutButtonBar);
        panelButtonBar.setPreferredSize(new Dimension(450, 37));
        layoutButtonBar.setHgap(30);
        layoutButtonBar.setVgap(10);
        buttonCancel.setText("Cancel");
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonCancel_actionPerformed(e);
            }
        });
        this.setDefaultCloseOperation(0);
        this.setResizable(false);
        this.setModal(true);
        this.setTitle("Choice one or more elements");
        tabbedPaneBusComponents.setBorder(BorderFactory.createEmptyBorder());
        this.getContentPane().add(panelButtonBar, BorderLayout.SOUTH);
        panelButtonBar.add(panelButtonBarContainer, BorderLayout.CENTER);
        panelButtonBarContainer.add(buttonOk, null);
        panelButtonBarContainer.add(buttonCancel, null);
        panelButtonBar.add(empty6, BorderLayout.SOUTH);
        panelButtonBar.add(empty4, BorderLayout.WEST);
        panelButtonBar.add(empty5, BorderLayout.EAST);
        this.getContentPane().add(tabbedPaneBusComponents, BorderLayout.CENTER);
    }

    void buttonOk_actionPerformed(ActionEvent e) {
		PolitellaFrame pFrame = (PolitellaFrame)this.getParent();
		for(int i=this.tabbedPaneBusComponents.getTabCount();i>0;i--)
			((SingleBusModCompDownloadResourcesPanel)this.tabbedPaneBusComponents.getComponentAt(i-1)).StartDownloads(pFrame);

		pFrame.currentPrjViewing.CancelMultiSelection();
		this.dispose();
    }

    void buttonCancel_actionPerformed(ActionEvent e) {
		this.dispose();
    }
}