/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import Utility.ProjectType;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import java.io.File;
import java.io.IOException;
import java.io.DataOutputStream;
import java.io.FileOutputStream;
import javax.swing.border.*;

/**
 * Gestisce la finestra di dialogo per la creazione di un nuovo progetto
 */
class NewProjectDialog extends JDialog {
    BorderLayout layoutNewProject = new BorderLayout();
    JPanel panelButtonBar = new JPanel();
    JPanel panelProjectOption = new JPanel();
    JLabel empty1 = new JLabel();
    JLabel empty2 = new JLabel();
    JLabel empty3 = new JLabel();
    JPanel panelButtonBarContainer = new JPanel();
    JButton buttonCancel = new JButton();
    BorderLayout layoutButtonBar = new BorderLayout();
    GridLayout layoutButtonBarContainer = new GridLayout();
    JButton buttonOK = new JButton();
    JLabel empty4 = new JLabel();
    JLabel empty5 = new JLabel();
    JLabel empty6 = new JLabel();
    BorderLayout layoutProjectOption = new BorderLayout();
    JPanel panelProjectDescr = new JPanel();
    JScrollPane projectDescrScrollPane = new JScrollPane();
    JTextPane projectDescriptionTextPane = new JTextPane();
    BorderLayout layoutProjectDescr = new BorderLayout();
    JLabel labelProjectDecription = new JLabel();
    JLabel labelProjectCommercialModel = new JLabel();
    JPanel panelProjectCommercialModel = new JPanel();
    BorderLayout layoutProjectCommercialModel = new BorderLayout();
    JComboBox comboBoxProjectCommercialModel = null;
    JComboBox comboBoxProjectArchitecturalModel = null;
    JLabel labelProjectArchitecturalModel = new JLabel();
    JPanel panelProjectArchitecturalModel = new JPanel();
    BorderLayout layoutProjectArchitecturalModel = new BorderLayout();

//	PolitellaFrame parentFrame=null;

    public NewProjectDialog(PolitellaFrame pFrame) {
        super(pFrame);

//		this.parentFrame=parentFrame;

        try {
			//rimuovo la voce COMMERCIAL_MODEL_ALL dalle categorie.
			// quella voce mi serve solo nelle ricerche
//			this.comboBoxProjectCommercialModel= new JComboBox((this.parentFrame.userInterface.GetProjectTypeDescription())[0]);
			this.comboBoxProjectCommercialModel= new JComboBox((ProjectType.prjTypeDescription)[0]);
			this.comboBoxProjectCommercialModel.removeItemAt(0);

			//rimuovo la voce ARCHITECTURAL_MODEL_ALL dalle categorie.
			// quella voce mi serve solo nelle ricerche
//			this.comboBoxProjectArchitecturalModel= new JComboBox((this.parentFrame.userInterface.GetProjectTypeDescription())[1]);
			this.comboBoxProjectArchitecturalModel= new JComboBox((ProjectType.prjTypeDescription)[1]);
			this.comboBoxProjectArchitecturalModel.removeItemAt(0);

            jbInit();
		    pack();

	        //Center the window
		    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	        Dimension frameSize = this.getSize();
            if (frameSize.height > screenSize.height) {
                frameSize.height = screenSize.height;
	        }
			if (frameSize.width > screenSize.width) {
                frameSize.width = screenSize.width;
            }
            this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
            this.setVisible(true);
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {
        this.getContentPane().setLayout(layoutNewProject);
        this.setDefaultCloseOperation(0);
        this.setResizable(false);
        this.setModal(true);
        this.setTitle("Create a New Project");
        panelButtonBar.setLayout(layoutButtonBar);
        panelProjectOption.setLayout(layoutProjectOption);
        layoutNewProject.setHgap(10);
        layoutNewProject.setVgap(10);
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonCancel_actionPerformed(e);
            }
        });
        buttonCancel.setText("Cancel");
        layoutButtonBar.setHgap(10);
        layoutButtonBar.setVgap(5);
        panelButtonBarContainer.setLayout(layoutButtonBarContainer);
        layoutButtonBarContainer.setColumns(2);
        layoutButtonBarContainer.setHgap(100);
        buttonOK.setText("OK");
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonOK_actionPerformed(e);
            }
        });
        projectDescrScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        projectDescrScrollPane.setBorder(BorderFactory.createLoweredBevelBorder());
        projectDescriptionTextPane.setSelectionColor(new Color(100, 36, 106));
        panelProjectDescr.setLayout(layoutProjectDescr);
        layoutProjectDescr.setHgap(10);
        layoutProjectDescr.setVgap(10);
        layoutProjectOption.setHgap(5);
        layoutProjectOption.setVgap(5);
        panelProjectDescr.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),BorderFactory.createEmptyBorder(5,5,5,5)));
        panelProjectDescr.setPreferredSize(new Dimension(118, 100));
        labelProjectDecription.setToolTipText("Give a short description of the new project");
        labelProjectDecription.setHorizontalAlignment(SwingConstants.LEFT);
        labelProjectDecription.setHorizontalTextPosition(SwingConstants.LEFT);
        labelProjectDecription.setText("Description             ");
        labelProjectCommercialModel.setText("Commercial Model");
        labelProjectCommercialModel.setHorizontalTextPosition(SwingConstants.LEFT);
        labelProjectCommercialModel.setHorizontalAlignment(SwingConstants.LEFT);
        labelProjectCommercialModel.setToolTipText("Choice the type of the new project");
        panelProjectCommercialModel.setLayout(layoutProjectCommercialModel);
        panelProjectCommercialModel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),BorderFactory.createEmptyBorder(5,5,5,5)));
        layoutProjectCommercialModel.setHgap(10);
        layoutProjectCommercialModel.setVgap(10);
        comboBoxProjectCommercialModel.setSelectedIndex(-1);
        comboBoxProjectCommercialModel.setDoubleBuffered(true);
        comboBoxProjectArchitecturalModel.setDoubleBuffered(true);
        comboBoxProjectArchitecturalModel.setSelectedIndex(-1);
        labelProjectArchitecturalModel.setToolTipText("Choice the type of the new project");
        labelProjectArchitecturalModel.setHorizontalAlignment(SwingConstants.LEFT);
        labelProjectArchitecturalModel.setHorizontalTextPosition(SwingConstants.LEFT);
        labelProjectArchitecturalModel.setText("Architectural Model");
        panelProjectArchitecturalModel.setLayout(layoutProjectArchitecturalModel);
        panelProjectArchitecturalModel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),BorderFactory.createEmptyBorder(5,5,5,5)));
        layoutProjectArchitecturalModel.setHgap(10);
        layoutProjectArchitecturalModel.setVgap(10);
        this.getContentPane().add(panelButtonBar, BorderLayout.SOUTH);
        panelButtonBar.add(panelButtonBarContainer, BorderLayout.CENTER);
        panelButtonBarContainer.add(buttonOK, null);
        panelButtonBarContainer.add(buttonCancel, null);
        panelButtonBar.add(empty4, BorderLayout.SOUTH);
        panelButtonBar.add(empty5, BorderLayout.WEST);
        panelButtonBar.add(empty6, BorderLayout.EAST);
        this.getContentPane().add(panelProjectOption, BorderLayout.CENTER);

        panelProjectOption.add(panelProjectDescr, BorderLayout.SOUTH);
        panelProjectDescr.add(projectDescrScrollPane, BorderLayout.CENTER);
        panelProjectDescr.add(labelProjectDecription, BorderLayout.WEST);
        panelProjectOption.add(panelProjectCommercialModel, BorderLayout.NORTH);
        panelProjectCommercialModel.add(labelProjectCommercialModel, BorderLayout.WEST);
        panelProjectCommercialModel.add(comboBoxProjectCommercialModel, BorderLayout.CENTER);
        panelProjectOption.add(panelProjectArchitecturalModel, BorderLayout.CENTER);
        panelProjectArchitecturalModel.add(comboBoxProjectArchitecturalModel, BorderLayout.CENTER);
        panelProjectArchitecturalModel.add(labelProjectArchitecturalModel, BorderLayout.WEST);
        projectDescrScrollPane.getViewport().add(projectDescriptionTextPane, null);

        this.getContentPane().add(empty1, BorderLayout.WEST);
        this.getContentPane().add(empty2, BorderLayout.NORTH);
        this.getContentPane().add(empty3, BorderLayout.EAST);
    }

    void buttonCancel_actionPerformed(ActionEvent e) {
		this.dispose();
    }

    void buttonOK_actionPerformed(ActionEvent e) {
		PolitellaFrame pFrame = (PolitellaFrame)this.getParent();


		// chiamo UserInterface per impostare i parametri settati nella dialogue
		short[] prjIndexTypes=new short[2];
		if(((prjIndexTypes[0]=(short)this.comboBoxProjectCommercialModel.getSelectedIndex())!=-1) &&
		((prjIndexTypes[1]=(short)this.comboBoxProjectArchitecturalModel.getSelectedIndex())!=-1)) {
			//ho selezionato una tipologia di progetto
			String prjDescr=this.projectDescriptionTextPane.getText().replace('\n',' ').replace('\r',' ').trim();
			if(prjDescr.compareTo("")!=0)    {
				//ho fornito una descrizione
				String fileName = (new Long((new java.util.Random()).nextLong())).toString();

				File pathBase=pFrame.userInterface.projectManager.GetProjectFile(0,true,false);
				File prjFilePath = new File(pathBase,fileName);
				while(prjFilePath.exists()) {
					prjFilePath=null; fileName=null;
				    fileName = (new Long((new java.util.Random()).nextLong())).toString();
					prjFilePath = new File(pathBase,fileName);
				}
				prjFilePath.mkdir();
				File prjFile = new File(prjFilePath,fileName + ".xml");

		        this.dispose();
				pFrame.userInterface.NewProjectShare(prjIndexTypes,prjDescr,prjFile);
			}
			else
				// non ho scritto nulla, devo scrivere qualcosa
	    		JOptionPane.showMessageDialog(this,"You must give a short description of the new project","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
		}
		else
			// non ho selzionato nulla, devo selezionare qualcosa
			JOptionPane.showMessageDialog(this,"You must choice a category of project","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
    }
}