/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import Utility.ProjectType;

import java.util.Vector;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import javax.swing.border.*;

/**
 * Gestisce la finestra di dialogo per la ricerca di un progetto all'interno della comunit
 */
class NewSearchDialog extends JDialog {

    BorderLayout layoutNewSearch = new BorderLayout();
    JPanel panelButtonBar = new JPanel();
    JPanel panelProjectOption = new JPanel();
    JLabel empty1 = new JLabel();
    JLabel empty2 = new JLabel();
    BorderLayout layoutButtonBar = new BorderLayout();
    JPanel panelButtonBarContainer = new JPanel();
    JButton buttonOK = new JButton();
    JButton buttonCancel = new JButton();
    GridLayout layoutButtonBarContainer = new GridLayout();
    JLabel empty4 = new JLabel();
    JLabel empty5 = new JLabel();
    JLabel empty6 = new JLabel();
    JPanel panelProjectModel = new JPanel();
    JPanel panelProjectDescr = new JPanel();
    JScrollPane projectDescrScrollPane = new JScrollPane();
    JTextPane projectDescriptionTextPane = new JTextPane();
    JLabel labelProjectDecription = new JLabel();
    BorderLayout layoutProjectOption = new BorderLayout();
    JPanel panelProjectArchitecturalModel = new JPanel();
    JPanel panelProjectCommercialModel = new JPanel();
    JLabel labelProjectCommercialModel = new JLabel();
    JComboBox comboBoxProjectArchitecturalModel = null;
    BorderLayout layoutProjectModel = new BorderLayout();
    BorderLayout layoutProjectDescr = new BorderLayout();
    JPanel panelProjectBusMod = new JPanel();
    BorderLayout layoutProjectBusMod = new BorderLayout();
    ButtonGroup buttonGroupBusComponentType = new ButtonGroup();
    JLabel empty3 = new JLabel();
    JPanel panelProjectBusModelCompSelec = new JPanel();
    JPanel panelProjectBusModCompType = new JPanel();
    BorderLayout layoutProjectBusModelCompSelec = new BorderLayout();
    BorderLayout layoutProjectBusModCompType = new BorderLayout();
    JRadioButton radioButtonBusRelationship = new JRadioButton();
    JComboBox comboBoxBusRelationship = null;
    JComboBox comboBoxProjectCommercialModel = null;
    JLabel labelProjectArchitecturalModel = new JLabel();
    BorderLayout layoutProjectCommercialModel = new BorderLayout();
    BorderLayout layoutProjectArchitecturalModel = new BorderLayout();
    JRadioButton radioButtonBusRole = new JRadioButton();
    JComboBox comboBoxBusRole = null;

//	PolitellaFrame parentFrame=null;

    public NewSearchDialog(PolitellaFrame pFrame) {
        super(pFrame);

//		this.parentFrame=parentFrame;

        try {

//			this.comboBoxProjectCommercialModel= new JComboBox((this.parentFrame.userInterface.GetProjectTypeDescription())[0]);
			this.comboBoxProjectCommercialModel= new JComboBox((ProjectType.prjTypeDescription)[0]);
//		    this.comboBoxProjectArchitecturalModel= new JComboBox((this.parentFrame.userInterface.GetProjectTypeDescription())[1]);
		    this.comboBoxProjectArchitecturalModel= new JComboBox((ProjectType.prjTypeDescription)[1]);

			Vector busComp = new Vector();
			String[] busCompDescr = ProjectType.prjTypeDescription[2];
			for(int i=0;i<ProjectType.numBusinessRole+1;i++)
			//il +1 serve per copiare anche il campo "Any Business Role"
				busComp.add(busCompDescr[i]);
		    this.comboBoxBusRole = new JComboBox((Vector)busComp.clone());
			busComp.clear();
			for(int i=ProjectType.numBusinessRole+1;i<busCompDescr.length-2;i++)
			//il +1 serve per copiare anche il campo "Any Business Relationship"
			//il -2 serve per non fargli prendere le 2 bus. rela. fittizie necessarie per terminare i 2 lacci
				busComp.add(busCompDescr[i]);
			this.comboBoxBusRelationship = new JComboBox(busComp);

            jbInit();
		    pack();

	        //Center the window
		    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	        Dimension frameSize = this.getSize();
            if (frameSize.height > screenSize.height) {
                frameSize.height = screenSize.height;
	        }
			if (frameSize.width > screenSize.width) {
                frameSize.width = screenSize.width;
            }
            this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
            this.setVisible(true);
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {
        this.getContentPane().setLayout(layoutNewSearch);
        this.setDefaultCloseOperation(0);
        this.setResizable(false);
        this.setModal(true);
        this.setTitle("Search a Project");
        panelButtonBar.setLayout(layoutButtonBar);
        panelProjectOption.setLayout(layoutProjectOption);
        layoutNewSearch.setHgap(10);
        layoutNewSearch.setVgap(10);
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonOK_actionPerformed(e);
            }
        });
        buttonOK.setText("OK");
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonCancel_actionPerformed(e);
            }
        });
        buttonCancel.setText("Cancel");
        panelButtonBarContainer.setLayout(layoutButtonBarContainer);
        layoutButtonBarContainer.setColumns(2);
        layoutButtonBarContainer.setHgap(100);
        layoutButtonBarContainer.setVgap(10);
        layoutButtonBar.setHgap(10);
        layoutButtonBar.setVgap(10);
        projectDescrScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        projectDescrScrollPane.setBorder(BorderFactory.createLoweredBevelBorder());
        projectDescriptionTextPane.setSelectionColor(new Color(100, 36, 106));
        labelProjectDecription.setToolTipText("Give a short description of the project to search");
        labelProjectDecription.setHorizontalAlignment(SwingConstants.LEFT);
        labelProjectDecription.setHorizontalTextPosition(SwingConstants.LEFT);
        labelProjectDecription.setText("Description           ");
        layoutProjectOption.setHgap(5);
        layoutProjectOption.setVgap(5);
        labelProjectCommercialModel.setToolTipText("Choice the type of the project to search");
        labelProjectCommercialModel.setHorizontalAlignment(SwingConstants.LEFT);
        labelProjectCommercialModel.setHorizontalTextPosition(SwingConstants.LEFT);
        labelProjectCommercialModel.setText("Commercial Type");
//        comboBoxProjectArchitecturalModel.setSelectedIndex(-1);
        comboBoxProjectArchitecturalModel.setDoubleBuffered(true);
        panelProjectModel.setLayout(layoutProjectModel);
        layoutProjectModel.setHgap(5);
        layoutProjectModel.setVgap(5);
        panelProjectCommercialModel.setLayout(layoutProjectCommercialModel);
        panelProjectArchitecturalModel.setLayout(layoutProjectArchitecturalModel);
        panelProjectDescr.setLayout(layoutProjectDescr);
        layoutProjectDescr.setHgap(10);
        layoutProjectDescr.setVgap(10);
        panelProjectDescr.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),BorderFactory.createEmptyBorder(5,5,5,5)));
        panelProjectDescr.setPreferredSize(new Dimension(118, 100));
        panelProjectBusMod.setLayout(layoutProjectBusMod);
        empty3.setToolTipText("");
        panelProjectBusModelCompSelec.setLayout(layoutProjectBusModelCompSelec);
        panelProjectBusModCompType.setLayout(layoutProjectBusModCompType);
        radioButtonBusRelationship.setText("Bus. Relationship");
        radioButtonBusRelationship.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                radioButtonBusRelationship_actionPerformed(e);
            }
        });
        panelProjectBusMod.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),BorderFactory.createEmptyBorder(5,5,5,5)));
        comboBoxProjectCommercialModel.setDoubleBuffered(true);
        comboBoxProjectCommercialModel.setMaximumRowCount(9);
//        comboBoxProjectCommercialModel.setSelectedIndex(-1);
        labelProjectArchitecturalModel.setText("Architectural Type");
        labelProjectArchitecturalModel.setHorizontalTextPosition(SwingConstants.LEFT);
        labelProjectArchitecturalModel.setHorizontalAlignment(SwingConstants.LEFT);
        labelProjectArchitecturalModel.setToolTipText("Choice the type of the project to search");
        layoutProjectCommercialModel.setHgap(10);
        layoutProjectCommercialModel.setVgap(10);
        panelProjectCommercialModel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),BorderFactory.createEmptyBorder(5,5,5,5)));
        layoutProjectArchitecturalModel.setHgap(10);
        layoutProjectArchitecturalModel.setVgap(10);
        radioButtonBusRole.setSelected(true);
        radioButtonBusRole.setText("Business Role");
        radioButtonBusRole.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                radioButtonBusRole_actionPerformed(e);
            }
        });
        panelProjectArchitecturalModel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),BorderFactory.createEmptyBorder(5,5,5,5)));
        comboBoxBusRelationship.setEnabled(false);
		this.comboBoxBusRole.setMaximumRowCount(ProjectType.numBusinessRole+1);
		this.comboBoxBusRelationship.setMaximumRowCount(ProjectType.numBusinessRelationship+1);
        this.getContentPane().add(panelButtonBar, BorderLayout.SOUTH);
        panelButtonBar.add(panelButtonBarContainer, BorderLayout.CENTER);
        panelButtonBarContainer.add(buttonOK, null);
        panelButtonBarContainer.add(buttonCancel, null);
        panelButtonBar.add(empty4, BorderLayout.EAST);
        panelButtonBar.add(empty5, BorderLayout.WEST);
        panelButtonBar.add(empty6, BorderLayout.SOUTH);
        this.getContentPane().add(panelProjectOption, BorderLayout.CENTER);
        panelProjectOption.add(panelProjectModel, BorderLayout.NORTH);
        panelProjectModel.add(panelProjectCommercialModel, BorderLayout.NORTH);
        panelProjectCommercialModel.add(labelProjectCommercialModel, BorderLayout.WEST);
        panelProjectCommercialModel.add(comboBoxProjectCommercialModel, BorderLayout.CENTER);
        panelProjectModel.add(panelProjectArchitecturalModel, BorderLayout.CENTER);
        panelProjectArchitecturalModel.add(comboBoxProjectArchitecturalModel, BorderLayout.CENTER);
        panelProjectArchitecturalModel.add(labelProjectArchitecturalModel, BorderLayout.WEST);
        panelProjectOption.add(panelProjectDescr, BorderLayout.CENTER);
        panelProjectDescr.add(labelProjectDecription, BorderLayout.WEST);
        panelProjectDescr.add(projectDescrScrollPane, BorderLayout.CENTER);
        panelProjectOption.add(panelProjectBusMod, BorderLayout.SOUTH);
        panelProjectBusMod.add(panelProjectBusModelCompSelec, BorderLayout.CENTER);
        panelProjectBusModelCompSelec.add(comboBoxBusRelationship, BorderLayout.SOUTH);
        panelProjectBusModelCompSelec.add(comboBoxBusRole, BorderLayout.NORTH);
        panelProjectBusMod.add(panelProjectBusModCompType, BorderLayout.WEST);
        panelProjectBusModCompType.add(radioButtonBusRelationship, BorderLayout.CENTER);
        panelProjectBusModCompType.add(radioButtonBusRole, BorderLayout.NORTH);
        projectDescrScrollPane.getViewport().add(projectDescriptionTextPane, null);
        this.getContentPane().add(empty1, BorderLayout.WEST);
        this.getContentPane().add(empty2, BorderLayout.EAST);
        this.getContentPane().add(empty3, BorderLayout.NORTH);
        buttonGroupBusComponentType.add(radioButtonBusRelationship);
        buttonGroupBusComponentType.add(radioButtonBusRole);
    }

    void buttonCancel_actionPerformed(ActionEvent e) {
		this.dispose();
    }

    void buttonOK_actionPerformed(ActionEvent e) {
		PolitellaFrame pFrame = (PolitellaFrame)this.getParent();

		short[] prjIndexTypes= new short[3];
		//Recupero le chiavi di ricerca
		//Tipologia del progetto
		//devo decrementarle per tener conto anche dei campi Any
	    prjIndexTypes[0]=(short)(this.comboBoxProjectCommercialModel.getSelectedIndex()-1);
	    prjIndexTypes[1]=(short)(this.comboBoxProjectArchitecturalModel.getSelectedIndex()-1);

	    //Componente del Bus Model incluso
		if(this.comboBoxBusRole.isEnabled())
		//devo decrementare per tener conto anche del campo Any Business Role
			prjIndexTypes[2]= (short)(this.comboBoxBusRole.getSelectedIndex()-1);

		if(this.comboBoxBusRelationship.isEnabled())    {
		//devo decrementare per tener conto anche del campo Any Business Relationship
			if(this.comboBoxBusRelationship.getSelectedIndex()==0)
			//ho scelto Any Business Relationship
				prjIndexTypes[2]= (short)(this.comboBoxBusRelationship.getSelectedIndex()-1);
			else
			//ho scelto una Business Relationship
			//devo aumentare di ProjectType.numBusinessRole perch nel vettore dei bus comp le relationship sono messe
			//in coda a tutti i bus role
				prjIndexTypes[2]= (short)(this.comboBoxBusRelationship.getSelectedIndex()-1+ProjectType.numBusinessRole);
		}

		//Descrizione del progetto
		String prjDescr=this.projectDescriptionTextPane.getText().replace('\n',' ').replace('\r',' ').trim();
		if(prjDescr.compareTo("")==0)
			//non ho fornito una descrizione allora cerco tutti i progetti di una certa categoria
			prjDescr=null;

		// chiamo UserInterface per avviare la ricerca
		pFrame.userInterface.NewSearch(prjIndexTypes,prjDescr);
	    this.dispose();
    }

    void radioButtonBusRole_actionPerformed(ActionEvent e) {
		this.comboBoxBusRole.setEnabled(true);
		this.comboBoxBusRelationship.setEnabled(false);
    }

    void radioButtonBusRelationship_actionPerformed(ActionEvent e) {
		this.comboBoxBusRelationship.setEnabled(true);
		this.comboBoxBusRole.setEnabled(false);
    }
}