/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import Utility.PolitellaException;
import Utility.BusinessModelComponent;

import java.lang.Long;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.table.AbstractTableModel;

import java.util.Vector;
import java.util.Enumeration;

import java.io.File;

import com.sun.java.swing.plaf.motif.*;
import javax.swing.plaf.metal.*;
import com.sun.java.swing.plaf.windows.*;

/**
 * Definisce il frame dell'applicazione
 */
class PolitellaFrame extends JFrame {
    JMenuBar menuBar = new JMenuBar();
    JMenu menuFileRoot = new JMenu();
    JMenuItem menuFileItemExit = new JMenuItem();
    JMenuItem menuFileItemSave = new JMenuItem();
    JMenuItem menuFileItemSetup = new JMenuItem();
    JMenuItem menuFileItemConnect = new JMenuItem();
    JMenu menuActionRoot = new JMenu();
    JMenuItem menuProjectItemNewProject = new JMenuItem();
    JMenuItem menuProjectItemSearchProject = new JMenuItem();
    JMenuItem menuActionItemDownloadItem = new JMenuItem();
    JMenu menuActionItemDeleteSharedRoot = new JMenu();
    JMenuItem menuActionItemDeleteSharedItemOnly1 = new JMenuItem();
    JMenuItem menuActionItemDeleteSharedItemAll = new JMenuItem();
    JMenu menuActionItemClearFoundRoot = new JMenu();
    JMenuItem menuActionItemClearFoundItemOnly1 = new JMenuItem();
    JMenuItem menuActionItemClearFoundItemAll = new JMenuItem();
    BorderLayout mainFrameLayout = new BorderLayout();
    JToolBar toolBar = new JToolBar();
    JTabbedPane tabbedPaneWorking = new JTabbedPane();
    JButton buttonConnect = new JButton();
    JPanel panelSharedProjects = new JPanel();
    JPanel panelFoundProjects = new JPanel();
    JPanel statusBarPanel = new JPanel();
    JLabel statusBarConnectionsStatus = new JLabel();
    JLabel statusBarDownloadsStatus = new JLabel();
    GridLayout statusBarLayout = new GridLayout();
    JLabel statusBarUploadsStatus = new JLabel();
    JMenuItem menuFileItemDisconnect = new JMenuItem();
    JMenu menuHelpRoot = new JMenu();
    JMenuItem menuHelpAboutItem = new JMenuItem();
    JPopupMenu menuPopUpDefaultRoot = new JPopupMenu();
    JMenuItem menuPopUpItemConnect = new JMenuItem();
    JMenuItem menuPopUpItemDisconnect = new JMenuItem();
    JMenuItem menuPopUpItemNewProject = new JMenuItem();
    JMenuItem menuPopUpItemSearchProject = new JMenuItem();
    JMenuItem menuPopUpItemDonwloadProject = new JMenuItem();
    JMenu menuPopUpItemDeleteSharedRoot = new JMenu();
    JMenuItem menuPopUpItemDeleteSharedItemOnly1 = new JMenuItem();
    JMenu menuPopUpItemClearFoundRoot = new JMenu();
    JMenuItem menuPopUpItemClearFoundItemOnly1 = new JMenuItem();
    JMenuItem menuPopUpItemDeleteSharedItemAll = new JMenuItem();
    JMenuItem menuPopUpItemClearFoundItemAll = new JMenuItem();
    JButton buttonDisconnect = new JButton();
    JButton buttonSearchPrj = new JButton();
    JButton buttonSaveAllDb_Setups = new JButton();
    JButton buttonNewPrj = new JButton();
    JButton buttonExit = new JButton();
    JButton buttonDownloadItem = new JButton();
    JPanel panelViewProject = new JPanel();
    JMenu menuNetworkInfoRoot = new JMenu();
    JMenuItem menuNetworkInfoItemViewActiveConnections = new JMenuItem();
    JMenuItem menuNetworkInfoItemViewActiveUploads = new JMenuItem();
    JMenuItem menuNetworkInfoItemViewActiveDownloads = new JMenuItem();
    BorderLayout layoutFoundProjects = new BorderLayout();
    JScrollPane scrollPaneFoundProjects = new JScrollPane();
    BorderLayout layoutSharedProjects = new BorderLayout();
    BorderLayout layoutViewProject = new BorderLayout();
    JScrollPane scrollPaneSharedProjects = new JScrollPane();
    TitledBorder titledBorderViewProject;
    JMenuItem menuActionItemViewItem = new JMenuItem();
    JMenuItem menuPopUpItemViewSelectedProject = new JMenuItem();
    JSplitPane splitPaneViewProject = new JSplitPane();
    JScrollPane scrollPaneViewPrjBusinessModelComponents = new JScrollPane();
    JScrollPane scrollPaneViewProjectInfos = new JScrollPane();
    JTree treeViewProjectInfos = null;
    JPanel panelDownProjects = new JPanel();
    BorderLayout layoutDownProjects = new BorderLayout();
    JScrollPane scrollPaneDownProjects = new JScrollPane();
    JMenu menuPopUpItemDeleteDownRoot = new JMenu();
    JMenuItem menuPopUpItemDeleteDownItemOnly1 = new JMenuItem();
    JMenuItem menuPopUpItemDeleteDownItemAll = new JMenuItem();
    JMenu menuActionItemDeleteDownRoot = new JMenu();
    JMenuItem menuActionItemDeleteDownItemOnly1 = new JMenuItem();
    JMenuItem menuActionItemDeleteDownItemAll = new JMenuItem();
    JMenu menuProjectRoot = new JMenu();
    JMenuItem menuProjectItemSaveCurrent = new JMenuItem();
    JPopupMenu menuPopUpManageRoot = new JPopupMenu();
    JCheckBoxMenuItem menuPopUpManageItemEditPrj = new JCheckBoxMenuItem();
    JMenuItem menuPopUpManageItemSaveCurrPrj = new JMenuItem();
    JMenuItem menuPopUpManageItemDownAllComp = new JMenuItem();
    JMenuItem menuPopUpManageItemAddThisComp = new JMenuItem();
    JMenuItem menuPopUpManageItemCloseCurrPrj = new JMenuItem();
    JMenuItem menuProjectItemCloseCurrent = new JMenuItem();
    JMenuItem menuProjectItemAddThisComp = new JMenuItem();
    JMenuItem menuProjectItemDownAllComp = new JMenuItem();
    JCheckBoxMenuItem menuProjectItemEditCurrPrj = new JCheckBoxMenuItem();
    JButton buttonViewItem = new JButton();
    JButton buttonSaveCurrPrj = new JButton();
    JMenuItem menuPopUpManageItemEditThisComp = new JMenuItem();
    JMenuItem menuPopUpManageItemDownThisComp = new JMenuItem();
    JMenuItem menuProjectItemDownThisComp = new JMenuItem();
    JMenuItem menuProjectItemEditThisComp = new JMenuItem();
    JMenuItem menuProjectItemDownSelectedComp = new JMenuItem();
    JMenuItem menuPopUpManageItemDownSelectedComp = new JMenuItem();
    JPanel panelViewPrjTool = new JPanel();
    BorderLayout layoutViewPrjTool = new BorderLayout();
    JCheckBox checkBoxViewPrjEditProject = new JCheckBox();
    JButton buttonOpenPrjDir = new JButton();

	//tabelle dei progetti
	ProjectTableModel tableModelFoundProjects = new ProjectTableModel();
	JTable tableFoundProjects = new JTable(tableModelFoundProjects);
    ProjectTableModel tableModelSharedProjects= new ProjectTableModel();
    JTable tableSharedProjects = new JTable(tableModelSharedProjects);
	ProjectTableModel tableModelDownProjects = new ProjectTableModel();
	JTable tableDownProjects = new JTable(tableModelDownProjects);

	// look & feel
	MetalLookAndFeel metalLF = new MetalLookAndFeel();
	MotifLookAndFeel motifLF = new MotifLookAndFeel();
	WindowsLookAndFeel windowsLF = new WindowsLookAndFeel();
	String actualLookAndFeel= "none";

	//Identificativo del'oggetto UserInterface
	UserInterface userInterface= null;

	//identificativo del prj correntemente visualizzato
	ProjectViewing currentPrjViewing=null;

	//identificativo della dialog contenente l'indicatore di progresso dei download
	ConnectionDownloadsInProgressDialog connectionDownloadsInProgressDialog = null;

    public PolitellaFrame(UserInterface userInterface) {
        try {
            this.userInterface=userInterface;
			this.connectionDownloadsInProgressDialog = new ConnectionDownloadsInProgressDialog(this);

		    pack();

		    this.currentPrjViewing= new ProjectViewing(this);

			jbInit();

			this.setSize(500,500);

		    this.tableFoundProjects.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		    this.tableSharedProjects.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		    this.tableDownProjects.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

	        //Center the window
		    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	        Dimension frameSize = this.getSize();
            if (frameSize.height > screenSize.height) {
                frameSize.height = screenSize.height;
	        }
			if (frameSize.width > screenSize.width) {
                frameSize.width = screenSize.width;
            }
            this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
			this.UpdateLookAndFeel("Windows");

        }   catch(Exception e) {
//                e.printStackTrace();
        }

		// imposto la posizione della barra di divisione dello SplitPane nel tab
		// ViewProject
		int i = (int)(this.splitPaneViewProject.getHeight()*0.80);
        splitPaneViewProject.setDividerLocation(i);

//		this.tabbedPaneWorking.setSelectedComponent(this.panelSharedProjects);
		this.connectionDownloadsInProgressDialog.setTitle("Start in progress...");
		this.connectionDownloadsInProgressDialog.setVisible(true);
    }

	/**
	 * Aggiorno la status bar, se ricevo -1 su uno dei parametri vuol dire che
	 * non devo modificare il campo associato
	 */
	 synchronized void UpdateStatusBar(int activeConnections, int activeDownloads, int activeUploads) {
		boolean status;
		if(activeConnections!=-1)    {
			if(activeConnections==0)    {
				this.statusBarConnectionsStatus.setText("Connections: None");
				status=false;
	    		this.menuFileItemConnect.setEnabled(true);
		    	this.menuFileItemDisconnect.setEnabled(false);
		        this.menuProjectItemSearchProject.setEnabled(false);
				this.menuPopUpItemConnect.setEnabled(true);
		    	this.menuPopUpItemDisconnect.setEnabled(false);
				this.menuPopUpItemSearchProject.setEnabled(false);
				this.buttonDisconnect.setEnabled(false);
				this.buttonConnect.setEnabled(true);
				this.buttonSearchPrj.setEnabled(false);
			}
			else    {
				this.statusBarConnectionsStatus.setText("Connections: "+activeConnections);
				status=true;

				this.menuFileItemConnect.setEnabled(false);
	        	this.menuFileItemDisconnect.setEnabled(true);
			    this.menuProjectItemSearchProject.setEnabled(true);
				this.menuPopUpItemConnect.setEnabled(false);
		    	this.menuPopUpItemDisconnect.setEnabled(true);
				this.menuPopUpItemSearchProject.setEnabled(true);
				this.buttonConnect.setEnabled(false);
				this.buttonDisconnect.setEnabled(true);
				this.buttonSearchPrj.setEnabled(true);
				this.connectionDownloadsInProgressDialog.setVisible(false);
			}
			this.menuNetworkInfoItemViewActiveConnections.setEnabled(status);
            this.userInterface.SetStatusAnnuncioTimer(status);
		}
		if(activeDownloads!=-1) {
			if(activeDownloads==0)  {
				this.statusBarDownloadsStatus.setText("Downloads: None");
				status=false;
			}
			else    {
				this.statusBarDownloadsStatus.setText("Downloads: "+activeDownloads);
				status=true;
			}
			this.connectionDownloadsInProgressDialog.setTitle("Downloads in progress...");
			this.connectionDownloadsInProgressDialog.setVisible(status);
			this.menuNetworkInfoItemViewActiveDownloads.setEnabled(status);
		}
		if(activeUploads!=-1)   {
//		System.out.println(activeUploads);
			if(activeUploads==0)    {
				this.statusBarUploadsStatus.setText("Uploads: None");
				status=false;
			}
			else    {
				this.statusBarUploadsStatus.setText("Uploads: "+activeUploads);
				status=true;
			}
			this.menuNetworkInfoItemViewActiveUploads.setEnabled(status);
		}
	 }

	/**
	 * Visualizzo un progetto
	 */
	 void ViewProject(Long prjID, String[] prjType, String prjDescr, File prjFile, Vector prjBusModelComponents,/*String prjPeerLocation, */boolean isEditable/*,boolean isNew*/) throws PolitellaException{
		if(this.currentPrjViewing.IsViewed())  {
			//sto visualizzando gi un altro progetto, attenzione
			int risp=JOptionPane.showConfirmDialog(this,"You are analizing another project.\nDo you really want closing it and open this one?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
			if(risp==JOptionPane.YES_OPTION)
				//voglio caricare un altro progetto
				this.menuProjectItemCloseCurrent_actionPerformed(null);
			else
				//non volgio caricare un altro progetto
				return;
		}
		//non sto visualizzando nessun altro progetto, carico quello selezionato
		this.currentPrjViewing.SetProjectViewingObj(prjID,prjType,prjDescr,prjFile,prjBusModelComponents/*,prjPeerLocation*/,isEditable/*,isNew*/);

		if(isEditable)  {
			//  un prj share posso editarlo
			this.checkBoxViewPrjEditProject.setEnabled(true);
			this.menuPopUpManageItemEditPrj.setEnabled(true);
			this.menuProjectItemEditCurrPrj.setEnabled(true);
		}
		else    {
			//  un prj down posso scaricare in auto tutti i componenti
			this.menuProjectItemDownAllComp.setEnabled(true);
			this.menuPopUpManageItemDownAllComp.setEnabled(true);
		}

		this.buttonOpenPrjDir.setEnabled(true);

		this.menuProjectItemCloseCurrent.setEnabled(true);
		this.menuPopUpManageItemCloseCurrPrj.setEnabled(true);

		this.treeViewProjectInfos.setEnabled(true);
		if(isEditable)
		//visualizzo un prj share
			this.titledBorderViewProject.setTitle("Shared\\"+prjID.toString());
		else
		//visualizzo un prj down
			this.titledBorderViewProject.setTitle("Downloaded\\"+prjID.toString());
		this.tabbedPaneWorking.setSelectedComponent(this.panelViewProject);

		this.panelViewProject.repaint();
	 }

	/**
	 * Aggiorna il contenuto delle tabelle di progetti gestiti
	 */
	void UpdateTables() {
		// aggiorno la tabella dei prjFound
		this.tableModelFoundProjects.setRowsValue(this.userInterface.projectManager.GetInfoAllPrjFound());
		if(!this.tableModelFoundProjects.rowsData.isEmpty())    {
			this.menuPopUpItemClearFoundRoot.setEnabled(true);
			this.menuActionItemClearFoundRoot.setEnabled(true);
//            this.menuActionItemDownloadItem.setEnabled(true);
//            this.menuPopUpItemDonwloadProject.setEnabled(true);
//            this.buttonDownloadItem.setEnabled(true);
		}
		else    {
			this.menuPopUpItemClearFoundRoot.setEnabled(false);
			this.menuActionItemClearFoundRoot.setEnabled(false);
//            this.menuActionItemDownloadItem.setEnabled(false);
//            this.menuPopUpItemDonwloadProject.setEnabled(false);
//            this.buttonDownloadItem.setEnabled(false);
		}
		// aggiorno la tabella dei prjDown
		this.tableModelDownProjects.setRowsValue(this.userInterface.projectManager.GetInfoAllPrjDown());
		if(!this.tableModelDownProjects.rowsData.isEmpty())    {
			this.menuPopUpItemDeleteDownRoot.setEnabled(true);
			this.menuActionItemDeleteDownRoot.setEnabled(true);
//			this.menuActionItemViewItem.setEnabled(true);
//			this.menuPopUpItemViewSelectedProject.setEnabled(true);
//			this.buttonViewItem.setEnabled(true);
		}
		else    {
			this.menuPopUpItemDeleteDownRoot.setEnabled(false);
			this.menuActionItemDeleteDownRoot.setEnabled(false);
//			this.menuActionItemViewItem.setEnabled(false);
//			this.menuPopUpItemViewSelectedProject.setEnabled(false);
//			this.buttonViewItem.setEnabled(false);
		}

		// aggiorno la tabella dei prjShare
		this.tableModelSharedProjects.setRowsValue(this.userInterface.projectManager.GetInfoAllPrjShare());
		if(!this.tableModelSharedProjects.rowsData.isEmpty())   {
			this.menuPopUpItemDeleteSharedRoot.setEnabled(true);
			this.menuActionItemDeleteSharedRoot.setEnabled(true);
//			this.menuActionItemViewItem.setEnabled(true);
//			this.menuPopUpItemViewSelectedProject.setEnabled(true);
//			this.buttonViewItem.setEnabled(true);
		}
		else    {
			this.menuPopUpItemDeleteSharedRoot.setEnabled(false);
			this.menuActionItemDeleteSharedRoot.setEnabled(false);
//			this.menuViewInfoItemSelectedProjecr.setEnabled(false);
//			this.menuPopUpItemViewSelectedProject.setEnabled(false);
		}

		this.tabbedPaneWorking_stateChanged(null);
	}

	/**
	 * Aggiorna l'interfaccia con il look&feel selezionato
	 */
	void UpdateLookAndFeel(String actualLookAndFeel)    {
		if(this.actualLookAndFeel.compareTo(actualLookAndFeel)!=0)  {
		// controllo se non ho scelto il Look&Feel gi attivo
			try {
			    if(actualLookAndFeel.compareTo("Windows")==0)
			        UIManager.setLookAndFeel(windowsLF);
				else    {
	        		if(actualLookAndFeel.compareTo("Motif")==0)
			    	    UIManager.setLookAndFeel(motifLF);
					else
	    	    		// ho scelgo Metal
						UIManager.setLookAndFeel(metalLF);
		    	}
			}catch(UnsupportedLookAndFeelException e){}
		}
		this.actualLookAndFeel=actualLookAndFeel;
		SwingUtilities.updateComponentTreeUI(this);
		SwingUtilities.updateComponentTreeUI(this.menuPopUpDefaultRoot);
		SwingUtilities.updateComponentTreeUI(this.menuPopUpManageRoot);
		SwingUtilities.updateComponentTreeUI(this.connectionDownloadsInProgressDialog);
	}

    private void jbInit() throws Exception {
        this.setIconImage(new ImageIcon("Interfaccia/Icons/Icona.gif").getImage());
        titledBorderViewProject = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Disabled");
        this.getContentPane().setLayout(mainFrameLayout);
        menuFileRoot.setNextFocusableComponent(menuActionRoot);
        menuFileRoot.setToolTipText("");
        menuFileRoot.setMnemonic('F');
        menuFileRoot.setText("File");
        menuFileRoot.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                menuFileRoot_keyPressed(e);
            }
        });
        menuFileItemExit.setToolTipText("Close Politella");
        menuFileItemExit.setIcon(new ImageIcon("Interfaccia/Icons/ExitSmall.gif"));
        menuFileItemExit.setMnemonic('X');
        menuFileItemExit.setText("Exit");
        menuFileItemExit.setAccelerator(javax.swing.KeyStroke.getKeyStroke(81, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuFileItemExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuFileItemExit_actionPerformed(e);
            }
        });
        menuFileItemSave.setToolTipText("Save Politella databases and setups");
        menuFileItemSave.setIcon(new ImageIcon("Interfaccia/Icons/SaveAllSmall.gif"));
        menuFileItemSave.setMnemonic('S');
        menuFileItemSave.setText("Save");
        menuFileItemSave.setAccelerator(javax.swing.KeyStroke.getKeyStroke(83, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuFileItemSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuFileItemSave_actionPerformed(e);
            }
        });
        menuFileItemSetup.setToolTipText("Politella setup");
        menuFileItemSetup.setMargin(new Insets(2, 22, 2, 2));
        menuFileItemSetup.setMnemonic('P');
        menuFileItemSetup.setText("Setup");
        menuFileItemSetup.setAccelerator(javax.swing.KeyStroke.getKeyStroke(80, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuFileItemSetup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuFileItemSetup_actionPerformed(e);
            }
        });
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        this.setJMenuBar(menuBar);
        this.setTitle("Politella 1.0");
        this.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                this_mouseClicked(e);
            }
        });
        this.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                this_windowClosing(e);
            }
        });
        this.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(KeyEvent e) {
                this_keyReleased(e);
            }
        });
        menuFileItemConnect.setToolTipText("Connect to Politella Network");
        menuFileItemConnect.setIcon(new ImageIcon("Interfaccia/Icons/ConnectSmall.gif"));
        menuFileItemConnect.setMnemonic('O');
        menuFileItemConnect.setText("Connect");
        menuFileItemConnect.setAccelerator(javax.swing.KeyStroke.getKeyStroke(79, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuFileItemConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuFileItemConnect_actionPerformed(e);
            }
        });
        menuActionRoot.setNextFocusableComponent(menuNetworkInfoRoot);
        menuActionRoot.setMnemonic('A');
        menuActionRoot.setText("Action Item");
        menuActionRoot.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                menuActionRoot_keyPressed(e);
            }
        });
        menuProjectItemNewProject.setToolTipText("Create a new project");
        menuProjectItemNewProject.setIcon(new ImageIcon("Interfaccia/Icons/NewSmall.gif"));
        menuProjectItemNewProject.setMnemonic('N');
        menuProjectItemNewProject.setText("New");
        menuProjectItemNewProject.setAccelerator(javax.swing.KeyStroke.getKeyStroke(78, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuProjectItemNewProject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemNewProject_actionPerformed(e);
            }
        });
        menuProjectItemSearchProject.setEnabled(false);
        menuProjectItemSearchProject.setToolTipText("Search projects");
        menuProjectItemSearchProject.setIcon(new ImageIcon("Interfaccia/Icons/SearchSmall.gif"));
        menuProjectItemSearchProject.setMnemonic('E');
        menuProjectItemSearchProject.setText("Search");
        menuProjectItemSearchProject.setArmed(true);
        menuProjectItemSearchProject.setAccelerator(javax.swing.KeyStroke.getKeyStroke(69, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuProjectItemSearchProject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemSearchProject_actionPerformed(e);
            }
        });
        menuActionItemDownloadItem.setEnabled(false);
        menuActionItemDownloadItem.setToolTipText("Download selected item");
        menuActionItemDownloadItem.setIcon(new ImageIcon("Interfaccia/Icons/DownloadSmall.gif"));
        menuActionItemDownloadItem.setMnemonic('D');
        menuActionItemDownloadItem.setText("Download Item");
        menuActionItemDownloadItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(68, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuActionItemDownloadItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuActionItemDownloadItem_actionPerformed(e);
            }
        });
        menuActionItemDeleteSharedRoot.setEnabled(false);
        menuActionItemDeleteSharedRoot.setToolTipText("Delete one or more shared items");
        menuActionItemDeleteSharedRoot.setMargin(new Insets(2, 22, 2, 2));
        menuActionItemDeleteSharedRoot.setText("Delete Shared Item");
        menuActionItemDeleteSharedItemOnly1.setToolTipText("Delete one item");
        menuActionItemDeleteSharedItemOnly1.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        menuActionItemDeleteDownItemOnly1.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        menuActionItemDeleteSharedItemOnly1.setText("Only Selected One");
        menuActionItemDeleteSharedItemOnly1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuActionItemDeleteSharedItemOnly1_actionPerformed(e);
            }
        });
        menuActionItemDeleteSharedItemAll.setToolTipText("Delete all items");
        menuActionItemDeleteSharedItemAll.setIcon(new ImageIcon("Interfaccia/Icons/DeleteAllSmall.gif"));
        menuActionItemDeleteDownItemAll.setIcon(new ImageIcon("Interfaccia/Icons/DeleteAllSmall.gif"));
        menuActionItemDeleteSharedItemAll.setText("All");
        menuActionItemDeleteSharedItemAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuActionItemDeleteSharedItemAll_actionPerformed(e);
            }
        });
        menuActionItemClearFoundRoot.setEnabled(false);
        menuActionItemClearFoundRoot.setToolTipText("Delete one or more found items");
        menuActionItemClearFoundRoot.setMargin(new Insets(2, 22, 2, 2));
        menuActionItemClearFoundRoot.setText("Clear Found Item");
        menuActionItemClearFoundItemOnly1.setToolTipText("Delete one item");
        menuActionItemClearFoundItemOnly1.setText("Only Selected One");
        menuActionItemClearFoundItemOnly1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuActionItemClearFoundItemOnly1_actionPerformed(e);
            }
        });
        menuActionItemClearFoundItemAll.setToolTipText("Delete all items");
        menuActionItemClearFoundItemAll.setText("All");
        menuActionItemClearFoundItemAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuActionItemClearFoundItemAll_actionPerformed(e);
            }
        });
        statusBarPanel.setLayout(statusBarLayout);
        statusBarConnectionsStatus.setBorder(BorderFactory.createLoweredBevelBorder());
        statusBarConnectionsStatus.setDoubleBuffered(true);
        statusBarConnectionsStatus.setNextFocusableComponent(statusBarDownloadsStatus);
        statusBarConnectionsStatus.setToolTipText("Active Connections");
        statusBarConnectionsStatus.setHorizontalAlignment(SwingConstants.LEFT);
        statusBarConnectionsStatus.setText("Connections: None");
        statusBarConnectionsStatus.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                statusBarConnectionsStatus_mousePressed(e);
            }
        });
        statusBarDownloadsStatus.setBorder(BorderFactory.createLoweredBevelBorder());
        statusBarDownloadsStatus.setDoubleBuffered(true);
        statusBarDownloadsStatus.setNextFocusableComponent(statusBarUploadsStatus);
        statusBarDownloadsStatus.setToolTipText("Active Downloads ");
        statusBarDownloadsStatus.setHorizontalAlignment(SwingConstants.LEFT);
        statusBarDownloadsStatus.setText("Downloads: None");
        statusBarDownloadsStatus.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                statusBarDownloadsStatus_mousePressed(e);
            }
        });
        statusBarUploadsStatus.setBorder(BorderFactory.createLoweredBevelBorder());
        statusBarUploadsStatus.setDoubleBuffered(true);
        statusBarUploadsStatus.setNextFocusableComponent(menuFileRoot);
        statusBarUploadsStatus.setToolTipText("Active Uploads");
        statusBarUploadsStatus.setHorizontalAlignment(SwingConstants.LEFT);
        statusBarUploadsStatus.setText("Uploads: None");
        statusBarUploadsStatus.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                statusBarUploadsStatus_mousePressed(e);
            }
        });
        toolBar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                toolBar_mouseClicked(e);
            }
        });
        statusBarLayout.setColumns(3);
        menuFileItemDisconnect.setEnabled(false);
        menuFileItemDisconnect.setToolTipText("Disconnect from Politella Network");
        menuFileItemDisconnect.setIcon(new ImageIcon("Interfaccia/Icons/DisconnectSmall.gif"));
        menuFileItemDisconnect.setMnemonic('I');
        menuFileItemDisconnect.setText("Disconnect");
        menuFileItemDisconnect.setAccelerator(javax.swing.KeyStroke.getKeyStroke(73, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuFileItemDisconnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuFileItemDisconnect_actionPerformed(e);
            }
        });
        menuHelpRoot.setNextFocusableComponent(buttonConnect);
        menuHelpRoot.setMnemonic('H');
        menuHelpRoot.setText("Help");
        menuHelpRoot.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                menuHelpRoot_keyPressed(e);
            }
        });
        menuHelpAboutItem.setToolTipText("Show info about Politella");
        menuHelpAboutItem.setIcon(new ImageIcon("Interfaccia/Icons/AboutSmall.gif"));
        menuHelpAboutItem.setMnemonic('B');
        menuHelpAboutItem.setText("About");
        menuHelpAboutItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(66, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuHelpAboutItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuHelpAboutItem_actionPerformed(e);
            }
        });
        menuPopUpItemConnect.setIcon(new ImageIcon("Interfaccia/Icons/ConnectSmall.gif"));
        menuPopUpItemConnect.setText("Connect");
        menuPopUpItemConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemConnect_actionPerformed(e);
            }
        });
        menuPopUpItemDisconnect.setEnabled(false);
        menuPopUpItemDisconnect.setIcon(new ImageIcon("Interfaccia/Icons/DisconnectSmall.gif"));
        menuPopUpItemDisconnect.setText("Disconnect");
        menuPopUpItemDisconnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemDisconnect_actionPerformed(e);
            }
        });
        menuPopUpItemNewProject.setIcon(new ImageIcon("Interfaccia/Icons/NewSmall.gif"));
        menuPopUpItemNewProject.setText("New Project");
        menuPopUpItemNewProject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemNewProject_actionPerformed(e);
            }
        });
        menuPopUpItemSearchProject.setEnabled(false);
        menuPopUpItemSearchProject.setIcon(new ImageIcon("Interfaccia/Icons/SearchSmall.gif"));
        menuPopUpItemSearchProject.setText("Search Project");
        menuPopUpItemSearchProject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemSearchProject_actionPerformed(e);
            }
        });
        menuPopUpItemDonwloadProject.setEnabled(false);
        menuPopUpItemDonwloadProject.setIcon(new ImageIcon("Interfaccia/Icons/DownloadSmall.gif"));
        menuPopUpItemDonwloadProject.setText("Download Selected Item");
        menuPopUpItemDonwloadProject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemDonwloadProject_actionPerformed(e);
            }
        });
        menuPopUpItemDeleteSharedRoot.setEnabled(false);
        menuPopUpItemDeleteSharedRoot.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpItemDeleteSharedRoot.setText("Delete Shared Item");
        menuPopUpItemDeleteSharedItemOnly1.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        menuPopUpItemDeleteDownItemOnly1.setIcon(new ImageIcon("Interfaccia/Icons/DeleteSmall.gif"));
        menuPopUpItemDeleteSharedItemOnly1.setText("Only Selected One");
        menuPopUpItemDeleteSharedItemOnly1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemDeleteSharedItemOnly1_actionPerformed(e);
            }
        });
        menuPopUpItemClearFoundRoot.setEnabled(false);
        menuPopUpItemClearFoundRoot.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpItemClearFoundRoot.setText("Clear Found Item");
        menuPopUpItemClearFoundItemOnly1.setText("Only Selected One");
        menuPopUpItemClearFoundItemOnly1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemClearFoundItemOnly1_actionPerformed(e);
            }
        });
        menuPopUpItemDeleteSharedItemAll.setIcon(new ImageIcon("Interfaccia/Icons/DeleteAllSmall.gif"));
        menuPopUpItemDeleteDownItemAll.setIcon(new ImageIcon("Interfaccia/Icons/DeleteAllSmall.gif"));
        menuPopUpItemDeleteSharedItemAll.setText("All");
        menuPopUpItemDeleteSharedItemAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemDeleteSharedItemAll_actionPerformed(e);
            }
        });
        menuPopUpItemClearFoundItemAll.setText("All");
        menuPopUpItemClearFoundItemAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemClearFoundItemAll_actionPerformed(e);
            }
        });
        tabbedPaneWorking.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                tabbedPaneWorking_mouseClicked(e);
            }
        });
        menuPopUpDefaultRoot.setDoubleBuffered(true);
        tabbedPaneWorking.setDoubleBuffered(true);
        buttonConnect.setBorder(BorderFactory.createEtchedBorder());
        buttonConnect.setDoubleBuffered(true);
        buttonConnect.setMaximumSize(new Dimension(35, 35));
        buttonConnect.setMinimumSize(new Dimension(35, 35));
        buttonConnect.setNextFocusableComponent(buttonDisconnect);
        buttonConnect.setPreferredSize(new Dimension(35, 35));
        buttonConnect.setToolTipText("Connect to Politella Network");
        buttonConnect.setIcon(new ImageIcon("Interfaccia/Icons/Connect.gif"));
        buttonConnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonConnect_actionPerformed(e);
            }
        });
        buttonDisconnect.setEnabled(false);
        buttonDisconnect.setBorder(BorderFactory.createEtchedBorder());
        buttonDisconnect.setDoubleBuffered(true);
        buttonDisconnect.setMaximumSize(new Dimension(35, 35));
        buttonDisconnect.setMinimumSize(new Dimension(35, 35));
        buttonDisconnect.setNextFocusableComponent(buttonSaveAllDb_Setups);
        buttonDisconnect.setPreferredSize(new Dimension(35, 35));
        buttonDisconnect.setToolTipText("Disconnect from Politella Network");
        buttonDisconnect.setIcon(new ImageIcon("Interfaccia/Icons/Disconnect.gif"));
        buttonDisconnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonDisconnect_actionPerformed(e);
            }
        });
        buttonSaveAllDb_Setups.setBorder(BorderFactory.createEtchedBorder());
        buttonSaveAllDb_Setups.setDoubleBuffered(true);
        buttonSaveAllDb_Setups.setMaximumSize(new Dimension(35, 35));
        buttonSaveAllDb_Setups.setMinimumSize(new Dimension(35, 35));
        buttonSaveAllDb_Setups.setNextFocusableComponent(buttonNewPrj);
        buttonSaveAllDb_Setups.setPreferredSize(new Dimension(35, 35));
        buttonSaveAllDb_Setups.setToolTipText("Save Politella databases and setups");
        buttonSaveAllDb_Setups.setIcon(new ImageIcon("Interfaccia/Icons/SaveAll.gif"));
        buttonSaveAllDb_Setups.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonSaveAllDb_Setups_actionPerformed(e);
            }
        });
        buttonSearchPrj.setEnabled(false);
        buttonSearchPrj.setBorder(BorderFactory.createEtchedBorder());
        buttonSearchPrj.setDoubleBuffered(true);
        buttonSearchPrj.setMaximumSize(new Dimension(35, 35));
        buttonSearchPrj.setMinimumSize(new Dimension(35, 35));
        buttonSearchPrj.setNextFocusableComponent(buttonDownloadItem);
        buttonSearchPrj.setPreferredSize(new Dimension(35, 35));
        buttonSearchPrj.setToolTipText("Search projects");
        buttonSearchPrj.setIcon(new ImageIcon("Interfaccia/Icons/Search.gif"));
        buttonSearchPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonSearchPrj_actionPerformed(e);
            }
        });
        buttonNewPrj.setBorder(BorderFactory.createEtchedBorder());
        buttonNewPrj.setDoubleBuffered(true);
        buttonNewPrj.setMaximumSize(new Dimension(35, 35));
        buttonNewPrj.setMinimumSize(new Dimension(35, 35));
        buttonNewPrj.setNextFocusableComponent(buttonSearchPrj);
        buttonNewPrj.setPreferredSize(new Dimension(35, 35));
        buttonNewPrj.setToolTipText("Create a new project");
        buttonNewPrj.setIcon(new ImageIcon("Interfaccia/Icons/New.gif"));
        buttonNewPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonNewPrj_actionPerformed(e);
            }
        });
        buttonExit.setBorder(BorderFactory.createEtchedBorder());
        buttonExit.setDoubleBuffered(true);
        buttonExit.setMaximumSize(new Dimension(35, 35));
        buttonExit.setMinimumSize(new Dimension(35, 35));
        buttonExit.setNextFocusableComponent(buttonConnect);
        buttonExit.setPreferredSize(new Dimension(35, 35));
        buttonExit.setToolTipText("Close Politella");
        buttonExit.setIcon(new ImageIcon("Interfaccia/Icons/Exit.gif"));
        buttonExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonExit_actionPerformed(e);
            }
        });
        buttonDownloadItem.setEnabled(false);
        buttonDownloadItem.setBorder(BorderFactory.createEtchedBorder());
        buttonDownloadItem.setDoubleBuffered(true);
        buttonDownloadItem.setMaximumSize(new Dimension(35, 35));
        buttonDownloadItem.setMinimumSize(new Dimension(35, 35));
        buttonDownloadItem.setNextFocusableComponent(buttonExit);
        buttonDownloadItem.setPreferredSize(new Dimension(35, 35));
        buttonDownloadItem.setToolTipText("Download selected item");
        buttonDownloadItem.setIcon(new ImageIcon("Interfaccia/Icons/Download.gif"));
        buttonDownloadItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonDownloadItem_actionPerformed(e);
            }
        });
        panelFoundProjects.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Items"));
        panelFoundProjects.setToolTipText("These are the projects you have found. You must download them before " +
    "analizing");
        panelFoundProjects.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                panelFoundProjects_mouseClicked(e);
            }
        });
        panelFoundProjects.setLayout(layoutFoundProjects);
        panelSharedProjects.setLayout(layoutSharedProjects);
        tableSharedProjects.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        tableSharedProjects.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                tableSharedProjects_mouseClicked(e);
            }
        });
        panelSharedProjects.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Items"));
        panelSharedProjects.setToolTipText("These are the projects you share. You can analize and edit them");
        panelSharedProjects.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                panelSharedProjects_mouseClicked(e);
            }
        });
        menuNetworkInfoRoot.setNextFocusableComponent(menuHelpRoot);
        menuNetworkInfoRoot.setMnemonic('N');
        menuNetworkInfoRoot.setText("Network Info");
        menuNetworkInfoRoot.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                menuNetworkInfoRoot_keyPressed(e);
            }
        });
        menuNetworkInfoItemViewActiveConnections.setEnabled(false);
        menuNetworkInfoItemViewActiveConnections.setToolTipText("View info about active connections");
        menuNetworkInfoItemViewActiveConnections.setMnemonic('T');
        menuNetworkInfoItemViewActiveConnections.setText("View Active Connections");
        menuNetworkInfoItemViewActiveConnections.setAccelerator(javax.swing.KeyStroke.getKeyStroke(84, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuNetworkInfoItemViewActiveConnections.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuNetworkInfoItemViewActiveConnections_actionPerformed(e);
            }
        });
        menuNetworkInfoItemViewActiveUploads.setEnabled(false);
        menuNetworkInfoItemViewActiveUploads.setToolTipText("View info about active uploads");
        menuNetworkInfoItemViewActiveUploads.setMnemonic('U');
        menuNetworkInfoItemViewActiveUploads.setText("View Active Uploads");
        menuNetworkInfoItemViewActiveUploads.setAccelerator(javax.swing.KeyStroke.getKeyStroke(85, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuNetworkInfoItemViewActiveUploads.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuNetworkInfoItemViewActiveUploads_actionPerformed(e);
            }
        });
        menuNetworkInfoItemViewActiveDownloads.setEnabled(false);
        menuNetworkInfoItemViewActiveDownloads.setToolTipText("View info about active downloads");
        menuNetworkInfoItemViewActiveDownloads.setMnemonic('W');
        menuNetworkInfoItemViewActiveDownloads.setText("View Active Downloads");
        menuNetworkInfoItemViewActiveDownloads.setAccelerator(javax.swing.KeyStroke.getKeyStroke(87, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuNetworkInfoItemViewActiveDownloads.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuNetworkInfoItemViewActiveDownloads_actionPerformed(e);
            }
        });
        panelViewProject.setLayout(layoutViewProject);
        tableFoundProjects.setDoubleBuffered(true);
        tableFoundProjects.setAutoResizeMode(JTable.AUTO_RESIZE_NEXT_COLUMN);
        tableFoundProjects.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                tableFoundProjects_mouseClicked(e);
            }
        });
        tableSharedProjects.setDoubleBuffered(true);
        tableSharedProjects.setAutoResizeMode(JTable.AUTO_RESIZE_NEXT_COLUMN);
        tableSharedProjects.setCellSelectionEnabled(false);
        tableSharedProjects.setRowSelectionAllowed(true);
        scrollPaneFoundProjects.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(103, 101, 98),new Color(148, 145, 140)));
        scrollPaneFoundProjects.setDoubleBuffered(true);
        scrollPaneFoundProjects.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                scrollPaneFoundProjects_mouseClicked(e);
            }
        });
        panelViewProject.setBorder(titledBorderViewProject);
        panelViewProject.setMinimumSize(new Dimension(36, 56));
        panelViewProject.setPreferredSize(new Dimension(466, 432));
        panelViewProject.setToolTipText("You can analyze and edit the characteristics of the selected project");
        menuActionItemViewItem.setEnabled(false);
        menuActionItemViewItem.setToolTipText("View selected item");
        menuActionItemViewItem.setIcon(new ImageIcon("Interfaccia/Icons/ViewSmall.gif"));
        menuActionItemViewItem.setMnemonic('V');
        menuActionItemViewItem.setText("View Item");
        menuActionItemViewItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(86, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuActionItemViewItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuActionItemViewItem_actionPerformed(e);
            }
        });
        menuPopUpItemViewSelectedProject.setEnabled(false);
        menuPopUpItemViewSelectedProject.setIcon(new ImageIcon("Interfaccia/Icons/ViewSmall.gif"));
        menuPopUpItemViewSelectedProject.setText("View Selected Item");
        menuPopUpItemViewSelectedProject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemViewSelectedProject_actionPerformed(e);
            }
        });
        toolBar.setBorder(BorderFactory.createEtchedBorder());
        toolBar.setDoubleBuffered(true);
        toolBar.setFloatable(false);
        scrollPaneSharedProjects.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(103, 101, 98),new Color(148, 145, 140)));
        scrollPaneSharedProjects.setDoubleBuffered(true);
        scrollPaneSharedProjects.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                scrollPaneSharedProjects_mouseClicked(e);
            }
        });
        splitPaneViewProject.setOrientation(JSplitPane.VERTICAL_SPLIT);
        splitPaneViewProject.setBackground(Color.white);
        splitPaneViewProject.setForeground(Color.black);
        splitPaneViewProject.setBorder(BorderFactory.createEmptyBorder());
        splitPaneViewProject.setDoubleBuffered(true);
        scrollPaneViewPrjBusinessModelComponents.setViewportBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(148, 145, 140),new Color(103, 101, 98)));
        scrollPaneViewPrjBusinessModelComponents.getViewport().setBackground(Color.white);
        scrollPaneViewPrjBusinessModelComponents.setForeground(Color.red);
        scrollPaneViewPrjBusinessModelComponents.setAlignmentX((float) 0.0);
        scrollPaneViewPrjBusinessModelComponents.setAlignmentY((float) 0.0);
        scrollPaneViewPrjBusinessModelComponents.setAutoscrolls(true);
        scrollPaneViewPrjBusinessModelComponents.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Business Model Components"));
        scrollPaneViewPrjBusinessModelComponents.setDoubleBuffered(true);
        scrollPaneViewProjectInfos.setViewportBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(103, 101, 98),new Color(148, 145, 140)));
        scrollPaneViewProjectInfos.getViewport().setBackground(Color.white);
        scrollPaneViewProjectInfos.setAlignmentX((float) 0.0);
        scrollPaneViewProjectInfos.setAlignmentY((float) 0.0);
        scrollPaneViewProjectInfos.setAutoscrolls(true);
        scrollPaneViewProjectInfos.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Project Informations"));
        scrollPaneViewProjectInfos.setDoubleBuffered(true);
        treeViewProjectInfos.setEnabled(false);
        treeViewProjectInfos.setDoubleBuffered(true);
        treeViewProjectInfos.setEditable(true);
        treeViewProjectInfos.setRowHeight(20);
        treeViewProjectInfos.setScrollsOnExpand(false);
        panelDownProjects.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Items"));
        panelDownProjects.setToolTipText("These are the projects you have downloaded, but you don\'t already " +
    "share.You can only analize them");
        panelDownProjects.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                panelDownProjects_mouseClicked(e);
            }
        });
        panelDownProjects.setLayout(layoutDownProjects);
        scrollPaneDownProjects.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(103, 101, 98),new Color(148, 145, 140)));
        scrollPaneDownProjects.setDoubleBuffered(true);
        scrollPaneDownProjects.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                scrollPaneDownProjects_mouseClicked(e);
            }
        });
        tableDownProjects.setDoubleBuffered(true);
        tableDownProjects.setAutoResizeMode(JTable.AUTO_RESIZE_NEXT_COLUMN);
        tableDownProjects.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                tableDownProjects_mouseClicked(e);
            }
        });
        menuPopUpItemDeleteDownRoot.setEnabled(false);
        menuPopUpItemDeleteDownRoot.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpItemDeleteDownRoot.setText("Delete Downloaded Item");
        menuPopUpItemDeleteDownItemOnly1.setText("Only Selected One");
        menuPopUpItemDeleteDownItemOnly1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemDeleteDownItemOnly1_actionPerformed(e);
            }
        });
        menuPopUpItemDeleteDownItemAll.setText("All");
        menuPopUpItemDeleteDownItemAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpItemDeleteDownItemAll_actionPerformed(e);
            }
        });
        menuActionItemDeleteDownRoot.setEnabled(false);
        menuActionItemDeleteDownRoot.setToolTipText("Delete one or more downloaded items");
        menuActionItemDeleteDownRoot.setMargin(new Insets(2, 22, 2, 2));
        menuActionItemDeleteDownRoot.setText("Delete Downloaded Item");
        menuActionItemDeleteDownItemOnly1.setToolTipText("Delete one item");
        menuActionItemDeleteDownItemOnly1.setText("Only One");
        menuActionItemDeleteDownItemOnly1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuActionItemDeleteDownItemOnly1_actionPerformed(e);
            }
        });
        menuActionItemDeleteDownItemAll.setToolTipText("Delete all items");
        menuActionItemDeleteDownItemAll.setText("All");
        menuActionItemDeleteDownItemAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuActionItemDeleteDownItemAll_actionPerformed(e);
            }
        });
        menuProjectRoot.setMnemonic('P');
        menuProjectRoot.setText("Project");
        menuProjectRoot.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                menuProjectRoot_keyPressed(e);
            }
        });
        menuProjectItemSaveCurrent.setEnabled(false);
        menuProjectItemSaveCurrent.setToolTipText("Save current project");
        menuProjectItemSaveCurrent.setMnemonic('A');
        menuProjectItemSaveCurrent.setText("Save Current");
        menuProjectItemSaveCurrent.setIcon(new ImageIcon("Interfaccia/Icons/SaveSmall.gif"));
		menuProjectItemSaveCurrent.setAccelerator(javax.swing.KeyStroke.getKeyStroke(65, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuProjectItemSaveCurrent.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemSaveCurrent_actionPerformed(e);
            }
        });
        menuPopUpManageItemEditPrj.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpManageItemEditPrj.setEnabled(false);
        menuPopUpManageItemEditPrj.setText("Edit Project");
        menuPopUpManageItemEditPrj.setToolTipText("Edit the components of current project");
        menuPopUpManageItemEditPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpManageItemEditPrj_actionPerformed(e);
            }
        });
        menuPopUpManageItemSaveCurrPrj.setEnabled(false);
        menuPopUpManageItemSaveCurrPrj.setToolTipText("Save current project");
        menuPopUpManageItemSaveCurrPrj.setText("Save Current Project");
        menuPopUpManageItemSaveCurrPrj.setIcon(new ImageIcon("Interfaccia/Icons/SaveSmall.gif"));
        menuPopUpManageItemSaveCurrPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpManageItemSaveCurrPrj_actionPerformed(e);
            }
        });
        menuPopUpManageItemDownAllComp.setEnabled(false);
        menuPopUpManageItemDownAllComp.setToolTipText("Download all components of current project");
        menuPopUpManageItemDownAllComp.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpManageItemDownAllComp.setText("Download All Components");
        menuPopUpManageItemDownAllComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpManageItemDownAllComp_actionPerformed(e);
            }
        });
        menuPopUpManageItemAddThisComp.setEnabled(false);
        menuPopUpManageItemAddThisComp.setToolTipText("Add this component to current project");
        menuPopUpManageItemAddThisComp.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpManageItemAddThisComp.setText("Add This Component");
        menuPopUpManageItemAddThisComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpManageItemAddThisComp_actionPerformed(e);
            }
        });
        menuPopUpManageItemCloseCurrPrj.setEnabled(false);
        menuPopUpManageItemCloseCurrPrj.setToolTipText("Close current project");
        menuPopUpManageItemCloseCurrPrj.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpManageItemCloseCurrPrj.setText("Close Current Project");
        menuPopUpManageItemCloseCurrPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpManageItemCloseCurrPrj_actionPerformed(e);
            }
        });
        menuProjectItemCloseCurrent.setEnabled(false);
        menuProjectItemCloseCurrent.setMargin(new Insets(2, 22, 2, 2));
        menuProjectItemCloseCurrent.setMnemonic('L');
        menuProjectItemCloseCurrent.setText("Close Current");
        menuProjectItemCloseCurrent.setAccelerator(javax.swing.KeyStroke.getKeyStroke(76, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuProjectItemCloseCurrent.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemCloseCurrent_actionPerformed(e);
            }
        });
        menuProjectItemDownAllComp.setEnabled(false);
        menuProjectItemDownAllComp.setMargin(new Insets(2, 22, 2, 2));
        menuProjectItemDownAllComp.setMnemonic('M');
        menuProjectItemDownAllComp.setText("Download All Components");
        menuProjectItemDownAllComp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(77, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuProjectItemDownAllComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemDownAllComp_actionPerformed(e);
            }
        });
        menuProjectItemAddThisComp.setEnabled(false);
        menuProjectItemAddThisComp.setMargin(new Insets(2, 22, 2, 2));
//        menuProjectItemAddThisComp.setMnemonic('H');
        menuProjectItemAddThisComp.setText("Add This Component");
//        menuProjectItemAddThisComp.setAccelerator(javax.swing.KeyStroke.getKeyStroke(72, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuProjectItemAddThisComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemAddThisComp_actionPerformed(e);
            }
        });
        menuProjectItemEditCurrPrj.setMargin(new Insets(2, 22, 2, 2));
        menuProjectItemEditCurrPrj.setAccelerator(javax.swing.KeyStroke.getKeyStroke(82, java.awt.event.KeyEvent.CTRL_MASK, false));
        menuProjectItemEditCurrPrj.setEnabled(false);
        menuProjectItemEditCurrPrj.setText("Edit Current Project");
        menuProjectItemEditCurrPrj.setMnemonic('R');
        menuProjectItemEditCurrPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemEditCurrPrj_actionPerformed(e);
            }
        });
        buttonViewItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonViewItem_actionPerformed(e);
            }
        });
        buttonViewItem.setIcon(new ImageIcon("Interfaccia/Icons/View.gif"));
        buttonViewItem.setToolTipText("View selected item");
        buttonViewItem.setPreferredSize(new Dimension(35, 35));
        buttonViewItem.setNextFocusableComponent(buttonConnect);
        buttonViewItem.setMinimumSize(new Dimension(35, 35));
        buttonViewItem.setMaximumSize(new Dimension(35, 35));
        buttonViewItem.setDoubleBuffered(true);
        buttonViewItem.setEnabled(false);
        buttonViewItem.setBorder(BorderFactory.createEtchedBorder());
        buttonSaveCurrPrj.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonSaveCurrPrj_actionPerformed(e);
            }
        });
        buttonSaveCurrPrj.setIcon(new ImageIcon("Interfaccia/Icons/Save.gif"));
        buttonSaveCurrPrj.setToolTipText("Save current project");
        buttonSaveCurrPrj.setPreferredSize(new Dimension(35, 35));
        buttonSaveCurrPrj.setNextFocusableComponent(buttonNewPrj);
        buttonSaveCurrPrj.setMinimumSize(new Dimension(35, 35));
        buttonSaveCurrPrj.setMaximumSize(new Dimension(35, 35));
        buttonSaveCurrPrj.setDoubleBuffered(true);
        buttonSaveCurrPrj.setEnabled(false);
        buttonSaveCurrPrj.setBorder(BorderFactory.createEtchedBorder());
        menuPopUpManageItemEditThisComp.setEnabled(false);
        menuPopUpManageItemEditThisComp.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpManageItemEditThisComp.setText("Edit This Component");
        menuPopUpManageItemEditThisComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpManageItemEditThisComp_actionPerformed(e);
            }
        });
        menuPopUpManageItemDownThisComp.setEnabled(false);
        menuPopUpManageItemDownThisComp.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpManageItemDownThisComp.setText("Download This Component");
        menuPopUpManageItemDownThisComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpManageItemDownThisComp_actionPerformed(e);
            }
        });
        menuProjectItemDownThisComp.setEnabled(false);
        menuProjectItemDownThisComp.setMargin(new Insets(2, 22, 2, 2));
        menuProjectItemDownThisComp.setText("Download This Component");
        menuProjectItemDownThisComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemDownThisComp_actionPerformed(e);
            }
        });
        menuProjectItemEditThisComp.setEnabled(false);
        menuProjectItemEditThisComp.setMargin(new Insets(2, 22, 2, 2));
        menuProjectItemEditThisComp.setText("Edit This Component");
        menuProjectItemEditThisComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemEditThisComp_actionPerformed(e);
            }
        });
        menuProjectItemDownSelectedComp.setEnabled(false);
        menuProjectItemDownSelectedComp.setMargin(new Insets(2, 22, 2, 2));
        menuProjectItemDownSelectedComp.setText("Download Selected Components");
        menuProjectItemDownSelectedComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuProjectItemDownSelectedComp_actionPerformed(e);
            }
        });
        menuPopUpManageItemDownSelectedComp.setEnabled(false);
        menuPopUpManageItemDownSelectedComp.setMargin(new Insets(2, 22, 2, 2));
        menuPopUpManageItemDownSelectedComp.setText("Download Selected Components");
        menuPopUpManageItemDownSelectedComp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                menuPopUpManageItemDownSelectedComp_actionPerformed(e);
            }
        });
        panelViewPrjTool.setLayout(layoutViewPrjTool);
        checkBoxViewPrjEditProject.setEnabled(false);
        checkBoxViewPrjEditProject.setDoubleBuffered(true);
        checkBoxViewPrjEditProject.setAlignmentX((float) 0.5);
        checkBoxViewPrjEditProject.setText("Edit this project");
        checkBoxViewPrjEditProject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                checkBoxViewPrjEditProject_actionPerformed(e);
            }
        });
        buttonOpenPrjDir.setEnabled(false);
        buttonOpenPrjDir.setToolTipText("Press to open the viewed project directory");
        buttonOpenPrjDir.setText("Open project dir.");
        buttonOpenPrjDir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonOpenPrjDir_actionPerformed(e);
            }
        });
        menuBar.add(menuFileRoot);
        menuBar.add(menuActionRoot);
        menuBar.add(menuProjectRoot);
        menuBar.add(menuNetworkInfoRoot);
        menuBar.add(menuHelpRoot);
        menuFileRoot.add(menuFileItemConnect);
        menuFileRoot.add(menuFileItemDisconnect);
        menuFileRoot.add(menuFileItemSave);
        menuFileRoot.add(menuFileItemSetup);
        menuFileRoot.addSeparator();
        menuFileRoot.add(menuFileItemExit);
        menuActionRoot.add(menuActionItemDownloadItem);
        menuActionRoot.add(menuActionItemViewItem);
        menuActionRoot.addSeparator();
        menuActionRoot.add(menuActionItemClearFoundRoot);
        menuActionRoot.add(menuActionItemDeleteDownRoot);
        menuActionRoot.add(menuActionItemDeleteSharedRoot);
        menuActionItemDeleteSharedRoot.add(menuActionItemDeleteSharedItemOnly1);
        menuActionItemDeleteSharedRoot.add(menuActionItemDeleteSharedItemAll);
        menuActionItemClearFoundRoot.add(menuActionItemClearFoundItemOnly1);
        menuActionItemClearFoundRoot.add(menuActionItemClearFoundItemAll);
        this.getContentPane().add(statusBarPanel, BorderLayout.SOUTH);
        statusBarPanel.add(statusBarConnectionsStatus, null);
        statusBarPanel.add(statusBarDownloadsStatus, null);
        statusBarPanel.add(statusBarUploadsStatus, null);
        this.getContentPane().add(toolBar, BorderLayout.NORTH);
        toolBar.add(buttonConnect, null);
        toolBar.add(buttonDisconnect, null);
        toolBar.add(buttonSaveAllDb_Setups, null);
		toolBar.addSeparator(new java.awt.Dimension(10,this.toolBar.getHeight()));
        toolBar.add(buttonDownloadItem, null);
        toolBar.add(buttonViewItem, null);
		toolBar.addSeparator(new java.awt.Dimension(10,this.toolBar.getHeight()));
        toolBar.add(buttonSearchPrj, null);
        toolBar.add(buttonNewPrj, null);
        toolBar.add(buttonSaveCurrPrj, null);
		toolBar.addSeparator(new java.awt.Dimension(10,this.toolBar.getHeight()));
        toolBar.add(buttonExit, null);
        this.getContentPane().add(tabbedPaneWorking, BorderLayout.CENTER);
        tabbedPaneWorking.add(panelFoundProjects, "Found Projects");
        panelFoundProjects.add(scrollPaneFoundProjects, BorderLayout.CENTER);
        scrollPaneFoundProjects.getViewport().add(tableFoundProjects, null);
        menuHelpRoot.add(menuHelpAboutItem);
        menuPopUpDefaultRoot.add(menuPopUpItemConnect);
        menuPopUpDefaultRoot.add(menuPopUpItemDisconnect);
        menuPopUpDefaultRoot.addSeparator();
        menuPopUpDefaultRoot.add(menuPopUpItemNewProject);
        menuPopUpDefaultRoot.add(menuPopUpItemSearchProject);
        menuPopUpDefaultRoot.addSeparator();
        menuPopUpDefaultRoot.add(menuPopUpItemDonwloadProject);
        menuPopUpDefaultRoot.add(menuPopUpItemViewSelectedProject);
        menuPopUpDefaultRoot.addSeparator();
        menuPopUpDefaultRoot.add(menuPopUpItemClearFoundRoot);
        menuPopUpDefaultRoot.add(menuPopUpItemDeleteDownRoot);
        menuPopUpDefaultRoot.add(menuPopUpItemDeleteSharedRoot);
        menuPopUpItemDeleteSharedRoot.add(menuPopUpItemDeleteSharedItemOnly1);
        menuPopUpItemDeleteSharedRoot.add(menuPopUpItemDeleteSharedItemAll);
        menuPopUpItemClearFoundRoot.add(menuPopUpItemClearFoundItemOnly1);
        menuPopUpItemClearFoundRoot.add(menuPopUpItemClearFoundItemAll);
        menuNetworkInfoRoot.add(menuNetworkInfoItemViewActiveConnections);
        menuNetworkInfoRoot.add(menuNetworkInfoItemViewActiveDownloads);
        menuNetworkInfoRoot.add(menuNetworkInfoItemViewActiveUploads);
        tabbedPaneWorking.add(panelDownProjects, "Downloaded Projects");
        tabbedPaneWorking.add(panelSharedProjects, "Shared Projects");
        panelSharedProjects.add(scrollPaneSharedProjects, BorderLayout.CENTER);
        scrollPaneSharedProjects.getViewport().add(tableSharedProjects, null);
		scrollPaneDownProjects.getViewport().add(tableDownProjects,null);
        tabbedPaneWorking.add(panelViewProject, "View Project");
        panelViewProject.add(splitPaneViewProject, BorderLayout.CENTER);
        splitPaneViewProject.add(scrollPaneViewPrjBusinessModelComponents, JSplitPane.TOP);
        splitPaneViewProject.add(scrollPaneViewProjectInfos, JSplitPane.BOTTOM);
        panelViewProject.add(panelViewPrjTool, BorderLayout.NORTH);
        panelViewPrjTool.add(checkBoxViewPrjEditProject, BorderLayout.WEST);
        panelViewPrjTool.add(buttonOpenPrjDir, BorderLayout.EAST);
        panelDownProjects.add(scrollPaneDownProjects, BorderLayout.CENTER);
        this.tabbedPaneWorking.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                tabbedPaneWorking_stateChanged(e);
            }
        });
        scrollPaneViewProjectInfos.getViewport().add(treeViewProjectInfos,null);
        menuPopUpItemDeleteDownRoot.add(menuPopUpItemDeleteDownItemOnly1);
        menuPopUpItemDeleteDownRoot.add(menuPopUpItemDeleteDownItemAll);
        menuActionItemDeleteDownRoot.add(menuActionItemDeleteDownItemOnly1);
        menuActionItemDeleteDownRoot.add(menuActionItemDeleteDownItemAll);
        menuProjectRoot.add(menuProjectItemSearchProject);
        menuProjectRoot.addSeparator();
        menuProjectRoot.add(menuProjectItemNewProject);
        menuProjectRoot.add(menuProjectItemSaveCurrent);
        menuProjectRoot.addSeparator();
        menuProjectRoot.add(menuProjectItemEditCurrPrj);
        menuProjectRoot.add(menuProjectItemEditThisComp);
        menuProjectRoot.add(menuProjectItemAddThisComp);
        menuProjectRoot.addSeparator();
        menuProjectRoot.add(menuProjectItemDownThisComp);
        menuProjectRoot.add(menuProjectItemDownSelectedComp);
        menuProjectRoot.add(menuProjectItemDownAllComp);
        menuProjectRoot.addSeparator();
        menuProjectRoot.add(menuProjectItemCloseCurrent);
        menuPopUpManageRoot.add(menuPopUpManageItemEditPrj);
        menuPopUpManageRoot.add(menuPopUpManageItemEditThisComp);
        menuPopUpManageRoot.add(menuPopUpManageItemAddThisComp);
        menuPopUpManageRoot.addSeparator();
        menuPopUpManageRoot.add(menuPopUpManageItemDownThisComp);
        menuPopUpManageRoot.add(menuPopUpManageItemDownSelectedComp);
        menuPopUpManageRoot.add(menuPopUpManageItemDownAllComp);
        menuPopUpManageRoot.addSeparator();
        menuPopUpManageRoot.add(menuPopUpManageItemSaveCurrPrj);
        menuPopUpManageRoot.add(menuPopUpManageItemCloseCurrPrj);

        treeViewProjectInfos.setShowsRootHandles(true);
		treeViewProjectInfos.putClientProperty("JTree.lineStyle", "Angled");
		treeViewProjectInfos.setLargeModel(true);
    }

	public void tabbedPaneWorking_stateChanged(ChangeEvent e)   {
		if(this.tabbedPaneWorking.getSelectedComponent()==this.panelViewProject)    {
			this.currentPrjViewing.SetVisibleBusinessModelImg(true);

			// diabilito tutti i menu di visualizzazione e download prj
            this.menuActionItemDownloadItem.setEnabled(false);
            this.menuPopUpItemDonwloadProject.setEnabled(false);
            this.buttonDownloadItem.setEnabled(false);
			this.menuActionItemViewItem.setEnabled(false);
			this.menuPopUpItemViewSelectedProject.setEnabled(false);
			this.buttonViewItem.setEnabled(false);
		}
		else    {
			this.currentPrjViewing.SetVisibleBusinessModelImg(false);
			if(this.tabbedPaneWorking.getSelectedComponent()==this.panelFoundProjects)  {
				//sono nel panel dei prj found, disabilito i menu di visualizzazione...
				this.menuActionItemViewItem.setEnabled(false);
				this.menuPopUpItemViewSelectedProject.setEnabled(false);
				this.buttonViewItem.setEnabled(false);
				//...e abilito i menu di down
				if(!this.tableModelFoundProjects.rowsData.isEmpty())    {
					this.menuActionItemDownloadItem.setEnabled(true);
					this.menuPopUpItemDonwloadProject.setEnabled(true);
					this.buttonDownloadItem.setEnabled(true);
				}
				else    {
					//non ho pi progetti down
					this.menuActionItemDownloadItem.setEnabled(false);
					this.menuPopUpItemDonwloadProject.setEnabled(false);
					this.buttonDownloadItem.setEnabled(false);
				}
			}
			else    {
				//sono o nel panel dei down o nel panel dei share prj, disabilito i menu di down...
				this.menuActionItemDownloadItem.setEnabled(false);
				this.menuPopUpItemDonwloadProject.setEnabled(false);
				this.buttonDownloadItem.setEnabled(false);
				//...e riabilito i menu di visualizzazione
				if(!this.tableModelDownProjects.rowsData.isEmpty()   ||
					!this.tableModelSharedProjects.rowsData.isEmpty())  {
					this.menuActionItemViewItem.setEnabled(true);
	    			this.menuPopUpItemViewSelectedProject.setEnabled(true);
					this.buttonViewItem.setEnabled(true);
				}
				else    {
				//non ho n prjDown n share
					this.menuActionItemViewItem.setEnabled(false);
	    			this.menuPopUpItemViewSelectedProject.setEnabled(false);
					this.buttonViewItem.setEnabled(false);
				}
			}
		}
	}

	// gestisco gli shortcut
    void this_keyReleased(KeyEvent e) {
		if(e.getModifiers()==KeyEvent.CTRL_MASK)
			switch(e.getKeyCode()){
				case KeyEvent.VK_A :{
					this.menuProjectItemSaveCurrent_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_B :{
					this.menuHelpAboutItem_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_D :{
					this.menuActionItemDownloadItem_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_E :{
					this.menuProjectItemSearchProject_actionPerformed(null);
					break;
					}
//				case KeyEvent.VK_H :{
//					this.menuProjectItemAddThisComp_actionPerformed(null);
//					break;
//					}
				case KeyEvent.VK_I :{
					this.checkBoxViewPrjEditProject.setSelected(!this.checkBoxViewPrjEditProject.isSelected());
					this.menuFileItemDisconnect_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_L :{
					this.menuProjectItemCloseCurrent_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_M :{
					this.menuProjectItemDownAllComp_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_N :{
					this.menuProjectItemNewProject_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_O:{
					this.menuFileItemConnect_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_P :{
					this.menuFileItemSetup_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_Q :{
					this.menuFileItemExit_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_R :{
					if(this.checkBoxViewPrjEditProject.isEnabled()) {
						this.checkBoxViewPrjEditProject.setSelected(!this.checkBoxViewPrjEditProject.isSelected());
						this.menuProjectItemEditCurrPrj_actionPerformed(null);
					}
					break;
					}
				case KeyEvent.VK_S :{
					this.menuFileItemSave_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_T :{
					this.menuNetworkInfoItemViewActiveConnections_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_U :{
					this.menuNetworkInfoItemViewActiveUploads_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_V :{
					this.menuActionItemViewItem_actionPerformed(null);
					break;
					}
				case KeyEvent.VK_W :{
					this.menuNetworkInfoItemViewActiveDownloads_actionPerformed(null);
					break;
					}
			}
    }

	// click del mouse
    void tableSharedProjects_mouseClicked(MouseEvent e) {
		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
			//compare popup
//			this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
		    this.ShowMenuPopUp(e);
		}
		else    {
			if(e.getClickCount()==2 && e.getModifiers()==MouseEvent.BUTTON1_MASK)
				// visualizzo il file associato
				this.menuActionItemViewItem_actionPerformed(null);
		}
    }

    void tableDownProjects_mouseClicked(MouseEvent e) {
		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
			//compare popup
//		    this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
			this.ShowMenuPopUp(e);
		}
		else    {
			if(e.getClickCount()==2 && e.getModifiers()==MouseEvent.BUTTON1_MASK)
				// visualizzo il file associato
				this.menuActionItemViewItem_actionPerformed(null);
		}
    }

    void tableFoundProjects_mouseClicked(MouseEvent e) {
		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
//		    this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
			this.ShowMenuPopUp(e);
		}
		else
			if(e.getClickCount()==2 && e.getModifiers()==MouseEvent.BUTTON1_MASK)
			// scarico il progetto associato
				this.menuActionItemDownloadItem_actionPerformed(null);
    }

	// PopUp Menu
    void tabbedPaneWorking_mouseClicked(MouseEvent e) {
//		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
//		    this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
//		}
		this.ShowMenuPopUp(e);
    }

    void this_mouseClicked(MouseEvent e) {
//		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
//			this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
//		}
		this.ShowMenuPopUp(e);
    }

    void toolBar_mouseClicked(MouseEvent e) {
//		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
//		    this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
//		}
		this.ShowMenuPopUp(e);
    }

    void menuPopUpItemViewSelectedProject_actionPerformed(ActionEvent e) {
		this.menuActionItemViewItem_actionPerformed(e);
    }

    void menuPopUpItemConnect_actionPerformed(ActionEvent e) {
		this.menuFileItemConnect_actionPerformed(e);
    }

    void menuPopUpItemDisconnect_actionPerformed(ActionEvent e) {
		this.menuFileItemDisconnect_actionPerformed(e);
    }


    void menuPopUpItemNewProject_actionPerformed(ActionEvent e) {
		this.menuProjectItemNewProject_actionPerformed(e);
    }

    void menuPopUpItemSearchProject_actionPerformed(ActionEvent e) {
		this.menuProjectItemSearchProject_actionPerformed(e);
    }

    void menuPopUpItemDonwloadProject_actionPerformed(ActionEvent e) {
		this.menuActionItemDownloadItem_actionPerformed(e);
    }

    void menuPopUpItemDeleteSharedItemOnly1_actionPerformed(ActionEvent e) {
		this.menuActionItemDeleteSharedItemOnly1_actionPerformed(e);
    }


    void menuPopUpItemDeleteSharedItemAll_actionPerformed(ActionEvent e) {
		this.menuActionItemDeleteSharedItemAll_actionPerformed(e);
    }


    void menuPopUpItemClearFoundItemOnly1_actionPerformed(ActionEvent e) {
		this.menuActionItemClearFoundItemOnly1_actionPerformed(e);
    }

    void menuPopUpItemClearFoundItemAll_actionPerformed(ActionEvent e) {
		this.menuActionItemClearFoundItemAll_actionPerformed(e);
    }

	// Menu File
    void menuFileRoot_keyPressed(KeyEvent e) {
		switch(e.getKeyCode()){
			case KeyEvent.VK_O:{
				this.menuFileItemConnect_actionPerformed(null);
				break;
				}
			case KeyEvent.VK_I:{
				this.menuFileItemDisconnect_actionPerformed(null);
				break;
				}
			case KeyEvent.VK_S:{
				this.menuFileItemSave_actionPerformed(null);
				break;
				}
			case KeyEvent.VK_P:{
				this.menuFileItemSetup_actionPerformed(null);
				break;
				}
			case KeyEvent.VK_X:{
				this.menuFileItemExit_actionPerformed(null);
				break;
				}
		}
    }

	void menuFileItemConnect_actionPerformed(ActionEvent e) {
		if(this.menuFileItemConnect.isEnabled())    {
			this.connectionDownloadsInProgressDialog.setTitle("Connection in progress...");
			this.connectionDownloadsInProgressDialog.setVisible(true);

			if(!this.userInterface.NewConnect()) {
				// l'accesspeer era errato, apro il dialog setup per modificarlo
				this.connectionDownloadsInProgressDialog.setVisible(false);
				new SetupDialog(this);
			}
		}
    }

    void menuFileItemDisconnect_actionPerformed(ActionEvent e) {
		if(this.menuFileItemDisconnect.isEnabled()) {
			int risp=JOptionPane.showConfirmDialog(this,"Do you really want disconnecting from Politella Network ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
			if(risp==JOptionPane.YES_OPTION)    {
	    		this.menuFileItemConnect.setEnabled(true);
		    	this.menuFileItemDisconnect.setEnabled(false);
		        this.menuProjectItemSearchProject.setEnabled(false);
				this.menuPopUpItemConnect.setEnabled(true);
		    	this.menuPopUpItemDisconnect.setEnabled(false);
				this.menuPopUpItemSearchProject.setEnabled(false);
				this.buttonDisconnect.setEnabled(false);
				this.buttonConnect.setEnabled(true);
				this.buttonSearchPrj.setEnabled(false);

				this.userInterface.Disconnect();

				//devo attendere che tutti i thread di gestione connessioni siano morti
				new WaitAllThreadDeathDialog(this);
		    }
		}
    }


    void menuFileItemSave_actionPerformed(ActionEvent e) {
		// chiamo UserInterface per effettuare i salvataggi dei db
		this.userInterface.Save();
    }

    void menuFileItemSetup_actionPerformed(ActionEvent e) {
		// apro la finestra di dialogo del setup
		new SetupDialog(this);
    }

    void menuFileItemExit_actionPerformed(ActionEvent e) {
		int risp=JOptionPane.showConfirmDialog(this,"Do you really want closing Politella?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
		if(risp==JOptionPane.YES_OPTION)    {
			//se ho 1 progetto aperto devo chiuderlo
			this.menuProjectItemCloseCurrent_actionPerformed(null);

			this.userInterface.Exit();
	    	if(this.menuFileItemDisconnect.isEnabled())
			//ho delle connessioni attive, devo chiuderle
	        	new WaitAllThreadDeathDialog(this);
			this.dispose();
			System.exit(0);
		}
    }

    void this_windowClosing(WindowEvent e) {
		this.menuFileItemExit_actionPerformed(null);
    }

    // Menu Action
    void menuActionRoot_keyPressed(KeyEvent e) {
		switch(e.getKeyCode()){
			case KeyEvent.VK_V :{
				this.menuActionItemViewItem_actionPerformed(null);
				break;
				}
			case KeyEvent.VK_D:{
				this.menuActionItemDownloadItem_actionPerformed(null);
				break;
				}
		}
    }

   void menuProjectItemNewProject_actionPerformed(ActionEvent e) {
		//ctrl di non star guardando altri progetti
		if(this.currentPrjViewing.IsViewed())  {
			//sto visualizzando gi un altro progetto, attenzione
			int risp=JOptionPane.showConfirmDialog(this,"You are analizing another project.\nDo you really want closing it and create another one?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
			if(risp==JOptionPane.YES_OPTION)
				//voglio creare un altro progetto, prima chiudo quello corrente
				this.menuProjectItemCloseCurrent_actionPerformed(null);
			else
    			//non volgio creare un altro progetto
				return;
    	}
		// apro la dialog per la creazione del nuovo porgetto
		new NewProjectDialog(this);
    }

    void menuProjectItemSearchProject_actionPerformed(ActionEvent e) {
		if(this.menuProjectItemSearchProject.isEnabled())    {
		    //apro il dialog per l'impostazione dei parametri di ricerca
			new NewSearchDialog(this);
		}
    }

    void menuActionItemDownloadItem_actionPerformed(ActionEvent e) {
		if(this.menuActionItemDownloadItem.isEnabled())  {
			if(this.tableFoundProjects.getSelectedRow()==-1)    {
	    		//non ho selezionato nulla
				JOptionPane.showMessageDialog(this,"You must select an item before","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
			}
		    //chiamo UserInterface per l'avvio della procedura di download
		    int selected=this.tableFoundProjects.getSelectedRow();
			this.userInterface.NewDownloadProject((String)this.tableModelFoundProjects.getValueAt(selected,3),((Long)this.tableModelFoundProjects.getValueAt(selected,4)).longValue());
		}
    }

    void menuActionItemDeleteSharedItemOnly1_actionPerformed(ActionEvent e) {
		if(this.tableSharedProjects.getSelectedRow()==-1)    {
			//non ho selezionato nulla
			JOptionPane.showMessageDialog(this,"You must select an item before","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
		}
		else    {
			//ho selezionato una riga
			Long prjID =(Long)this.tableModelSharedProjects.getValueAt(this.tableSharedProjects.getSelectedRow(),4);

			if(this.currentPrjViewing.IsViewed() &&
				this.currentPrjViewing.IsEditable() &&
				(prjID.longValue()==this.currentPrjViewing.GetPrjID().longValue()))  {
					// sto visualizzando un progetto share  e
					//sto cercando di cancellare il progetto che sto analizzando
					int risp=JOptionPane.showConfirmDialog(this,"You are analizing this project.\nDo you really want deleting it ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
		    		if(risp==JOptionPane.YES_OPTION)    {
						this.menuProjectItemCloseCurrent_actionPerformed(null);
						this.userInterface.projectManager.DelPrjShare(prjID.longValue());
			    	    this.UpdateTables();
		    		}
			}
			else    {
			// non sto visualizzando il progetto che voglio cancellare
				int risp=JOptionPane.showConfirmDialog(this,"Do you really want deleting this project ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
				if(risp==JOptionPane.YES_OPTION)    {
					this.userInterface.projectManager.DelPrjShare(prjID.longValue());
		    	    this.UpdateTables();
				}
			}

		}
    }

    void menuActionItemDeleteSharedItemAll_actionPerformed(ActionEvent e) {
		if(this.currentPrjViewing.IsViewed()    &&
			this.currentPrjViewing.IsEditable())    {
		// sto visualizzando un progetto share
			int risp=JOptionPane.showConfirmDialog(this,"You are analizing one shared project.\nDo you really want to continue ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
			if(risp==JOptionPane.YES_OPTION)    {
			// devo prima chiudere il progetto correntemente visualizzato
				this.menuProjectItemCloseCurrent_actionPerformed(null);
			}
			else
			//mi sono sbagliato, non voglio cancellare tutto, esco subito dal metodo
				return;
		}

		int risp=JOptionPane.showConfirmDialog(this,"Do you really want deleting all your shared projects ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
		if(risp==JOptionPane.YES_OPTION)    {
			//chiamo UserInterface per cancellare tutti i progetti salvati localmente
		    this.userInterface.projectManager.EmptyDbPrjShare();
			this.UpdateTables();
		}
    }

	void menuActionItemClearFoundItemOnly1_actionPerformed(ActionEvent e) {
		if(this.tableFoundProjects.getSelectedRow()==-1)    {
			//non ho selezionato nulla
			JOptionPane.showMessageDialog(this,"You must select a item before","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
		}
		else    {
			int risp=JOptionPane.showConfirmDialog(this,"Do you really want deleting this found item ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
		    if(risp==JOptionPane.YES_OPTION)    {
				//chiamo UserInterface per cancellare il riferimento selezionato
			    int selected=this.tableFoundProjects.getSelectedRow();
				this.userInterface.projectManager.DelPrfFound(((Long)this.tableModelFoundProjects.getValueAt(selected,4)).longValue(),(String)this.tableModelFoundProjects.getValueAt(selected,3));
			    this.UpdateTables();
		    }
		}
    }

    void menuActionItemClearFoundItemAll_actionPerformed(ActionEvent e) {
		int risp=JOptionPane.showConfirmDialog(this,"Do you really want deleting all your found items ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
		if(risp==JOptionPane.YES_OPTION)    {
			//chiamo UserInterface per cancellare tutti i riferimenti
			this.userInterface.projectManager.EmptyDbPrjFound();
			this.UpdateTables();
		}
    }

	// Menu View
    void menuNetworkInfoRoot_keyPressed(KeyEvent e) {
		switch(e.getKeyCode()){
			case KeyEvent.VK_T :{
				this.menuNetworkInfoItemViewActiveConnections_actionPerformed(null);
				break;
			    }
			case KeyEvent.VK_W :{
				this.menuNetworkInfoItemViewActiveDownloads_actionPerformed(null);
				break;
			    }
			case KeyEvent.VK_U :{
				this.menuNetworkInfoItemViewActiveUploads_actionPerformed(null);
				break;
			    }
		}
    }

    void menuActionItemViewItem_actionPerformed(ActionEvent e) {
		if(this.menuActionItemViewItem.isEnabled())    {
			int selectedID;
			JTable currentTable=null;
			ProjectTableModel currentTableModel=null;
			boolean isEditable;

		    //devo verificare a quale tabella appartiene il prj che voglio visualizzare:
			// quella dei prjShare o prjDown
			if(this.tabbedPaneWorking.getSelectedComponent()==this.panelDownProjects)   {
				//voglio visualizzare un prj tra quelli scaricati
				currentTable=this.tableDownProjects;
				currentTableModel=this.tableModelDownProjects;
				isEditable=false;
			}
			else    {
				//voglio visualizzare un prj tra quelli condivisi
				currentTable=this.tableSharedProjects;
				currentTableModel=this.tableModelSharedProjects;
				isEditable=true;
			}
			if((selectedID=currentTable.getSelectedRow())!=-1)  {
			    //ho selezionato un progetto posso chiamare UserInterface
			    //per visualizzare il progetto
				String[] prjType = new String[2];
				prjType[0]=(String)currentTableModel.getValueAt(selectedID,0);
				prjType[1]=(String)currentTableModel.getValueAt(selectedID,1);

				String prjPeerLocation=null;
//				if(!isEditable)
//					prjPeerLocation=(String)currentTableModel.getValueAt(selectedID,5);

				this.userInterface.ViewProject((Long)currentTableModel.getValueAt(selectedID,4),
											    prjType,
								/*Descr*/		(String)currentTableModel.getValueAt(selectedID,2),
//								/*FIle*/    	(String)currentTableModel.getValueAt(selectedID,3),
				/*prjBusModelComponents*/    	(Vector)currentTableModel.getValueAt(selectedID,5),
//												prjPeerLocation,
												isEditable);
			}
			else
	 			JOptionPane.showMessageDialog(this,"You must select a project before","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
		}
    }

   void menuNetworkInfoItemViewActiveConnections_actionPerformed(ActionEvent e) {
		if(this.menuNetworkInfoItemViewActiveConnections.isEnabled())    {
		    // visualizza la dialog con le informazioni relative alle connessioni attive
			new ActiveConnectionUploadDownloadInfoDialog(this,"Active Connections",this.userInterface.GetActiveConnectionsInfo());
		}
    }

    void menuNetworkInfoItemViewActiveDownloads_actionPerformed(ActionEvent e) {
		if(this.menuNetworkInfoItemViewActiveDownloads.isEnabled())    {
		    // visualizza la dialog con le informazioni relative ai download in corso
			new ActiveConnectionUploadDownloadInfoDialog(this,"Active Downloads",this.userInterface.GetActiveDownloadsInfo());
		}
    }

    void menuNetworkInfoItemViewActiveUploads_actionPerformed(ActionEvent e) {
		if(this.menuNetworkInfoItemViewActiveUploads.isEnabled())    {
		    // visualizza la dialog con le informazioni relative agli upload in corso
			new ActiveConnectionUploadDownloadInfoDialog(this,"Active Uploads",this.userInterface.GetActiveUploadsInfo());
		}
    }

	// Menu About
    void menuHelpRoot_keyPressed(KeyEvent e) {
		if(e.getKeyCode()==KeyEvent.VK_B)
			this.menuHelpAboutItem_actionPerformed(null);
    }

    void menuHelpAboutItem_actionPerformed(ActionEvent e) {
		JOptionPane.showMessageDialog(this,"Politella 1.0\nCopyright (c) 2001 Politecnico di Torino\nThis product includes code licensed from RSA Data Security","About",JOptionPane.INFORMATION_MESSAGE,new ImageIcon("Interfaccia/Icons/About.gif"));
    }

	// Status Bar
    void statusBarConnectionsStatus_mousePressed(MouseEvent e) {
		if(e.getClickCount()==2 && e.getModifiers()==MouseEvent.BUTTON1_MASK)
			this.menuNetworkInfoItemViewActiveConnections_actionPerformed(null);
	}

    void statusBarDownloadsStatus_mousePressed(MouseEvent e) {
		if(e.getClickCount()==2 && e.getModifiers()==MouseEvent.BUTTON1_MASK)
		    this.menuNetworkInfoItemViewActiveDownloads_actionPerformed(null);
    }

    void statusBarUploadsStatus_mousePressed(MouseEvent e) {
		if(e.getClickCount()==2 && e.getModifiers()==MouseEvent.BUTTON1_MASK)
			this.menuNetworkInfoItemViewActiveUploads_actionPerformed(null);
    }

    // toolbar
    void buttonConnect_actionPerformed(ActionEvent e) {
		this.menuFileItemConnect_actionPerformed(null);
    }

    void buttonDisconnect_actionPerformed(ActionEvent e) {
		this.menuFileItemDisconnect_actionPerformed(null);
    }

    void buttonSaveAllDb_Setups_actionPerformed(ActionEvent e) {
		this.menuFileItemSave_actionPerformed(null);
    }

    void buttonNewPrj_actionPerformed(ActionEvent e) {
		this.menuProjectItemNewProject_actionPerformed(null);
    }

    void buttonSearchPrj_actionPerformed(ActionEvent e) {
		this.menuProjectItemSearchProject_actionPerformed(null);
    }

    void buttonDownloadItem_actionPerformed(ActionEvent e) {
		this.menuActionItemDownloadItem_actionPerformed(null);
    }

    void buttonExit_actionPerformed(ActionEvent e) {
		this.menuFileItemExit_actionPerformed(null);
    }

	private class ProjectTableModel extends AbstractTableModel  {
		private Vector rowsData= new Vector();
		private String[] columnNames={"Commercial Model","Architectural Model","Description","Location"};

		public int getRowCount()    {
			return this.rowsData.size();
		}
		public int getColumnCount() {
			return this.columnNames.length;
		}
        public String getColumnName(int col) {
            return columnNames[col];
        }
		public Object getValueAt(int row, int column)   {
			return ((Vector)this.rowsData.elementAt(row)).elementAt(column);
		}
		protected void setRowsValue(Vector rowsData)  {
		    this.rowsData.removeAllElements();
			this.rowsData=rowsData;
			this.fireTableDataChanged();
		}
	}

    void scrollPaneFoundProjects_mouseClicked(MouseEvent e) {
//		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
//		    this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
//		}
		this.ShowMenuPopUp(e);
    }

    void scrollPaneSharedProjects_mouseClicked(MouseEvent e) {
		this.scrollPaneFoundProjects_mouseClicked(e);
    }

    void scrollPaneDownProjects_mouseClicked(MouseEvent e) {
		this.scrollPaneFoundProjects_mouseClicked(e);
    }

    void menuProjectRoot_keyPressed(KeyEvent e) {
		switch(e.getKeyCode()){
			case KeyEvent.VK_A:{
				this.menuProjectItemSaveCurrent_actionPerformed(null);
				break;
				}
			case KeyEvent.VK_E:{
				this.menuProjectItemSearchProject_actionPerformed(null);
				break;
				}
//			case KeyEvent.VK_H:{
//				this.menuProjectItemAddThisComp_actionPerformed(null);
//				break;
//				}
			case KeyEvent.VK_L:{
				this.menuProjectItemCloseCurrent_actionPerformed(null);
				break;
				}
			case KeyEvent.VK_M:{
				this.menuProjectItemDownAllComp_actionPerformed(null);
				break;
				}
			case KeyEvent.VK_N:{
				this.menuProjectItemNewProject_actionPerformed(null);
				break;
				}
			case KeyEvent.VK_R:{
				if(this.checkBoxViewPrjEditProject.isEnabled()) {
				    this.checkBoxViewPrjEditProject.setSelected(!this.checkBoxViewPrjEditProject.isSelected());
					this.checkBoxViewPrjEditProject_actionPerformed(null);
				}
				break;
				}
		}

    }

    void menuProjectItemSaveCurrent_actionPerformed(ActionEvent e){
		if(this.menuProjectItemSaveCurrent.isEnabled())
//			try {
//				this.currentPrjViewing.SaveProjectViewingObj();
				this.userInterface.SaveCurrPrj(this.currentPrjViewing.GetPrjID(),this.currentPrjViewing.IsEditable());
//			}catch(PolitellaException e1)    {
//				PolitellaException.ProcessException(e1);
//			}
    }

    void menuProjectItemCloseCurrent_actionPerformed(ActionEvent e) {
		if(this.menuProjectItemCloseCurrent.isEnabled()) {
			if(!this.currentPrjViewing.IsEditable())    {
			//il progetto  uno di quelli down
				this.menuProjectItemDownAllComp.setEnabled(false);
				this.menuPopUpManageItemDownAllComp.setEnabled(false);
			}

		    // il progetto correntemente visualizzato viene salvato sia che sia uno di quelli condivisi,
			// sia uno di quelli scaricati. In quest'ultimo caso  necessario per tenere conto degli eventuali
			//risorse gi scaricate.
			this.userInterface.SaveCurrPrj(this.currentPrjViewing.GetPrjID(),this.currentPrjViewing.IsEditable());

			if(!this.currentPrjViewing.IsEditable())    {
				// un progetto di tpo down, devo ctrl se ho scaricato tutte le risorse ad esso
				//associate in locale...
				if(this.currentPrjViewing.CheckAllBusModCompResourcesLocal())   {
				//...in tal caso posso trasformarlo in un progetto share
					int risp = JOptionPane.showConfirmDialog(this,"All resources of this downloaded project are local.\nDo you want sharing it ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
					if(risp==JOptionPane.YES_OPTION)    {
						//trasferisco il prj dal db down a quello share e sposto tutti i file ad esso associati
						try {
							this.userInterface.projectManager.MovePrjDownToPrjShare(this.currentPrjViewing.GetPrjID());
						}catch(PolitellaException e1)       {
							PolitellaException.ProcessException(this,e1);
						}
						this.UpdateTables();
					}
				}
			}

			this.menuProjectItemCloseCurrent.setEnabled(false);
			this.menuPopUpManageItemCloseCurrPrj.setEnabled(false);

			this.currentPrjViewing.ResetProjectViewingObj();

			this.SetEditChoiceItems(false);
			this.treeViewProjectInfos.setEnabled(false);

			this.checkBoxViewPrjEditProject.setEnabled(false);
			this.buttonOpenPrjDir.setEnabled(false);
			this.menuProjectItemEditCurrPrj.setEnabled(false);
			this.menuPopUpManageItemEditPrj.setEnabled(false);

			this.titledBorderViewProject.setTitle("Disabled");
			this.panelViewProject.repaint();
	    }
    }

	private void SetEditChoiceItems(boolean newState)  {

		this.currentPrjViewing.SetIsEditing(newState);

		this.checkBoxViewPrjEditProject.setSelected(newState);
		this.menuPopUpManageItemEditPrj.setSelected(newState);
		this.menuProjectItemEditCurrPrj.setSelected(newState);

		this.menuProjectItemSaveCurrent.setEnabled(newState);
		this.menuPopUpManageItemSaveCurrPrj.setEnabled(newState);

		this.buttonSaveCurrPrj.setEnabled(newState);
	}

    void checkBoxViewPrjEditProject_actionPerformed(ActionEvent e) {
		this.SetEditChoiceItems(this.checkBoxViewPrjEditProject.isSelected());
    }

    void menuProjectItemEditCurrPrj_actionPerformed(ActionEvent e) {
		if(this.menuProjectItemEditCurrPrj.isEnabled())
			this.SetEditChoiceItems(this.menuProjectItemEditCurrPrj.isSelected());
    }

    void menuPopUpManageItemEditPrj_actionPerformed(ActionEvent e) {
		this.SetEditChoiceItems(this.menuPopUpManageItemEditPrj.isSelected());
    }

    void menuProjectItemDownAllComp_actionPerformed(ActionEvent e) {
		if(this.menuProjectItemDownAllComp.isEnabled()) {
		    this.currentPrjViewing.SelectAllBusModComp();
//			Vector allBusCompSelected = this.currentPrjViewing.SelectAllBusModComp();
//			java.util.Enumeration list = allBusCompSelected.elements();
			Enumeration list = this.currentPrjViewing.busModCompMultiSelection.elements();
		    Vector currBusModCompInfos = new Vector();
			long prjID = this.currentPrjViewing.GetPrjID().longValue();
			while(list.hasMoreElements())   {
				BusinessModelComponent curr = (BusinessModelComponent)list.nextElement();

				if(curr.IsActive())   {
				    currBusModCompInfos.add(new Short(curr.GetBusModCompID()));

					String[] arrayOfRes=null;
					Vector vectorOfInfos=null;
					//scarico i sorgenti associati all'interno bus comp
					if((arrayOfRes=curr.GetBusModCompSourceLoc())!=null) {
						for(int i=0;i<arrayOfRes.length;i++)  {
							if(arrayOfRes[i].lastIndexOf('@')!=-1)  {
								//c' una risorsa da scaricare
								vectorOfInfos = new Vector(arrayOfRes.length);
								for(int y=0;y<vectorOfInfos.capacity();y++)
									vectorOfInfos.add(null);
								vectorOfInfos.remove(i);
								vectorOfInfos.add(i,arrayOfRes[i]);
		    		    		currBusModCompInfos.add(vectorOfInfos);
								currBusModCompInfos.add(new String("SOURCE"));
		    					this.userInterface.NewDownloadComponentElement(prjID,currBusModCompInfos);
								currBusModCompInfos.remove(2); currBusModCompInfos.remove(1);
							}
						}
					}

					//scarico i bin associati all'interno bus comp
					if((arrayOfRes=curr.GetBusModCompBinaryLoc())!=null) {
						for(int i=0;i<arrayOfRes.length;i++)  {
							if(arrayOfRes[i].lastIndexOf('@')!=-1)  {
								//c' una risorsa da scaricare
								vectorOfInfos = new Vector(arrayOfRes.length);
								for(int y=0;y<vectorOfInfos.capacity();y++)
									vectorOfInfos.add(null);
								vectorOfInfos.remove(i);
								vectorOfInfos.add(i,arrayOfRes[i]);
					    		currBusModCompInfos.add(vectorOfInfos);
								currBusModCompInfos.add(new String("BINARY"));
								this.userInterface.NewDownloadComponentElement(prjID,currBusModCompInfos);
								currBusModCompInfos.remove(2); currBusModCompInfos.remove(1);
							}
						}
					}

					//scarico la doc associata all'interno bus comp
					if((arrayOfRes=curr.GetBusModCompDocLoc())!=null)   {
						for(int i=0;i<arrayOfRes.length;i++)  {
							if(arrayOfRes[i].lastIndexOf('@')!=-1)  {
								//c' una risorsa da scaricare
								vectorOfInfos = new Vector(arrayOfRes.length);
								for(int y=0;y<vectorOfInfos.capacity();y++)
									vectorOfInfos.add(null);
								vectorOfInfos.remove(i);
								vectorOfInfos.add(i,arrayOfRes[i]);
					    		currBusModCompInfos.add(vectorOfInfos);
								currBusModCompInfos.add(new String("DOCUMENTATION"));
								this.userInterface.NewDownloadComponentElement(prjID,currBusModCompInfos);
								currBusModCompInfos.remove(2); currBusModCompInfos.remove(1);
							}
						}
					}

					//scarico le varie risorse associate al bus comp
					if(curr.IsBusinessRole())   {
						//se  una bus rela non ha gruppi di risorse proprie da scaricare
						short[] busModCompIDLinks = curr.GetBusModCompIDLinks();
						for(int i=0;i<busModCompIDLinks.length;i++) {
	    					//scarico un SOURCE
			    			if((arrayOfRes=curr.GetBusModComp_1_ResSourceLoc(busModCompIDLinks[i]))!=null)  {
								for(int z=0;z<arrayOfRes.length;z++)  {
									if(arrayOfRes[z].lastIndexOf('@')!=-1)  {
									//c' una risorsa da scaricare
										vectorOfInfos = new Vector(arrayOfRes.length);
										for(int y=0;y<vectorOfInfos.capacity();y++)
											vectorOfInfos.add(null);
										vectorOfInfos.remove(z);    vectorOfInfos.add(z,arrayOfRes[z]);
						    		    currBusModCompInfos.add(vectorOfInfos);
										currBusModCompInfos.add(new String("RESOURCES"));
										currBusModCompInfos.add(new Short(busModCompIDLinks[i]));
										currBusModCompInfos.add(new String("SOURCE"));
										this.userInterface.NewDownloadComponentElement(prjID,currBusModCompInfos);
										currBusModCompInfos.remove(4); currBusModCompInfos.remove(3); currBusModCompInfos.remove(2); currBusModCompInfos.remove(1);
									}
								}
		    				}
							//scarico un BINARY
			    			if((arrayOfRes=curr.GetBusModComp_1_ResBinaryLoc(busModCompIDLinks[i]))!=null)  {
								for(int z=0;z<arrayOfRes.length;z++)  {
									if(arrayOfRes[z].lastIndexOf('@')!=-1)  {
									//c' una risorsa da scaricare
										vectorOfInfos = new Vector(arrayOfRes.length);
										for(int y=0;y<vectorOfInfos.capacity();y++)
											vectorOfInfos.add(null);
										vectorOfInfos.remove(z);    vectorOfInfos.add(z,arrayOfRes[z]);
						    		    currBusModCompInfos.add(vectorOfInfos);
										currBusModCompInfos.add(new String("RESOURCES"));
										currBusModCompInfos.add(new Short(busModCompIDLinks[i]));
						    		    currBusModCompInfos.add(new String("BINARY"));
										this.userInterface.NewDownloadComponentElement(prjID,currBusModCompInfos);
										currBusModCompInfos.remove(4); currBusModCompInfos.remove(3); currBusModCompInfos.remove(2); currBusModCompInfos.remove(1);
									}
								}
							}
							//scarico un DOC
			    			if((arrayOfRes=curr.GetBusModComp_1_ResDocLoc(busModCompIDLinks[i]))!=null)  {
								for(int z=0;z<arrayOfRes.length;z++)  {
									if(arrayOfRes[z].lastIndexOf('@')!=-1)  {
									//c' una risorsa da scaricare
										vectorOfInfos = new Vector(arrayOfRes.length);
										for(int y=0;y<vectorOfInfos.capacity();y++)
											vectorOfInfos.add(null);
										vectorOfInfos.remove(z);    vectorOfInfos.add(z,arrayOfRes[z]);
						    		    currBusModCompInfos.add(vectorOfInfos);
										currBusModCompInfos.add(new String("RESOURCES"));
										currBusModCompInfos.add(new Short(busModCompIDLinks[i]));
			    		    		    currBusModCompInfos.add(new String("DOCUMENTATION"));
		    							this.userInterface.NewDownloadComponentElement(prjID,currBusModCompInfos);
										currBusModCompInfos.remove(4); currBusModCompInfos.remove(3); currBusModCompInfos.remove(2); currBusModCompInfos.remove(1);
									}
								}
							}
						}//chiudo il for
					}//chiudo if(businessRole)
				currBusModCompInfos.clear();
				}//chiudo if(active)
			}//chiudo il while
			this.currentPrjViewing.CancelMultiSelection();
			this.currentPrjViewing.repaint();
		}//chiudo if(enable)
    }

    void menuProjectItemAddThisComp_actionPerformed(ActionEvent e) {
//		if(this.menuProjectItemAddThisComp.isEnabled()) {
			new AddEditBusinessModelComponentDialog(this,true);
//		}
    }

    void menuPopUpManageItemDownAllComp_actionPerformed(ActionEvent e) {
		this.menuProjectItemDownAllComp_actionPerformed(null);
    }

    void menuPopUpManageItemAddThisComp_actionPerformed(ActionEvent e) {
		this.menuProjectItemAddThisComp_actionPerformed(null);
    }

    void menuPopUpManageItemSaveCurrPrj_actionPerformed(ActionEvent e) {
		this.menuProjectItemSaveCurrent_actionPerformed(null);
    }

    void menuPopUpManageItemCloseCurrPrj_actionPerformed(ActionEvent e) {
		this.menuProjectItemCloseCurrent_actionPerformed(null);
    }
    void buttonViewItem_actionPerformed(ActionEvent e) {
		this.menuActionItemViewItem_actionPerformed(null);

    }
    void buttonSaveCurrPrj_actionPerformed(ActionEvent e) {
		this.menuProjectItemSaveCurrent_actionPerformed(null);
    }

    void menuProjectItemDownThisComp_actionPerformed(ActionEvent e) {
		new SingleBusModCompDownloadResourcesDialog(this);
    }

    void menuProjectItemEditThisComp_actionPerformed(ActionEvent e) {
//		if(this.menuProjectItemEditThisComp.isEnabled())
			new AddEditBusinessModelComponentDialog(this,false);
    }

    void menuPopUpManageItemEditThisComp_actionPerformed(ActionEvent e) {
		this.menuProjectItemEditThisComp_actionPerformed(null);
    }

    void menuPopUpManageItemDownThisComp_actionPerformed(ActionEvent e) {
		this.menuProjectItemDownThisComp_actionPerformed(null);
    }

    void menuActionItemDeleteDownItemOnly1_actionPerformed(ActionEvent e) {
		if(this.tableDownProjects.getSelectedRow()==-1)    {
			//non ho selezionato nulla
			JOptionPane.showMessageDialog(this,"You must select an item before","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
		}
		else    {
			//ho selezionato una riga
            Long prjID =(Long)this.tableModelDownProjects.getValueAt(this.tableDownProjects.getSelectedRow(),4);

			if(this.currentPrjViewing.IsViewed() &&
				!this.currentPrjViewing.IsEditable() &&
				(prjID.longValue()==this.currentPrjViewing.GetPrjID().longValue()))  {
					// sto visualizzando un progetto down  e
					//sto cercando di cancellare il progetto che sto analizzando
					int risp=JOptionPane.showConfirmDialog(this,"You are analizing this project.\nDo you really want deleting it ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
		    		if(risp==JOptionPane.YES_OPTION)    {
						this.menuProjectItemCloseCurrent_actionPerformed(null);
						this.userInterface.projectManager.DelPrjDown(prjID.longValue());
			    	    this.UpdateTables();
		    		}
			}
			else    {
			// non sto visualizzando il progetto che voglio cancellare
				int risp=JOptionPane.showConfirmDialog(this,"Do you really want deleting this project ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
				if(risp==JOptionPane.YES_OPTION)    {
					this.userInterface.projectManager.DelPrjDown(prjID.longValue());
		    	    this.UpdateTables();
				}
			}

		}
    }

    void menuActionItemDeleteDownItemAll_actionPerformed(ActionEvent e) {
		if(this.currentPrjViewing.IsViewed()    &&
			!this.currentPrjViewing.IsEditable())    {
		// sto visualizzando un progetto down
			int risp=JOptionPane.showConfirmDialog(this,"You are analizing one downloaded project.\nDo you really want to continue ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
			if(risp==JOptionPane.YES_OPTION)    {
			// devo prima chiudere il progetto correntemente visualizzato
				this.menuProjectItemCloseCurrent_actionPerformed(null);
			}
			else
			//mi sono sbagliato, non voglio cancellare tutto, esco subito dal metodo
				return;
		}

		int risp=JOptionPane.showConfirmDialog(this,"Do you really want deleting all your downloaded projects ?","Warning",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
		if(risp==JOptionPane.YES_OPTION)    {
			//chiamo UserInterface per cancellare tutti i progetti scaricati
		    this.userInterface.projectManager.EmptyDbPrjDown();
			this.UpdateTables();
		}
    }

    void menuPopUpItemDeleteDownItemOnly1_actionPerformed(ActionEvent e) {
        this.menuActionItemDeleteDownItemOnly1_actionPerformed(null);
    }

    void menuPopUpItemDeleteDownItemAll_actionPerformed(ActionEvent e) {
        this.menuActionItemDeleteDownItemAll_actionPerformed(null);
    }

    void menuProjectItemDownSelectedComp_actionPerformed(ActionEvent e) {
		new MultiComponentsDownloadDialog(this);
    }

    void menuPopUpManageItemDownSelectedComp_actionPerformed(ActionEvent e) {
		this.menuProjectItemDownSelectedComp_actionPerformed(null);
    }

    void panelFoundProjects_mouseClicked(MouseEvent e) {
//		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
//		    this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
//		}
		this.ShowMenuPopUp(e);
    }

    void panelDownProjects_mouseClicked(MouseEvent e) {
//		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
//		    this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
//		}
		this.ShowMenuPopUp(e);
    }

    void panelSharedProjects_mouseClicked(MouseEvent e) {
//		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
//		    this.menuPopUpDefaultRoot.show(e.getComponent(),e.getX(),e.getY());
//		}
		this.ShowMenuPopUp(e);
    }

	/**
	 * Visualizza il menu popupdefault
	 */
	 private void ShowMenuPopUp(MouseEvent e)   {
		if(e.getModifiers()==MouseEvent.BUTTON3_MASK)   {
			Dimension compSize = e.getComponent().getSize();
			int xPos = 0;
			int yPos = 0;
			if((e.getX()+this.menuPopUpDefaultRoot.getWidth())>(int)compSize.getWidth())
				//il menu compare fuori della finestra lungo x
				xPos = e.getX()-this.menuPopUpDefaultRoot.getWidth();
			else
				xPos = e.getX();
			if((e.getY()+this.menuPopUpDefaultRoot.getHeight())>(int)compSize.getHeight())
				//il menu compare fuori della finestra lungo y
				yPos = e.getY()-this.menuPopUpDefaultRoot.getHeight();
			else
				yPos = e.getY();
			if(e.getComponent().getClass() == this.toolBar.getClass())
				//se il component  la toolbar, il popup deve comparire sempre in gi
				yPos = e.getY();
		    this.menuPopUpDefaultRoot.show(e.getComponent(),xPos,yPos);
		}
	 }

    void buttonOpenPrjDir_actionPerformed(ActionEvent e) {
		/**
		 * COn Linux dipende dal File Manager utilizzato
		 * Redhat with GMC
		 * Runtime.getRuntime().exec("gmc /usr/local");
		 *
		 * KDE vecchio
		 * Runtime.getRuntime().exec("kfm file:/<dir&gt");
		 *
		 * KDE nuovo
		 * Runtime.getRuntime(),exec("conqueror [path]");
		 *
		 * Gnome ha Nautilus
		 */

		String sist_oper = System.getProperty("os.name");
		try {
			if(sist_oper.compareTo("Windows 2000")==0 ||
				sist_oper.compareTo("Windows NT")==0 )
				Runtime.getRuntime().exec("cmd /C start "+ this.userInterface.projectManager.GetProjectFile(this.currentPrjViewing.GetPrjID().longValue(),this.currentPrjViewing.IsEditable(),!this.currentPrjViewing.IsEditable()).getParent() +" /B");
			else
				Runtime.getRuntime().exec("start "+ this.userInterface.projectManager.GetProjectFile(this.currentPrjViewing.GetPrjID().longValue(),this.currentPrjViewing.IsEditable(),!this.currentPrjViewing.IsEditable()).getParent());
		}catch(java.io.IOException e1)    {
		}
    }
}