/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import java.awt.*;
import javax.swing.*;
import javax.swing.JFileChooser;
import java.awt.event.*;

/**
 * Gestisce la finestra di dialogo per specificare dove creare il proprio database di progetti
 */
class PrjSavingPathChooseDialog extends JDialog {

    JFileChooser chooser = new JFileChooser();
    BorderLayout layoutPrjSavingPathChoose = new BorderLayout();

    SetupDialog parentDialog=null;
    JLabel empty1 = new JLabel();
    JLabel empty2 = new JLabel();
    JPanel panelButtonBarContainer = new JPanel();
    JButton buttonUseThis = new JButton();
    JButton buttonCancel = new JButton();
    JPanel panelButtonBar = new JPanel();
    BorderLayout layoutButtonBarContainer = new BorderLayout();
    GridLayout layoutpanelButtonBar = new GridLayout();
    JLabel empty4 = new JLabel();
    JLabel empty3 = new JLabel();
    JLabel empty5 = new JLabel();

    public PrjSavingPathChooseDialog(SetupDialog dialog) {
        super(dialog);

        this.parentDialog=dialog;

        try {
            jbInit();
//            this.setSize(500,235);
		    this.pack();

	        //Center the window
		    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	        Dimension frameSize = this.getSize();
            if (frameSize.height > screenSize.height) {
                frameSize.height = screenSize.height;
	        }
			if (frameSize.width > screenSize.width) {
                frameSize.width = screenSize.width;
            }
            this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
            this.setVisible(true);

        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {
        this.getContentPane().setLayout(layoutPrjSavingPathChoose);

        this.setModal(true);
        this.setTitle("Choose a directory");
        this.setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        this.setResizable(false);
        chooser.setFileFilter(null);
        chooser.setDialogTitle("");
        chooser.setControlButtonsAreShown(false);
        chooser.setApproveButtonText("");
        chooser.setApproveButtonToolTipText("");
        chooser.setDoubleBuffered(true);
        layoutPrjSavingPathChoose.setHgap(10);
        buttonUseThis.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonUseThis_actionPerformed(e);
            }
        });
        buttonUseThis.setToolTipText("Select one directory and press it");
        buttonUseThis.setText("Use this");
        buttonCancel.setToolTipText("Press it to use the default saving location");
        buttonCancel.setText("Use default path");
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonCancel_actionPerformed(e);
            }
        });
        panelButtonBar.setLayout(layoutpanelButtonBar);
        panelButtonBarContainer.setLayout(layoutButtonBarContainer);
        layoutButtonBarContainer.setHgap(10);
        layoutButtonBarContainer.setVgap(10);
        layoutpanelButtonBar.setColumns(4);
        layoutpanelButtonBar.setHgap(100);
        this.getContentPane().add(chooser, BorderLayout.CENTER);
        this.getContentPane().add(empty1, BorderLayout.WEST);
        this.getContentPane().add(empty2, BorderLayout.EAST);
        this.getContentPane().add(panelButtonBarContainer, BorderLayout.SOUTH);
        panelButtonBarContainer.add(panelButtonBar, BorderLayout.CENTER);
        panelButtonBar.add(buttonUseThis, null);
        panelButtonBar.add(buttonCancel, null);
        panelButtonBarContainer.add(empty4, BorderLayout.EAST);
        panelButtonBarContainer.add(empty3, BorderLayout.WEST);
        panelButtonBarContainer.add(empty5, BorderLayout.SOUTH);
        this.chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		this.chooser.setCurrentDirectory(new java.io.File(System.getProperty("user.dir")));

    }

    void buttonCancel_actionPerformed(ActionEvent e) {
        this.dispose();
        this.parentDialog.textFieldPrjSavingPath.setText("[Use default path]");
    }

    void buttonUseThis_actionPerformed(ActionEvent e) {
        this.parentDialog.textFieldPrjSavingPath.setText(this.chooser.getSelectedFile().getAbsolutePath());
        this.dispose();
    }

}