/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * Gestisce la finestra di dialogo per specificare i settaggi fondamentali per Politella
 */
class SetupDialog extends JDialog {
    ButtonGroup buttonGroupLook_Feel = new ButtonGroup();
    BorderLayout mainSetupDialogLayout = new BorderLayout();
    JLabel empty1 = new JLabel();
    JLabel empty2 = new JLabel();
    JPanel panelButtonsBarContainer = new JPanel();
    JButton buttonCancel = new JButton();
    JPanel panelButtonsBar = new JPanel();
    GridLayout layoutButtonsBar = new GridLayout();
    JButton buttonOK = new JButton();
    BorderLayout layoutpanelButtonsBarContainer = new BorderLayout();
    JLabel empty3 = new JLabel();
    JLabel empty4 = new JLabel();
    JLabel empty5 = new JLabel();
    JPanel panelMiscellaneusSetupContainer = new JPanel();
    JPanel panelMiscellaneusSetup = new JPanel();
    BorderLayout layoutMiscellaneusSetupContainer = new BorderLayout();
    JLabel empty7 = new JLabel();
    JLabel empty8 = new JLabel();
    JLabel empty9 = new JLabel();
    GridLayout layoutMiscellaneusSetup = new GridLayout();
    JPanel panelAccessPeerContainer = new JPanel();
    BorderLayout layoutAccessPeerContainer = new BorderLayout();
    JLabel labelAccessPeer = new JLabel();
    JTextField textFieldAccessPeer = new JTextField();
    JPanel panelMaxConnectionContainer = new JPanel();
    BorderLayout layoutMaxConnectionContainer = new BorderLayout();
    JLabel labelMaxConnection = new JLabel();
    JPanel panelDefaultTTLContainer = new JPanel();
    BorderLayout layoutDefaultTTLContainer = new BorderLayout();
    JLabel labelDefaultTTL = new JLabel();
    JPanel panelFrequencyPINGContainer = new JPanel();
    BorderLayout layoutFrequencyPINGContainer = new BorderLayout();
    JLabel labelFrequencyPING = new JLabel();
    JPanel panelPrjSavingPathContainer = new JPanel();
    BorderLayout layoutPrjSavingPathContainer = new BorderLayout();
    JLabel labelPrjSavingPath = new JLabel();
    JTextField textFieldPrjSavingPath = new JTextField();
    JPanel panelLook_FeelContainer = new JPanel();
    BorderLayout layoutLook_FeelContainer = new BorderLayout();
    JRadioButton choiceMetalLook_Feel = new JRadioButton();
    JRadioButton choiceMotifLook_Feel = new JRadioButton();
    JRadioButton choiceWindowsLook_Feel = new JRadioButton();
    JPanel panelLook_Feel = new JPanel();
    JLabel empty6 = new JLabel();
    GridLayout layoutLook_Feel = new GridLayout();
    JPanel panelDefaultTTLContainerInternal = new JPanel();
    JScrollBar scrollBarDefaultTTL = new JScrollBar();
    JTextField textFieldDefaultTTL = new JTextField();
    JPanel panelDefaultTTL = new JPanel();
    BorderLayout layoutDefaultTTLContainerInternal = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel panelFrequencyPINGContainerInternal = new JPanel();
    JScrollBar scrollBarFrequencyPING = new JScrollBar();
    BorderLayout layoutFrequencyPING = new BorderLayout();
    JPanel panelFrequencyPING = new JPanel();
    JTextField textFieldFrequencyPING = new JTextField();
    BorderLayout layoutFrequencyPINGContainerInternal = new BorderLayout();
    JPanel panelMaxConnectionContainerInternal = new JPanel();
    JScrollBar scrollBarMaxConnection = new JScrollBar();
    JPanel panelMaxConnection = new JPanel();
    JTextField textFieldMaxConnection = new JTextField();
    BorderLayout layoutMaxConnection = new BorderLayout();
    BorderLayout layoutMaxConnectionContainerInternal = new BorderLayout();
    JButton buttonSourceLocation = new JButton();
    JPanel panelMaxDownloadsContainer = new JPanel();
    BorderLayout layoutMaxDownloadsContainer = new BorderLayout();
    JLabel labelMaxDownloads = new JLabel();
    BorderLayout layoutMaxDownloadsContainerInternal = new BorderLayout();
    JScrollBar scrollBarMaxDownloads = new JScrollBar();
    JPanel panelMaxDownloads = new JPanel();
    JTextField textFieldMaxDownloads = new JTextField();
    BorderLayout layoutMaxDownloads = new BorderLayout();
    JPanel panelMaxDownloadsContainerInternal = new JPanel();

//	PolitellaFrame parentFrame=null;

	public SetupDialog(PolitellaFrame pFrame) {
        super(pFrame);

//		this.parentFrame=frame;

		try {
            jbInit();
            this.pack();

			//imposto i valori dei campi presenti nella dialog

			//imposto il valore del campo AccessPeer
			this.textFieldAccessPeer.setText(pFrame.userInterface.accessPeer);

			//imposto il valore del campo TTL
			this.textFieldDefaultTTL.setText(""+pFrame.userInterface.GetDefaultMsgTTL()+"");
			this.scrollBarDefaultTTL.setValue(pFrame.userInterface.GetDefaultMsgTTL()*-1);

			//imposto il valore del campo relativo al numero massimo di connessioni
           if(pFrame.userInterface.GetActiveConnectionsNum()!=0)
                this.scrollBarMaxConnection.setMaximum(-pFrame.userInterface.GetActiveConnectionsNum());
			this.scrollBarMaxConnection.setValue(-pFrame.userInterface.GetNumMaxActiveConnections());
            this.textFieldMaxConnection.setText(""+(this.scrollBarMaxConnection.getValue()*-1)+"");

			//imposto il valore del campo relativo al numero massimo di download
			this.scrollBarMaxDownloads.setValue(-pFrame.userInterface.GetNumMaxDownloadInCorso());
            this.textFieldMaxDownloads.setText(""+(this.scrollBarMaxDownloads.getValue()*-1)+"");

			//imposto il valore del campo frequencyPING
			this.textFieldFrequencyPING.setText(""+pFrame.userInterface.annuncioTimer.getDelay()/1000+"");
			this.scrollBarFrequencyPING.setValue(-pFrame.userInterface.annuncioTimer.getDelay()/1000);

			//imposto il valore del campo Project Saving Path
            if(pFrame.userInterface.prjSavingPath!=null)  {
                //ho gia' impostato il eprcorso di salvataggio dei progetti
                this.textFieldPrjSavingPath.setText(pFrame.userInterface.prjSavingPath);
				this.buttonSourceLocation.setEnabled(false);
//                this.textFieldPrjSavingPath.setEnabled(false);
				this.textFieldPrjSavingPath.setCaretPosition(0);
            }

            // decido quale choiceLookAndFeel selezionare
			if(pFrame.actualLookAndFeel.compareTo("Windows")==0)
				this.choiceWindowsLook_Feel.setSelected(true);
			else    {
				if(pFrame.actualLookAndFeel.compareTo("Motif")==0)
					this.choiceMotifLook_Feel.setSelected(true);
				else
					this.choiceMetalLook_Feel.setSelected(true);
			}

	        //Center the window
		    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	        Dimension frameSize = this.getSize();
            if (frameSize.height > screenSize.height) {
                frameSize.height = screenSize.height;
	        }
			if (frameSize.width > screenSize.width) {
                frameSize.width = screenSize.width;
            }
            this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
            this.setVisible(true);
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }

    void jbInit() throws Exception {
        this.setDefaultCloseOperation(0);
        this.setResizable(false);
        this.setModal(true);
        this.setTitle("Setup");
        this.getContentPane().setLayout(mainSetupDialogLayout);
        mainSetupDialogLayout.setHgap(10);
        mainSetupDialogLayout.setVgap(10);
        buttonCancel.setAlignmentX((float) 0.5);
        buttonCancel.setDoubleBuffered(true);
        buttonCancel.setMaximumSize(new Dimension(51, 27));
        buttonCancel.setMinimumSize(new Dimension(51, 27));
        buttonCancel.setPreferredSize(new Dimension(51, 27));
        buttonCancel.setText("Cancel");
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonCancel_actionPerformed(e);
            }
        });
        panelButtonsBar.setLayout(layoutButtonsBar);
        layoutButtonsBar.setColumns(4);
        layoutButtonsBar.setHgap(100);
        buttonOK.setAlignmentX((float) 1.0);
        buttonOK.setAlignmentY((float) 1.0);
        buttonOK.setDoubleBuffered(true);
        buttonOK.setNextFocusableComponent(buttonCancel);
        buttonOK.setText("OK");
        buttonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonOK_actionPerformed(e);
            }
        });
        panelButtonsBarContainer.setLayout(layoutpanelButtonsBarContainer);
        layoutpanelButtonsBarContainer.setHgap(10);
        layoutpanelButtonsBarContainer.setVgap(10);
        panelMiscellaneusSetup.setLayout(layoutMiscellaneusSetup);
        panelMiscellaneusSetupContainer.setLayout(layoutMiscellaneusSetupContainer);
        layoutMiscellaneusSetupContainer.setHgap(10);
        layoutMiscellaneusSetupContainer.setVgap(10);
        layoutMiscellaneusSetup.setRows(6);
        layoutMiscellaneusSetup.setColumns(1);
        layoutMiscellaneusSetup.setHgap(10);
        layoutMiscellaneusSetup.setVgap(10);
        panelMiscellaneusSetup.setBorder(BorderFactory.createCompoundBorder(new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Miscellaneus"),BorderFactory.createEmptyBorder(10,10,10,10)));
        panelMiscellaneusSetup.setMaximumSize(new Dimension(313, 328));
        panelAccessPeerContainer.setLayout(layoutAccessPeerContainer);
        labelAccessPeer.setDoubleBuffered(true);
        labelAccessPeer.setToolTipText("Insert the address of the access peer");
        labelAccessPeer.setText("Access Peer");
        textFieldAccessPeer.setDoubleBuffered(true);
        textFieldAccessPeer.setMaximumSize(new Dimension(165, 21));
        textFieldAccessPeer.setMinimumSize(new Dimension(41, 21));
        textFieldAccessPeer.setPreferredSize(new Dimension(165, 21));
        textFieldAccessPeer.setToolTipText("");
        textFieldAccessPeer.setSelectionEnd(20);
        textFieldAccessPeer.setColumns(15);
        textFieldAccessPeer.setHorizontalAlignment(SwingConstants.LEFT);
        textFieldAccessPeer.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(KeyEvent e) {
                textFieldAccessPeer_keyReleased(e);
            }
        });
        panelMaxConnectionContainer.setLayout(layoutMaxConnectionContainer);
        labelMaxConnection.setDoubleBuffered(true);
        labelMaxConnection.setToolTipText("Insert the max number of possible active connection");
        labelMaxConnection.setText("Max. Connections");
        panelDefaultTTLContainer.setLayout(layoutDefaultTTLContainer);
        labelDefaultTTL.setDoubleBuffered(true);
        labelDefaultTTL.setToolTipText("Insert the default TTL (min 1, max. 128)");
        labelDefaultTTL.setText("Default TTL");
        panelFrequencyPINGContainer.setLayout(layoutFrequencyPINGContainer);
        labelFrequencyPING.setToolTipText("Insert the frequency, in seconds, to send the PING");
        labelFrequencyPING.setText("Freq. sending PING");
        panelPrjSavingPathContainer.setLayout(layoutPrjSavingPathContainer);
        labelPrjSavingPath.setToolTipText("Insert where you want to save your project");
        labelPrjSavingPath.setText("Project Saving Path   ");
        textFieldPrjSavingPath.setMaximumSize(new Dimension(200, 21));
        textFieldPrjSavingPath.setPreferredSize(new Dimension(180, 21));
        textFieldPrjSavingPath.setCaretPosition(0);
        textFieldPrjSavingPath.setEditable(false);
        textFieldPrjSavingPath.setColumns(15);
        layoutPrjSavingPathContainer.setVgap(10);
        layoutFrequencyPINGContainer.setHgap(10);
        layoutFrequencyPINGContainer.setVgap(10);
        layoutDefaultTTLContainer.setHgap(10);
        layoutDefaultTTLContainer.setVgap(10);
        layoutMaxConnectionContainer.setHgap(10);
        layoutMaxConnectionContainer.setVgap(10);
        layoutAccessPeerContainer.setHgap(10);
        layoutAccessPeerContainer.setVgap(10);
        panelPrjSavingPathContainer.setMaximumSize(new Dimension(281, 21));
        panelAccessPeerContainer.setMaximumSize(new Dimension(244, 21));
        panelMaxConnectionContainer.setMaximumSize(new Dimension(156, 21));
        panelDefaultTTLContainer.setMaximumSize(new Dimension(122, 21));
        panelFrequencyPINGContainer.setMaximumSize(new Dimension(167, 21));
        panelMiscellaneusSetupContainer.setMaximumSize(new Dimension(333, 338));
        panelButtonsBarContainer.setMaximumSize(new Dimension(222, 37));
        panelButtonsBar.setMaximumSize(new Dimension(202, 27));
        panelLook_FeelContainer.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Look&Feel"));
        panelLook_FeelContainer.setMaximumSize(new Dimension(217, 123));
        panelLook_FeelContainer.setLayout(layoutLook_FeelContainer);
        choiceMetalLook_Feel.setRequestFocusEnabled(false);
        choiceMetalLook_Feel.setPreferredSize(new Dimension(55, 25));
        choiceMetalLook_Feel.setMinimumSize(new Dimension(55, 25));
        choiceMetalLook_Feel.setDoubleBuffered(true);
        choiceMetalLook_Feel.setText("Metal");
        choiceMetalLook_Feel.setToolTipText("Metal loop and feel");
        choiceMetalLook_Feel.setMaximumSize(new Dimension(55, 25));
        choiceMotifLook_Feel.setRequestFocusEnabled(false);
        choiceMotifLook_Feel.setPreferredSize(new Dimension(55, 25));
        choiceMotifLook_Feel.setMinimumSize(new Dimension(55, 25));
        choiceMotifLook_Feel.setDoubleBuffered(true);
        choiceMotifLook_Feel.setText("Motif");
        choiceMotifLook_Feel.setToolTipText("Motif look and feel");
        choiceMotifLook_Feel.setMaximumSize(new Dimension(55, 25));
        choiceWindowsLook_Feel.setRequestFocusEnabled(false);
        choiceWindowsLook_Feel.setPreferredSize(new Dimension(55, 25));
        choiceWindowsLook_Feel.setMinimumSize(new Dimension(55, 25));
        choiceWindowsLook_Feel.setDoubleBuffered(true);
        choiceWindowsLook_Feel.setText("Windows");
        choiceWindowsLook_Feel.setToolTipText("Windows look and feel");
        choiceWindowsLook_Feel.setMaximumSize(new Dimension(55, 25));
        panelLook_Feel.setMaximumSize(new Dimension(55, 95));
        panelLook_Feel.setLayout(layoutLook_Feel);
        layoutLook_Feel.setRows(3);
        layoutLook_Feel.setColumns(1);
        layoutLook_Feel.setHgap(10);
        layoutLook_Feel.setVgap(10);
        layoutLook_FeelContainer.setHgap(10);
        layoutLook_FeelContainer.setVgap(10);
        layoutLook_Feel.setRows(3);
        layoutLook_Feel.setColumns(1);
        layoutLook_Feel.setHgap(10);
        layoutLook_Feel.setVgap(10);
        scrollBarDefaultTTL.setMaximum(-1);
        scrollBarDefaultTTL.setMinimum(-128);
        scrollBarDefaultTTL.setPreferredSize(new Dimension(16, 21));
        scrollBarDefaultTTL.setDoubleBuffered(true);
        scrollBarDefaultTTL.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(AdjustmentEvent e) {
                scrollBarDefaultTTL_adjustmentValueChanged(e);
            }
        });
        textFieldDefaultTTL.setDoubleBuffered(true);
        textFieldDefaultTTL.setMaximumSize(new Dimension(33, 21));
        textFieldDefaultTTL.setPreferredSize(new Dimension(10, 21));
        textFieldDefaultTTL.setEditable(false);
        textFieldDefaultTTL.setColumns(3);
        textFieldDefaultTTL.setHorizontalAlignment(SwingConstants.RIGHT);
        panelDefaultTTL.setLayout(borderLayout2);
        panelDefaultTTL.setMaximumSize(new Dimension(50, 21));
        panelDefaultTTL.setPreferredSize(new Dimension(50, 21));
        panelDefaultTTLContainerInternal.setLayout(layoutDefaultTTLContainerInternal);
        scrollBarFrequencyPING.setUnitIncrement(10);
        scrollBarFrequencyPING.setMaximum(-10);
        scrollBarFrequencyPING.setMinimum(-300);
        scrollBarFrequencyPING.setValue(-30);
        scrollBarFrequencyPING.setPreferredSize(new Dimension(16, 21));
        scrollBarFrequencyPING.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(AdjustmentEvent e) {
                scrollBarFrequencyPING_adjustmentValueChanged(e);
            }
        });
        panelFrequencyPING.setLayout(layoutFrequencyPING);
        panelFrequencyPING.setMaximumSize(new Dimension(49, 21));
        textFieldFrequencyPING.setDoubleBuffered(true);
        textFieldFrequencyPING.setMaximumSize(new Dimension(33, 21));
        textFieldFrequencyPING.setEditable(false);
        textFieldFrequencyPING.setColumns(3);
        textFieldFrequencyPING.setHorizontalAlignment(SwingConstants.RIGHT);
        panelFrequencyPINGContainerInternal.setLayout(layoutFrequencyPINGContainerInternal);
        scrollBarMaxConnection.setMaximum(-1);
        scrollBarMaxConnection.setMinimum(-32);
        scrollBarMaxConnection.setPreferredSize(new Dimension(16, 21));
        scrollBarMaxConnection.setDoubleBuffered(true);
        scrollBarMaxConnection.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(AdjustmentEvent e) {
                scrollBarMaxConnection_adjustmentValueChanged(e);
            }
        });
        panelMaxConnection.setLayout(layoutMaxConnection);
        panelMaxConnection.setMaximumSize(new Dimension(49, 21));
        textFieldMaxConnection.setDoubleBuffered(true);
        textFieldMaxConnection.setMaximumSize(new Dimension(33, 21));
        textFieldMaxConnection.setEditable(false);
        textFieldMaxConnection.setColumns(3);
        textFieldMaxConnection.setHorizontalAlignment(SwingConstants.RIGHT);
        panelMaxConnectionContainerInternal.setLayout(layoutMaxConnectionContainerInternal);
        buttonSourceLocation.setIcon(new ImageIcon("Interfaccia/Icons/OpenSmall.gif"));
        buttonSourceLocation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonSourceLocation_actionPerformed(e);
            }
        });
        buttonSourceLocation.setMargin(new Insets(2, 2, 2, 2));
        buttonSourceLocation.setHorizontalTextPosition(SwingConstants.CENTER);
        buttonSourceLocation.setPreferredSize(new Dimension(22, 20));
        panelMaxDownloadsContainer.setLayout(layoutMaxDownloadsContainer);
        labelMaxDownloads.setText("Max. Downloads");
        labelMaxDownloads.setToolTipText("Insert the max number of contemporary downloads");
        labelMaxDownloads.setDoubleBuffered(true);
        scrollBarMaxDownloads.addAdjustmentListener(new java.awt.event.AdjustmentListener() {
            public void adjustmentValueChanged(AdjustmentEvent e) {
                scrollBarMaxDownloads_adjustmentValueChanged(e);
            }
        });
        scrollBarMaxDownloads.setDoubleBuffered(true);
        scrollBarMaxDownloads.setPreferredSize(new Dimension(16, 21));
        scrollBarMaxDownloads.setMinimum(-32);
        scrollBarMaxDownloads.setMaximum(-1);
        panelMaxDownloads.setMaximumSize(new Dimension(49, 21));
        panelMaxDownloads.setLayout(layoutMaxDownloads);
        textFieldMaxDownloads.setDoubleBuffered(true);
        textFieldMaxDownloads.setMaximumSize(new Dimension(33, 21));
        textFieldMaxDownloads.setEditable(false);
        textFieldMaxDownloads.setColumns(3);
        textFieldMaxDownloads.setHorizontalAlignment(SwingConstants.RIGHT);
        panelMaxDownloadsContainerInternal.setLayout(layoutMaxDownloadsContainerInternal);
        this.getContentPane().add(empty1, BorderLayout.EAST);
        this.getContentPane().add(empty2, BorderLayout.WEST);
        this.getContentPane().add(panelButtonsBarContainer, BorderLayout.SOUTH);
        panelButtonsBarContainer.add(panelButtonsBar, BorderLayout.CENTER);
        panelButtonsBar.add(buttonOK, null);
        panelButtonsBar.add(buttonCancel, null);
        panelButtonsBarContainer.add(empty3, BorderLayout.WEST);
        panelButtonsBarContainer.add(empty4, BorderLayout.EAST);
        panelButtonsBarContainer.add(empty5, BorderLayout.SOUTH);
        this.getContentPane().add(panelMiscellaneusSetupContainer, BorderLayout.NORTH);
        panelMiscellaneusSetupContainer.add(panelMiscellaneusSetup, BorderLayout.CENTER);
        panelMaxDownloadsContainer.add(labelMaxDownloads, BorderLayout.CENTER);
        panelMaxDownloadsContainer.add(panelMaxDownloadsContainerInternal, BorderLayout.EAST);
        panelMaxDownloadsContainerInternal.add(panelMaxDownloads, BorderLayout.EAST);
        panelMaxDownloads.add(scrollBarMaxDownloads, BorderLayout.EAST);
        panelMaxDownloads.add(textFieldMaxDownloads, BorderLayout.CENTER);
        panelMiscellaneusSetup.add(panelAccessPeerContainer, null);
        panelAccessPeerContainer.add(labelAccessPeer, BorderLayout.WEST);
        panelAccessPeerContainer.add(textFieldAccessPeer, BorderLayout.CENTER);
        panelMiscellaneusSetup.add(panelMaxConnectionContainer, null);
        panelMiscellaneusSetup.add(panelMaxDownloadsContainer, null);
        panelMaxConnectionContainer.add(labelMaxConnection, BorderLayout.WEST);
        panelMaxConnectionContainer.add(panelMaxConnectionContainerInternal, BorderLayout.CENTER);
        panelMaxConnectionContainerInternal.add(panelMaxConnection, BorderLayout.EAST);
        panelMaxConnection.add(scrollBarMaxConnection, BorderLayout.EAST);
        panelMaxConnection.add(textFieldMaxConnection, BorderLayout.CENTER);
        panelMiscellaneusSetup.add(panelDefaultTTLContainer, null);
        panelDefaultTTLContainer.add(labelDefaultTTL, BorderLayout.WEST);
        panelDefaultTTLContainer.add(panelDefaultTTLContainerInternal, BorderLayout.CENTER);
        panelDefaultTTLContainerInternal.add(panelDefaultTTL, BorderLayout.EAST);
        panelDefaultTTL.add(textFieldDefaultTTL, BorderLayout.CENTER);
        panelDefaultTTL.add(scrollBarDefaultTTL, BorderLayout.EAST);
        panelMiscellaneusSetup.add(panelFrequencyPINGContainer, null);
        panelFrequencyPINGContainer.add(labelFrequencyPING, BorderLayout.WEST);
        panelFrequencyPINGContainer.add(panelFrequencyPINGContainerInternal, BorderLayout.CENTER);
        panelFrequencyPINGContainerInternal.add(panelFrequencyPING, BorderLayout.EAST);
        panelFrequencyPING.add(textFieldFrequencyPING, BorderLayout.CENTER);
        panelFrequencyPING.add(scrollBarFrequencyPING, BorderLayout.EAST);
        panelMiscellaneusSetup.add(panelPrjSavingPathContainer, null);
        panelPrjSavingPathContainer.add(labelPrjSavingPath, BorderLayout.WEST);
        panelPrjSavingPathContainer.add(textFieldPrjSavingPath, BorderLayout.CENTER);
        panelPrjSavingPathContainer.add(buttonSourceLocation, BorderLayout.EAST);
        panelMiscellaneusSetupContainer.add(empty7, BorderLayout.EAST);
        panelMiscellaneusSetupContainer.add(empty8, BorderLayout.WEST);
        panelMiscellaneusSetupContainer.add(empty9, BorderLayout.NORTH);
        this.getContentPane().add(panelLook_FeelContainer, BorderLayout.CENTER);
        panelLook_FeelContainer.add(panelLook_Feel, BorderLayout.CENTER);
        panelLook_Feel.add(choiceWindowsLook_Feel, null);
        panelLook_Feel.add(choiceMotifLook_Feel, null);
        panelLook_Feel.add(choiceMetalLook_Feel, null);
        panelLook_FeelContainer.add(empty6, BorderLayout.WEST);
        buttonGroupLook_Feel.add(choiceWindowsLook_Feel);
        buttonGroupLook_Feel.add(choiceMotifLook_Feel);
        buttonGroupLook_Feel.add(choiceMetalLook_Feel);
    }

    void buttonCancel_actionPerformed(ActionEvent e) {
        if(this.buttonSourceLocation.isEnabled()) {
            JOptionPane.showMessageDialog(this.getParent(),"You must specify the project saving path.\nPlease do it.","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
            return;
        }
		this.dispose();
    }

    void buttonOK_actionPerformed(ActionEvent e) {
		PolitellaFrame pFrame = (PolitellaFrame) this.getParent();

		// chiamo UserInterface per impostare i parametri settati nella dialog
		//imposto il TTL
		pFrame.userInterface.SetDefaultMsgTTL((short)-this.scrollBarDefaultTTL.getValue());

		// imposto il valore dell'accessPeer
		pFrame.userInterface.accessPeer=null;
        pFrame.userInterface.accessPeer=this.textFieldAccessPeer.getText();

		//imposto il numero massimo di connessioni
		pFrame.userInterface.SetNumMaxActiveConnections((short)-this.scrollBarMaxConnection.getValue());

		//imposto il numero massimo di download
		pFrame.userInterface.SetNumMaxDownloadInCorso((short)-this.scrollBarMaxDownloads.getValue());

		//imposto il timer di invio dei PING
		pFrame.userInterface.annuncioTimer.setDelay(-this.scrollBarFrequencyPING.getValue()*1000);

        //imposto il valore del percorso di slavataggio dei progetti
        if(this.buttonSourceLocation.isEnabled()) {
            if(this.textFieldPrjSavingPath.getText().compareTo("")==0)  {
                //dovevo inserire un percorso ma non l'ho fatto: l'inserimento e' obbligatorio
                int res=JOptionPane.showConfirmDialog(pFrame,"You haven't specified the project saving path.\nIf you insert nothing, Politella will use the default path.\nPress OK to use the default saving path.\nPress Cancel to specify one.","Warning",JOptionPane.OK_CANCEL_OPTION,JOptionPane.QUESTION_MESSAGE,new ImageIcon("Interfaccia/Icons/QuestionDialog.gif"));
                if(res==JOptionPane.CANCEL_OPTION)
                    //ho premuto CANCEL, voglio specificare un mio percorso
                    return;
            }
        }

		this.dispose();

		if(this.choiceWindowsLook_Feel.isSelected())
			pFrame.UpdateLookAndFeel("Windows");
		else    {
			if(this.choiceMetalLook_Feel.isSelected())
				pFrame.UpdateLookAndFeel("Metal");
			else
				pFrame.UpdateLookAndFeel("Motif");
		}
    }

    void scrollBarDefaultTTL_adjustmentValueChanged(AdjustmentEvent e) {
		this.textFieldDefaultTTL.setText(""+this.scrollBarDefaultTTL.getValue()*-1+"");
    }

    void scrollBarMaxConnection_adjustmentValueChanged(AdjustmentEvent e) {
		PolitellaFrame pFrame = (PolitellaFrame) this.getParent();

		int newValue=this.scrollBarMaxConnection.getValue();
		if(newValue>pFrame.userInterface.GetActiveConnectionsNum())
		//non posso impostare il parametro realtivo al numero di max di connessioni
		//minore del numero di connessioni gi attive
		    JOptionPane.showMessageDialog(this,"You have already "+(-(newValue)+1)+" active connection","Warning",JOptionPane.WARNING_MESSAGE,new ImageIcon("Interfaccia/Icons/WarningDialog.gif"));
		else
			this.textFieldMaxConnection.setText(""+this.scrollBarMaxConnection.getValue()*-1+"");
    }

    void scrollBarFrequencyPING_adjustmentValueChanged(AdjustmentEvent e) {
		this.textFieldFrequencyPING.setText(""+-this.scrollBarFrequencyPING.getValue()+"");
    }

    void textFieldAccessPeer_keyReleased(KeyEvent e) {
		String tmp= this.textFieldAccessPeer.getText();
		if(tmp.length()>=30 && e.getKeyChar()!='\b') {
			int i=this.textFieldAccessPeer.getCaretPosition();
			this.textFieldAccessPeer.setText(tmp.substring(0,29));
			if(i==30)
				i--;
			this.textFieldAccessPeer.setCaretPosition(i);
		}
    }

    void buttonSourceLocation_actionPerformed(ActionEvent e) {
        PolitellaFrame pFrame = (PolitellaFrame) this.getParent();

		if(this.buttonSourceLocation.isEnabled()) {
        // devo specificare un percorso di salvataggio
            new PrjSavingPathChooseDialog(this);
//            this.textFieldPrjSavingPath.setEnabled(false);
			this.buttonSourceLocation.setEnabled(false);
			this.textFieldPrjSavingPath.setCaretPosition(0);
            if(!this.textFieldPrjSavingPath.getText().startsWith("["))
                //nel textfiled non c'e' scritto [Use default path], ma un percorso specifico
                pFrame.userInterface.prjSavingPath=this.textFieldPrjSavingPath.getText();
        }
    }

    void scrollBarMaxDownloads_adjustmentValueChanged(AdjustmentEvent e) {
		this.textFieldMaxDownloads.setText(""+this.scrollBarMaxDownloads.getValue()*-1+"");
    }
}