/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import Utility.ProjectType;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import java.util.Vector;

/**
 * Gestisce la finestra di dialogo per il download delle risorse di un singolo bus comp selezionato
 */
class SingleBusModCompDownloadResourcesDialog extends JDialog {
    JPanel panelButtonBar = new JPanel();
    BorderLayout layoutRoot = new BorderLayout();
    JPanel panelButtonBarContainer = new JPanel();
    GridLayout layoutButtonBarContainer = new GridLayout();
    JButton buttonOk = new JButton();
    JButton buttonCancel = new JButton();
    BorderLayout layoutButtonBar = new BorderLayout();
    JLabel empty3 = new JLabel();
    JLabel empty4 = new JLabel();
    JLabel empty5 = new JLabel();

    SingleBusModCompDownloadResourcesPanel singleBusModCompDownloadResourcesPanel = null;

    public SingleBusModCompDownloadResourcesDialog(PolitellaFrame pFrame) {
        super(pFrame);

		this.singleBusModCompDownloadResourcesPanel = new SingleBusModCompDownloadResourcesPanel(pFrame.currentPrjViewing.busModCompManaging);

        try {
            jbInit();
            pack();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }

		String compName = null;
		if(pFrame.currentPrjViewing.busModCompManaging.GetBusModCompID()<ProjectType.numBusinessRole)
			compName = ProjectType.prjTypeDescription[2][pFrame.currentPrjViewing.busModCompManaging.GetBusModCompID()+1];
		else
			compName = ProjectType.prjTypeDescription[2][pFrame.currentPrjViewing.busModCompManaging.GetBusModCompID()+2];

		this.setTitle(this.getTitle() + compName);

        //Center the window
	    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
           if (frameSize.height > screenSize.height) {
               frameSize.height = screenSize.height;
        }
		if (frameSize.width > screenSize.width) {
               frameSize.width = screenSize.width;
           }
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        this.setVisible(true);
    }

    void jbInit() throws Exception {
        panelButtonBar.setLayout(layoutButtonBar);
        this.getContentPane().setLayout(layoutRoot);
        panelButtonBarContainer.setLayout(layoutButtonBarContainer);
        layoutButtonBarContainer.setColumns(4);
        layoutButtonBarContainer.setHgap(100);
        buttonOk.setText("OK");
        buttonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonOk_actionPerformed(e);
            }
        });
        buttonCancel.setText("Cancel");
        buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                buttonCancel_actionPerformed(e);
            }
        });
        layoutButtonBar.setHgap(30);
        layoutButtonBar.setVgap(10);
        this.setDefaultCloseOperation(0);
        this.setResizable(false);
        this.setModal(true);
        this.setTitle("Choice one or more elements: ");
        panelButtonBar.setPreferredSize(new Dimension(450, 37));
        getContentPane().add(panelButtonBar, BorderLayout.SOUTH);
        panelButtonBar.add(panelButtonBarContainer, BorderLayout.CENTER);
        panelButtonBarContainer.add(buttonOk, null);
        panelButtonBarContainer.add(buttonCancel, null);
        panelButtonBar.add(empty3, BorderLayout.SOUTH);
        panelButtonBar.add(empty4, BorderLayout.WEST);
        panelButtonBar.add(empty5, BorderLayout.EAST);
        this.getContentPane().add(singleBusModCompDownloadResourcesPanel, BorderLayout.CENTER);
    }

    void buttonCancel_actionPerformed(ActionEvent e) {
		((PolitellaFrame)this.getParent()).currentPrjViewing.busModCompManaging=null;
		this.dispose();
    }

    void buttonOk_actionPerformed(ActionEvent e) {
		PolitellaFrame pFrame= (PolitellaFrame)this.getParent();

		this.singleBusModCompDownloadResourcesPanel.StartDownloads(pFrame);

		pFrame.currentPrjViewing.busModCompManaging=null;

		this.dispose();
    }
}