/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import Utility.BusinessModelComponent;
import Utility.ProjectType;

import java.util.Vector;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;

public class SingleBusModCompDownloadResourcesPanel extends JPanel {
    BorderLayout layoutRoot = new BorderLayout();
    JPanel panelSingleBusCompAllResourcesContainer = new JPanel();
    JTabbedPane tabbedPaneSingleBusCompResources = new JTabbedPane();
    BorderLayout layoutSingleBusCompAllResourcesContainer = new BorderLayout();
    JLabel empty1 = new JLabel();
    JLabel empty2 = new JLabel();
    JLabel empty3 = new JLabel();
    JLabel empty4 = new JLabel();
    JPanel panelSingleBusCompDocSourceBinContainer = new JPanel();
    GridLayout layoutSingleBusCompDocSourceBinContainer = new GridLayout();
    JScrollPane scrollPaneSourceResources = new JScrollPane();
    JScrollPane scrollPaneDocResources = new JScrollPane();
    JScrollPane scrollPaneBinaryResources = new JScrollPane();
    JList listSourceResources = new JList();
    JList listBinaryResources = new JList();
    JList listDocResources = new JList();

	/**
	 * Specifica il bus comp di cui si sta procedendo al download delle risorse ad esse associate
	 */
	private BusinessModelComponent curr=null;

	public SingleBusModCompDownloadResourcesPanel(BusinessModelComponent curr) {
        this.curr=curr;

		try {
            jbInit();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }

		String[] data = curr.GetBusModCompSourceLoc();
		if(data!=null)
			this.listSourceResources.setListData(data);

		data =curr.GetBusModCompBinaryLoc();
		if(data!=null)
			this.listBinaryResources.setListData(data);

		data =curr.GetBusModCompDocLoc();
		if(data!=null)
			this.listDocResources.setListData(data);


		//aggiungo al tabbedpane tanti panel quanti sono i gruppi di risorse
		//del bus comp curr
		short[] busModComIDLinks = curr.GetBusModCompIDLinks();
		Vector res = new Vector();
		for(int i=0;i<busModComIDLinks.length;i++)  {
			res.add(curr.GetBusModComp_1_ResSourceLoc(busModComIDLinks[i]));
			res.add(curr.GetBusModComp_1_ResBinaryLoc(busModComIDLinks[i]));
			res.add(curr.GetBusModComp_1_ResDocLoc(busModComIDLinks[i]));
			this.tabbedPaneSingleBusCompResources.add(new ChoiceBusModCompResourcesToDownloadPanel(this.curr.GetBusModCompID(),busModComIDLinks[i],res));
			if(curr.IsBusinessRole())   {
			//i gruppi si risorse si riferiscono solo a bus relatiomship =>
			//il +2 serve perch nell'elenco delle descrizioni dei bus comp prima delle bus rela ci sono 2 campi Any...
				this.tabbedPaneSingleBusCompResources.setTitleAt(this.tabbedPaneSingleBusCompResources.getTabCount()-1,ProjectType.prjTypeDescription[2][busModComIDLinks[i]+2]);
				this.tabbedPaneSingleBusCompResources.setToolTipTextAt(this.tabbedPaneSingleBusCompResources.getTabCount()-1,"Business Relationship "+ProjectType.prjTypeDescription[2][busModComIDLinks[i]+2]);
			}
			else    {
			//i gruppi si risorse si riferiscono solo a bus role =>
			//il +1 serve perch nell'elenco delle descrizioni dei bus comp prima dei bus role c' 1 campo Any...
				this.tabbedPaneSingleBusCompResources.setTitleAt(this.tabbedPaneSingleBusCompResources.getTabCount()-1,ProjectType.prjTypeDescription[2][busModComIDLinks[i]+1]);
				this.tabbedPaneSingleBusCompResources.setToolTipTextAt(this.tabbedPaneSingleBusCompResources.getTabCount()-1,"Business Role "+ProjectType.prjTypeDescription[2][busModComIDLinks[i]+2]);
			}
			res.clear();
		}
    }

    void jbInit() throws Exception {
        this.setLayout(layoutRoot);
        panelSingleBusCompAllResourcesContainer.setLayout(layoutSingleBusCompAllResourcesContainer);
        layoutRoot.setHgap(10);
        layoutRoot.setVgap(10);
        layoutSingleBusCompAllResourcesContainer.setHgap(10);
        layoutSingleBusCompAllResourcesContainer.setVgap(10);
        panelSingleBusCompDocSourceBinContainer.setLayout(layoutSingleBusCompDocSourceBinContainer);
        layoutSingleBusCompDocSourceBinContainer.setColumns(4);
        layoutSingleBusCompDocSourceBinContainer.setHgap(10);
        layoutSingleBusCompDocSourceBinContainer.setVgap(10);
        scrollPaneSourceResources.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Source Files"));
        scrollPaneSourceResources.setPreferredSize(new Dimension(100, 100));
        scrollPaneDocResources.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Doc. Files"));
        scrollPaneDocResources.setPreferredSize(new Dimension(100, 100));
        scrollPaneBinaryResources.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Binary Files"));
        scrollPaneBinaryResources.setPreferredSize(new Dimension(100, 100));
        listSourceResources.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(178, 178, 178),new Color(124, 124, 124)));
        listSourceResources.setVisibleRowCount(3);
        listBinaryResources.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(178, 178, 178),new Color(124, 124, 124)));
        listBinaryResources.setVisibleRowCount(3);
        listDocResources.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(178, 178, 178),new Color(124, 124, 124)));
        listDocResources.setVisibleRowCount(3);
        this.add(panelSingleBusCompAllResourcesContainer, BorderLayout.CENTER);
        panelSingleBusCompAllResourcesContainer.add(tabbedPaneSingleBusCompResources, BorderLayout.CENTER);
        panelSingleBusCompAllResourcesContainer.add(panelSingleBusCompDocSourceBinContainer, BorderLayout.NORTH);
        panelSingleBusCompDocSourceBinContainer.add(scrollPaneSourceResources, null);
        scrollPaneSourceResources.getViewport().add(listSourceResources, null);
        panelSingleBusCompDocSourceBinContainer.add(scrollPaneBinaryResources, null);
        scrollPaneBinaryResources.getViewport().add(listBinaryResources, null);
        panelSingleBusCompDocSourceBinContainer.add(scrollPaneDocResources, null);
        scrollPaneDocResources.getViewport().add(listDocResources, null);
        this.add(empty1, BorderLayout.SOUTH);
        this.add(empty2, BorderLayout.WEST);
        this.add(empty3, BorderLayout.EAST);
        this.add(empty4, BorderLayout.NORTH);
    }

	/**
	 * Inizia il down dei componenti selezionati
	 */
	void StartDownloads(PolitellaFrame pFrame)   {
		Vector busModCompInfos=new Vector();

	    int[] arrayOfSelectIndex = null;
		Object[] arrayOfSelectRes=null;
	    String[] list = null;
		Vector vectorOfInfos=null;

		 // nel Vector metto nell'ordine:
		 // - Short busModCompID
		 // - Vector vectorOfInfos // (i campi sono tanti quanti gli elementi della lista a cui appartiene,
									//tutti null tranne quello in cui nella lista si trova il file che
									//voglio scaricare, in quel campo riporto il nome)
		 // - String busCompElementType
		if(this.listSourceResources.getSelectedIndex()!=-1)   {
		    arrayOfSelectIndex = this.listSourceResources.getSelectedIndices();
			arrayOfSelectRes=this.listSourceResources.getSelectedValues();
		    list = new String[arrayOfSelectRes.length];
			for(int i=0;i<arrayOfSelectRes.length;i++)    {
				list[i]=(String)arrayOfSelectRes[i];
			}

			for(int i=0;i<list.length;i++)  {
				if(list[i].lastIndexOf('@')!=-1)    {
					//il file in questione non  ancora stato scaricato
					busModCompInfos.add(new Short(this.curr.GetBusModCompID()));

					vectorOfInfos = new Vector(this.listSourceResources.getModel().getSize());
					for(int y=0;y<vectorOfInfos.capacity();y++)
						vectorOfInfos.add(null);
					vectorOfInfos.remove(arrayOfSelectIndex[i]);
					vectorOfInfos.add(arrayOfSelectIndex[i],arrayOfSelectRes[i]);
   		    		busModCompInfos.add(vectorOfInfos);

					busModCompInfos.add(new String("SOURCE"));
					pFrame.userInterface.NewDownloadComponentElement(pFrame.currentPrjViewing.GetPrjID().longValue(),busModCompInfos);
				    busModCompInfos.clear();
				}
			}
		}

		if(this.listBinaryResources.getSelectedIndex()!=-1)   {
		    arrayOfSelectIndex = this.listBinaryResources.getSelectedIndices();
			arrayOfSelectRes=this.listBinaryResources.getSelectedValues();
		    list = new String[arrayOfSelectRes.length];
			for(int i=0;i<arrayOfSelectRes.length;i++)    {
				list[i]=(String)arrayOfSelectRes[i];
			}

			for(int i=0;i<list.length;i++)  {
				if(list[i].lastIndexOf('@')!=-1)    {
					//il file in questione non  ancora stato scaricato
					busModCompInfos.add(new Short(this.curr.GetBusModCompID()));

					vectorOfInfos = new Vector(this.listBinaryResources.getModel().getSize());
					for(int y=0;y<vectorOfInfos.capacity();y++)
						vectorOfInfos.add(null);
					vectorOfInfos.remove(arrayOfSelectIndex[i]);
					vectorOfInfos.add(arrayOfSelectIndex[i],arrayOfSelectRes[i]);
   		    		busModCompInfos.add(vectorOfInfos);

					busModCompInfos.add(new String("BINARY"));
					pFrame.userInterface.NewDownloadComponentElement(pFrame.currentPrjViewing.GetPrjID().longValue(),busModCompInfos);
				    busModCompInfos.clear();
				}
			}
		}

		if(this.listDocResources.getSelectedIndex()!=-1)   {
		    arrayOfSelectIndex = this.listDocResources.getSelectedIndices();
			arrayOfSelectRes=this.listDocResources.getSelectedValues();
		    list = new String[arrayOfSelectRes.length];
			for(int i=0;i<arrayOfSelectRes.length;i++)    {
				list[i]=(String)arrayOfSelectRes[i];
			}

			for(int i=0;i<list.length;i++)  {
				if(list[i].lastIndexOf('@')!=-1)    {
	    			//il file in questione non  ancora stato scaricato
		    		busModCompInfos.add(new Short(this.curr.GetBusModCompID()));

					vectorOfInfos = new Vector(this.listDocResources.getModel().getSize());
					for(int y=0;y<vectorOfInfos.capacity();y++)
						vectorOfInfos.add(null);
					vectorOfInfos.remove(arrayOfSelectIndex[i]);
					vectorOfInfos.add(arrayOfSelectIndex[i],arrayOfSelectRes[i]);
   		    		busModCompInfos.add(vectorOfInfos);

					busModCompInfos.add(new String("DOCUMENTATION"));
					pFrame.userInterface.NewDownloadComponentElement(pFrame.currentPrjViewing.GetPrjID().longValue(),busModCompInfos);
				    busModCompInfos.clear();
				}
			}
		}

		//avvio il download per ogni gruppo di risorse
		for(int i=this.tabbedPaneSingleBusCompResources.getTabCount();i>0;i--)
		    ((ChoiceBusModCompResourcesToDownloadPanel)this.tabbedPaneSingleBusCompResources.getComponentAt(i-1)).StartDownloads(pFrame);

	}

}