/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Interfaccia;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * Gestisce la finestra di dialogo di attesa per morte di tutte le connessioni attive.
 * Viene avviata quando un peer vuole chiudere l'applicativo mentre ha delle connessioni attive
 */
class WaitAllThreadDeathDialog extends JDialog {

	Timer timer=null;
    BorderLayout layoutRoot = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    JProgressBar progressBarWaitingIndicator = new JProgressBar();
    JLabel labelMessageWaiting = new JLabel();
    JLabel labelWithWaitIcon = new JLabel();
    JLabel empty1 = new JLabel();
    JLabel empty2 = new JLabel();
    JLabel empty3 = new JLabel();
    JLabel empty4 = new JLabel();
    BorderLayout borderLayout2 = new BorderLayout();

	public WaitAllThreadDeathDialog(PolitellaFrame pFrame) {
		super(pFrame);
        try {
			jbInit();
			pack();

	        //Center the window
		    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	        Dimension frameSize = this.getSize();
            if (frameSize.height > screenSize.height) {
                frameSize.height = screenSize.height;
	        }
			if (frameSize.width > screenSize.width) {
                frameSize.width = screenSize.width;
            }
            this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);

			timer= new Timer(500,null);
			timer.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    timer_actionPerformed(e);
	            }
            });
		    timer.start();

			setVisible(true);
        }catch(Exception ex) {
			ex.printStackTrace();
        }
    }

	private void timer_actionPerformed(ActionEvent e)   {
		if(this.progressBarWaitingIndicator.getValue()!=this.progressBarWaitingIndicator.getMaximum())  {
			this.progressBarWaitingIndicator.setValue(5+this.progressBarWaitingIndicator.getValue());
		}
		else    {
			this.dispose();
			this.timer.stop();
		}
	}

    void jbInit() throws Exception {
        this.getContentPane().setLayout(layoutRoot);
        this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        this.setResizable(false);
        this.setModal(true);
        this.setTitle("Wait");
        progressBarWaitingIndicator.setBorder(BorderFactory.createLoweredBevelBorder());
        progressBarWaitingIndicator.setDoubleBuffered(true);
        progressBarWaitingIndicator.setMaximumSize(new Dimension(200, 24));
        progressBarWaitingIndicator.setMinimumSize(new Dimension(200, 24));
        progressBarWaitingIndicator.setPreferredSize(new Dimension(200, 24));
        progressBarWaitingIndicator.setToolTipText("");
        progressBarWaitingIndicator.setString("");
        progressBarWaitingIndicator.setStringPainted(true);
        labelMessageWaiting.setDoubleBuffered(true);
        labelMessageWaiting.setHorizontalAlignment(SwingConstants.CENTER);
        labelMessageWaiting.setText("Please wait for all threads closing");
        labelWithWaitIcon.setDoubleBuffered(true);
        labelWithWaitIcon.setIcon(new ImageIcon("Interfaccia/Icons/Disconnect.gif"));
        jPanel1.setLayout(borderLayout2);
        layoutRoot.setHgap(10);
        layoutRoot.setVgap(10);
        borderLayout2.setHgap(10);
        borderLayout2.setVgap(10);
        jPanel1.setMaximumSize(new Dimension(185, 51));
        jPanel1.setMinimumSize(new Dimension(185, 51));
        this.getContentPane().add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(labelWithWaitIcon, BorderLayout.WEST);
        jPanel1.add(labelMessageWaiting, BorderLayout.NORTH);
        jPanel1.add(progressBarWaitingIndicator, BorderLayout.CENTER);
        this.getContentPane().add(empty1, BorderLayout.SOUTH);
        this.getContentPane().add(empty2, BorderLayout.WEST);
        this.getContentPane().add(empty3, BorderLayout.EAST);
        this.getContentPane().add(empty4, BorderLayout.NORTH);
    }
}