/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Network;

import javax.swing.Timer;
import java.awt.event.ActionEvent;

/**
   Cache locale con gestione degli elementi a timeout in cui sono memorizzati
   tutti i messaggi inviati da un peer
 */
final class MessageRif {
    /**
       Permette di identificare in modo univoco un messaggio memorizzato nella cache.
     */
    private long uniqueID;

    /**
       Identifica il tipo di messaggio memorizzato
     */
    private short type;
    /**
       Indirizzo IP del peer mittente
     */
    private String iPSource = "127.0.0.1";
	/**
	 * Riferimento al NetworkManager, necessario per eliminare in automatico
	 * i messaggi vecchi
	 */
	static NetworkManager networkManager=null;
	/**
	 * Timer di scadenza della validit di un messaggio archiviato
	 */
	 Timer timer=new Timer(1000*60,null);
//	 Timer timer=new Timer(1000*10,null);

	 /**
       Costruttore
     */
    MessageRif(long uniqueID, short type, String iPSource) {
		this.uniqueID=uniqueID;
		this.type=type;
		this.iPSource=iPSource;
        this.timer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                    timer_actionPerformed(e);
            }
        });
		this.timer.start();
    }

    /**
     * Metodo attivato allo scattare del timer.
	 * Il riferimento al messaggio non  pi valido, posso cancellarlo
     */
     private void timer_actionPerformed(ActionEvent e)   {
        this.timer.stop();
        this.networkManager.DelMsgInCache(this);
     }
    /**
       Restituisce il valore del campo uniqueID.
       @roseuid 3AED37B7014D
     */
    public long GetUniqueID() {
		return this.uniqueID;
    }

    /**
       Restituisce il valore del campo type.
       @roseuid 3AED37BE025C
     */
    public short GetType() {
		return this.type;
    }

    /**
       Restituisce il valore del campo iPSource.
       @roseuid 3AED37C500E9
     */
    public String GetIPSource() {
		return this.iPSource;
    }

}
