/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
//package Protocollo;
package Network.Protocol;

/**
   Messaggio di richiesta conessione.
 */
public final class Connect extends Header{
    /**
       Specifica quale sia il protocollo supportato dal peer
     */
    private final static String PROTOCOL = "Politella";
    /**
       Specifica la versione del protocollo supportato dal peer
     */
    private final static String VERSION = "1.0";
 /**
  * Specifica il protocollo supportato dal peer che ha generato
  * questo oggetto (pu essere diverso dal corrispondenete campo
  * costante nel caso in cui venga generato in lettura deserializzante
  * da un socket)
  */
 private String protocol = null;
 /**
  * Specifica la versione del protocollo supportato dal peer che
  * ha generato questo oggetto (pu essere diverso dal corrispondenete
  * campo costante nel caso in cui venga generato in lettura
  * deserializzante da un socket)
  */
 private String version = null;

 /**
       Costruttore
       @roseuid 3AED5A3E01CF
     */

	public Connect(String iPSource, short TTL) {
		super(Header.CONNECT);// imposta uniqueID e type
		this.TTL=TTL;
		this.iPSource=iPSource;
		this.protocol= Connect.PROTOCOL;
		this.version= Connect.VERSION;
		//il campo portSource  impostato di default a 5000
    }

	/**
       Restituisce il valore del campo protocol
       @roseuid 3AEACF0C0377
     */
    public static String GetProtocol() {
		return Connect.PROTOCOL;
    }

    /**
       Restituisce il valore del campo version
       @roseuid 3AEACF1700D3
     */
    public static String GetVersion() {
		return Connect.VERSION;
    }

    /**
       Metodo di tipo static che verifica  il protocollo del messaggio CONNECT appena ricevuto con il protocollo supportato localmente.
       @roseuid 3AED5F080182
     */
    public static boolean CheckProtocol(Connect connect) {
		if(Connect.PROTOCOL.compareTo(connect.protocol)==0)
		   return true;
		return false;
    }

    /**
       Metodo di tipo static che verifica  la versione del messaggio CONNECT appena ricevuto con la versioni supportata localmente.
     */
    public static boolean CheckVersion(Connect connect) {
		if(Connect.VERSION.compareTo(connect.version)==0)
		   return true;
		return false;
    }
}
