/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
//package Protocollo;
package Network.Protocol;

/**
   Risposta alla richiesta di connessione ricevuta.
 */
public final class ConnectReply extends Header {
    /**
       Identifica la risposta fornita:
       - OK: connessione accettata;
       - OK_WRONG_VERSION: connessione accattata, ma versione di Politella leggermente diversa, in data c' la versione correttta supportata;
       - NO_TOO_MANY_CONNECTION: connessione rifiutata, troppe connessioni gi attive;
       - NO_WRONG_PROTOCOL_OR_VERSION: connessione rifiutata, protocollo e versione troppo differenti.
     */
    private short answerType;
    /**
       Specifica maggiormente la risposta
     */
    private String data;
    /**
       Connessione accettata;
     */
    public static final short OK = 10;
    /**
       Connessione accattata, ma versione di Politella leggermente diversa, in data c' la versione correttta supportata
     */
    public static final short OK_WRONG_VERSION = 20;
    /**
       Connessione rifiutata, troppe connessioni gi attive
     */
    public static final short NO_TOO_MANY_CONNECTION = 30;
    /**
       Connessione rifiutata, protocollo e versione troppo differenti
     */
    public static final short NO_WRONG_PROTOCOL_OR_VERSION = 40;

	/**
       Costruttore
       @roseuid 3AED6035018F
     */
    public ConnectReply(String iPSource, short TTL, short answerType, String data) {
		super(Header.CONNECT_REPLY);// imposta uniqueID e type
		this.TTL=TTL;
		this.iPSource=iPSource;
		//il campo portSource  impostato di default a 5000
		this.answerType=answerType;
		this.data=data;
    }

    /**
       Restituisce il valore del campo answerType
       @roseuid 3AEAE31903D2
     */
    public short GetAnswerType() {
		return this.answerType;
    }

    /**
       Imposta il valore del campo answerType
       @roseuid 3AEAE33D0243
     */
    protected void SetAnswerType(short answerType) {
		this.answerType=answerType;
    }

    /**
       Imposta il valore del campo data
       @roseuid 3AEAE3A70097
     */
    protected void SetData(String data) {
		this.data=data;
    }

    /**
       Restituisce il valore del campo data
       @roseuid 3AEAE3C80102
     */
    public String GetData() {
		return this.data;
    }
}
