/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
//package Protocollo;
package Network.Protocol;

/**
   Risposta al messaggio di annuncio ricevuto.
 */
public final class Pong extends Header {
    /**
       Specifica il numero di progetti disponibili sul peer
     */
    private long numSharePrj;

    /**
       Costruttore
       @roseuid 3AEDB7DC0064
     */
    public Pong(long uniqueID, String iPSource, short TTL, long numSharePrj) {
		super(Header.PONG);// imposta type
		this.SetUniqueID(uniqueID);
		this.iPSource=iPSource;
		this.TTL=TTL;
		this.numSharePrj=numSharePrj;
    }

    /**
       Imposta il valore del campo numSharePrj
       @roseuid 3AEAE5C500DC
     */
    protected void SetNumSharePrj(long numSharePrj) {
		this.numSharePrj=numSharePrj;
    }

    /**
       Restituisce il valore del campo numSharePrj
       @roseuid 3AEAE5EC001A
     */
    public long GetNumSharePrj() {
		return this.numSharePrj;
    }
}
