/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
//package Protocollo;
package Network.Protocol;

import Utility.ProjectType;

/**
   Messaggio di ricerca di un progetto.
 */
public final class Query extends Header implements ProjectType {
    /**
       Chiave di ricerca
     */
    private String searchKey;

    /**
       Tipologia del progetto cercato
     */
    private short[] projectType;

    /**
       Costruttore
       @roseuid 3AEDC25902A0
     */
    public Query(String iPSource, short TTL, short[] prjType, String searchKey) {
		super(Header.QUERY);// imposta uniqueID e type
		this.iPSource=iPSource;
		this.TTL=TTL;
		this.projectType=prjType;
		this.searchKey=searchKey;
    }
    /**
       Restituisce il valore del campo searchKey
       @roseuid 3AEAE6F701A4
     */
    public String GetSearchKey() {
		return this.searchKey;
    }

    /**
       Imposta il valore del campo SearchKey
       @roseuid 3AEAE72400CD
     */
    protected void SetSearchKey(String searchKey) {
		this.searchKey=searchKey;
    }

    /**
       Imposta il valore del campo projectType
       @roseuid 3AEC2D8E0123
     */
    public void SetProjectType(short[] projectType) {
		this.projectType=projectType;
    }

    /**
       Restituisce il valore del campo projectType
       @roseuid 3AEC2D8E014B
     */
    public short[] GetProjectType() {
		return this.projectType;
    }
}
