/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Project;

import java.io.Serializable;

/**
   Elemento del db contenente i progetti trovati in una precedente ricerca
 */
final class ProjectFound implements Serializable {
    /**
       Specifica il peer su cui si trova questo specifico progetto
     */
    private String projectPeerLocation = null;
    /**
       Identificato del progetto, univoco solamente all'interno del peer su cui risiede
     */
    private long projectID;
    /**
       Tipologia del progetto
     */
    private short[] projectType;
    /**
       Descrizione completa del progetto.
     */
    private String projectDescr = null;
    /**
       Costruttore
       @roseuid 3AF911C201A0
     */
    ProjectFound(long projectID, short[] projectType, String projectDescr, String projectPeerLocation) {
		this.projectID=projectID;
		this.projectType=projectType;
		this.projectDescr=projectDescr;
		this.projectPeerLocation=projectPeerLocation;
    }

    /**
       Restituisce il valore del campo projectType
       @roseuid 3B01080702E0
     */
    public short[] GetProjectType() {
		return this.projectType;
    }

    /**
       Restituisce il valore del campo projectID
       @roseuid 3B01080702F4
     */
    public long GetProjectID() {
		return this.projectID;
    }

    /**
       Restituisce il valore del campo projectDescr
       @roseuid 3B0108070308
     */
    public String GetProjectDescr() {
		return this.projectDescr;
    }

    /**
       @roseuid 3B011D1C0236
     */
    public String GetProjectPeerLocation() {
		return this.projectPeerLocation;
    }
}
