/*
*                            Copyright (c) 2001
*                        <B>Politecnico di Torino</B>
*                            All Rights Reserved
* <p>
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that: (1) source code distributions
* retain the above copyright notice and this paragraph in its entirety,(2)
* distributions including binary code include the above copyright notice and
* this paragraph in its entirety in the documentation or other materials
* provided with the distribution, and (3) all advertising materials mentioning
* features or use of this software display the following acknowledgement:
* ``This product includes software developed by Politecnico
* di Torino, and its contributors.'' (4) Neither the name of
* the University nor the names of its contributors may be used to endorse
* or promote products derived from this software without specific prior
* written permission.
* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* This product includes code licensed from RSA Data Security (Java Secure Socket Extension)
*
* Sun grants you ("Licensee") a non-exclusive, royalty free, license to use, and redistribute
* this software graphics artwork, as individual graphics or as a collection, as part of
* software code or programs that you develop, provided that
* i) this copyright notice and license accompany the software graphics artwork; and
* ii) you do not utilize the software graphics artwork in a manner which is disparaging to Sun.
* Unless enforcement is prohibited by applicable law, you may not modify the graphics,
* and must use them true to color and unmodified in every way.
*
*<p>
*/
package Utility;

/**
 * Definisce tutte le chiavi con sui si possono ricercare dei progetti
 */
public interface ProjectType {
	/**
	 * Specifica da quanti Business Role  composto il business model
	 */
	 public static final short numBusinessRole = 4;
	/**
	 * Specifica da quante Business Relationship  composto il business model
	 */
	 public static final short numBusinessRelationship = 13;
    /**
	 * 	Tipologia di ricerca generica
	 */
	// Ricerca per Modelli Commerciali
	public static final short COMMERCIAL_MODEL_ANY = -1;

	public static final short COMMERCIAL_MODEL_GAMES = 0;
	public static final short COMMERCIAL_MODEL_HOME_EDUCATION = 1;
	public static final short COMMERCIAL_MODEL_MULTIMEDIA = 2;
	public static final short COMMERCIAL_MODEL_NETWORK_INTERNET = 3;
	public static final short COMMERCIAL_MODEL_OFFICE_BUSINESS = 4;
	public static final short COMMERCIAL_MODEL_SOFTWARE_DEVELOPMENT = 5;
	public static final short COMMERCIAL_MODEL_SYSTEM_UTILITIES = 6;
	public static final short COMMERCIAL_MODEL_OTHER = 7;

	// Ricerca per Modelli Architetturali
	public static final short ARCHITECTURAL_MODEL_ANY = -1;

	public static final short ARCHITECTURAL_MODEL_1TIER = 0;
	public static final short ARCHITECTURAL_MODEL_2TIER = 1;
	public static final short ARCHITECTURAL_MODEL_3TIER = 2;
	public static final short ARCHITECTURAL_MODEL_4TIER = 3;
	public static final short ARCHITECTURAL_MODEL_MORETIER = 4;

	// Ricerca per Business Model
	public static final short BUSINESS_MODEL_COMPONENT_ANY = -1;

	public static final short BUSINESS_MODEL_ROLE_CONSUMER = 0;
	public static final short BUSINESS_MODEL_ROLE_SERVICE_CONTENT_PROVIDER = 1;
	public static final short BUSINESS_MODEL_ROLE_BROKER = 2;
	public static final short BUSINESS_MODEL_ROLE_CONNECTIVITY_PROVIDER = 3;

	public static final short BUSINESS_MODEL_RELATIONSHIP_BROKERAGE_CONSUMER = 4;
	public static final short BUSINESS_MODEL_RELATIONSHIP_BROKERAGE_SERV_CONT_PROVIDER = 5;
	public static final short BUSINESS_MODEL_RELATIONSHIP_BROKERAGE_CONNECTIVITY_PROVIDER = 6;
	public static final short BUSINESS_MODEL_RELATIONSHIP_BROKERAGE_BROKER = 7;
	public static final short BUSINESS_MODEL_RELATIONSHIP_SERVICE_USAGE_SERV_CONT_PROV = 8;
	public static final short BUSINESS_MODEL_RELATIONSHIP_ACCESS_MANAGEMENT = 9;
	public static final short BUSINESS_MODEL_RELATIONSHIP_3rdPARTY_SERVICE_PROVISIONING = 10;
	public static final short BUSINESS_MODEL_RELATIONSHIP_USAGE_NET_SERVICES_SERV_CONT_PROVIDER = 11;
	public static final short BUSINESS_MODEL_RELATIONSHIP_USAGE_NET_SERVICES_CONSUMER = 12;
	public static final short BUSINESS_MODEL_RELATIONSHIP_SERVICE_USAGE_CONNECTIVITY_PROV = 13;
	public static final short BUSINESS_MODEL_RELATIONSHIP_USAGE_NET_SERVICES_CONNECTIVITY_PROVIDER = 14;
	//questi 2 non sono vere relationship, ma servono per i 2 lacci del bus. mod.
	public static final short BUSINESS_MODEL_RELATIONSHIP_BROKERAGE_BROKER_BIS = 15;
	public static final short BUSINESS_MODEL_RELATIONSHIP_USAGE_NET_SERVICES_CONNECTIVITY_PROVIDER_BIS = 16;
	/**
	 * Descrizione delle tipoligie di progetti supportati
	 */
	public static final String[][] prjTypeDescription={{"Any","Games","Home & Education Tools","Multimedia Tools","Network & Internet Tools","Office & Business Tools","Software Development Tools","System & Utilities Tools","Other Tools"},
														{"Any","1-Tier","2-Tiers","3-Tiers","4-Tiers","More-Tiers"},
														{"Any Business Role","Consumer","Service-Content Provider","Broker","Connectivity Provider","Any Business Relationship","Brokerage (Consumer)","Brokerage (S.-C.Provider)","Brokerage (Conn.Provider)","Brokerage (Broker)(Start)","Service Usage (S.C.Provider)","Access Management","3rd Party Service Provisioning","Usage of Net.Services (S./C.Provider)","Usage of Net.Services (Consumer)","Service Usage (Conn.Provider)","Usage of Net.Services (Conn.Provider)(Start)","Brokerage (Broker)(End)","Usage of Net.Services (Conn.Provider)(End)"}};
    /**
       Imposta il valore del campo projectType
       @roseuid 3AEAEA570098
     */
    public void SetProjectType(short[] projectType);

    /**
       Restituisce il valore del campo projectType
       @roseuid 3AEAEB3302D0
     */
    public short[] GetProjectType();
}
